/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { BundleDataOptionInterface } from '../model/bundleDataOptionInterface';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class BundleProductOptionRepositoryV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Remove bundle option
     * @param sku 
     * @param optionId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public bundleProductOptionRepositoryV1DeleteByIdDelete(sku: string, optionId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public bundleProductOptionRepositoryV1DeleteByIdDelete(sku: string, optionId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public bundleProductOptionRepositoryV1DeleteByIdDelete(sku: string, optionId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public bundleProductOptionRepositoryV1DeleteByIdDelete(sku: string, optionId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling bundleProductOptionRepositoryV1DeleteByIdDelete.');
        }
        if (optionId === null || optionId === undefined) {
            throw new Error('Required parameter optionId was null or undefined when calling bundleProductOptionRepositoryV1DeleteByIdDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/bundle-products/${encodeURIComponent(String(sku))}/options/${encodeURIComponent(String(optionId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get option for bundle product
     * @param sku 
     * @param optionId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public bundleProductOptionRepositoryV1GetGet(sku: string, optionId: number, observe?: 'body', reportProgress?: boolean): Observable<BundleDataOptionInterface>;
    public bundleProductOptionRepositoryV1GetGet(sku: string, optionId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BundleDataOptionInterface>>;
    public bundleProductOptionRepositoryV1GetGet(sku: string, optionId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BundleDataOptionInterface>>;
    public bundleProductOptionRepositoryV1GetGet(sku: string, optionId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling bundleProductOptionRepositoryV1GetGet.');
        }
        if (optionId === null || optionId === undefined) {
            throw new Error('Required parameter optionId was null or undefined when calling bundleProductOptionRepositoryV1GetGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<BundleDataOptionInterface>(`${this.basePath}/V1/bundle-products/${encodeURIComponent(String(sku))}/options/${encodeURIComponent(String(optionId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get all options for bundle product
     * @param sku 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public bundleProductOptionRepositoryV1GetListGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<BundleDataOptionInterface>>;
    public bundleProductOptionRepositoryV1GetListGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<BundleDataOptionInterface>>>;
    public bundleProductOptionRepositoryV1GetListGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<BundleDataOptionInterface>>>;
    public bundleProductOptionRepositoryV1GetListGet(sku: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling bundleProductOptionRepositoryV1GetListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<BundleDataOptionInterface>>(`${this.basePath}/V1/bundle-products/${encodeURIComponent(String(sku))}/options/all`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
