/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogAttributeSetManagementV1CreatePostBody } from '../model/catalogAttributeSetManagementV1CreatePostBody';
import { EavDataAttributeSetInterface } from '../model/eavDataAttributeSetInterface';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CatalogAttributeSetManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Create attribute set from data
     * @param catalogAttributeSetManagementV1CreatePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogAttributeSetManagementV1CreatePost(catalogAttributeSetManagementV1CreatePostBody?: CatalogAttributeSetManagementV1CreatePostBody, observe?: 'body', reportProgress?: boolean): Observable<EavDataAttributeSetInterface>;
    public catalogAttributeSetManagementV1CreatePost(catalogAttributeSetManagementV1CreatePostBody?: CatalogAttributeSetManagementV1CreatePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EavDataAttributeSetInterface>>;
    public catalogAttributeSetManagementV1CreatePost(catalogAttributeSetManagementV1CreatePostBody?: CatalogAttributeSetManagementV1CreatePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EavDataAttributeSetInterface>>;
    public catalogAttributeSetManagementV1CreatePost(catalogAttributeSetManagementV1CreatePostBody?: CatalogAttributeSetManagementV1CreatePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<EavDataAttributeSetInterface>(`${this.basePath}/V1/products/attribute-sets`,
            catalogAttributeSetManagementV1CreatePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
