/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogCategoryLinkRepositoryV1SavePostBody } from '../model/catalogCategoryLinkRepositoryV1SavePostBody';
import { CatalogCategoryLinkRepositoryV1SavePutBody } from '../model/catalogCategoryLinkRepositoryV1SavePutBody';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CatalogCategoryLinkRepositoryV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Remove the product assignment from the category by category id and sku
     * @param categoryId 
     * @param sku 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogCategoryLinkRepositoryV1DeleteByIdsDelete(categoryId: string, sku: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogCategoryLinkRepositoryV1DeleteByIdsDelete(categoryId: string, sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogCategoryLinkRepositoryV1DeleteByIdsDelete(categoryId: string, sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogCategoryLinkRepositoryV1DeleteByIdsDelete(categoryId: string, sku: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (categoryId === null || categoryId === undefined) {
            throw new Error('Required parameter categoryId was null or undefined when calling catalogCategoryLinkRepositoryV1DeleteByIdsDelete.');
        }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogCategoryLinkRepositoryV1DeleteByIdsDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/categories/${encodeURIComponent(String(categoryId))}/products/${encodeURIComponent(String(sku))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Assign a product to the required category
     * @param categoryId 
     * @param catalogCategoryLinkRepositoryV1SavePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogCategoryLinkRepositoryV1SavePost(categoryId: string, catalogCategoryLinkRepositoryV1SavePostBody?: CatalogCategoryLinkRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogCategoryLinkRepositoryV1SavePost(categoryId: string, catalogCategoryLinkRepositoryV1SavePostBody?: CatalogCategoryLinkRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogCategoryLinkRepositoryV1SavePost(categoryId: string, catalogCategoryLinkRepositoryV1SavePostBody?: CatalogCategoryLinkRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogCategoryLinkRepositoryV1SavePost(categoryId: string, catalogCategoryLinkRepositoryV1SavePostBody?: CatalogCategoryLinkRepositoryV1SavePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (categoryId === null || categoryId === undefined) {
            throw new Error('Required parameter categoryId was null or undefined when calling catalogCategoryLinkRepositoryV1SavePost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<boolean>(`${this.basePath}/V1/categories/${encodeURIComponent(String(categoryId))}/products`,
            catalogCategoryLinkRepositoryV1SavePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Assign a product to the required category
     * @param categoryId 
     * @param catalogCategoryLinkRepositoryV1SavePutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogCategoryLinkRepositoryV1SavePut(categoryId: string, catalogCategoryLinkRepositoryV1SavePutBody?: CatalogCategoryLinkRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogCategoryLinkRepositoryV1SavePut(categoryId: string, catalogCategoryLinkRepositoryV1SavePutBody?: CatalogCategoryLinkRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogCategoryLinkRepositoryV1SavePut(categoryId: string, catalogCategoryLinkRepositoryV1SavePutBody?: CatalogCategoryLinkRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogCategoryLinkRepositoryV1SavePut(categoryId: string, catalogCategoryLinkRepositoryV1SavePutBody?: CatalogCategoryLinkRepositoryV1SavePutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (categoryId === null || categoryId === undefined) {
            throw new Error('Required parameter categoryId was null or undefined when calling catalogCategoryLinkRepositoryV1SavePut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<boolean>(`${this.basePath}/V1/categories/${encodeURIComponent(String(categoryId))}/products`,
            catalogCategoryLinkRepositoryV1SavePutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
