/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogCategoryRepositoryV1SavePostBody } from '../model/catalogCategoryRepositoryV1SavePostBody';
import { CatalogCategoryRepositoryV1SavePutBody } from '../model/catalogCategoryRepositoryV1SavePutBody';
import { CatalogDataCategoryInterface } from '../model/catalogDataCategoryInterface';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CatalogCategoryRepositoryV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Delete category by identifier
     * @param categoryId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogCategoryRepositoryV1DeleteByIdentifierDelete(categoryId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogCategoryRepositoryV1DeleteByIdentifierDelete(categoryId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogCategoryRepositoryV1DeleteByIdentifierDelete(categoryId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogCategoryRepositoryV1DeleteByIdentifierDelete(categoryId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (categoryId === null || categoryId === undefined) {
            throw new Error('Required parameter categoryId was null or undefined when calling catalogCategoryRepositoryV1DeleteByIdentifierDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/categories/${encodeURIComponent(String(categoryId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get info about category by category id
     * @param categoryId 
     * @param storeId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogCategoryRepositoryV1GetGet(categoryId: number, storeId?: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataCategoryInterface>;
    public catalogCategoryRepositoryV1GetGet(categoryId: number, storeId?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataCategoryInterface>>;
    public catalogCategoryRepositoryV1GetGet(categoryId: number, storeId?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataCategoryInterface>>;
    public catalogCategoryRepositoryV1GetGet(categoryId: number, storeId?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (categoryId === null || categoryId === undefined) {
            throw new Error('Required parameter categoryId was null or undefined when calling catalogCategoryRepositoryV1GetGet.');
        }

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (storeId !== undefined) {
            queryParameters = queryParameters.set('storeId', <any>storeId);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<CatalogDataCategoryInterface>(`${this.basePath}/V1/categories/${encodeURIComponent(String(categoryId))}`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Create category service
     * @param catalogCategoryRepositoryV1SavePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogCategoryRepositoryV1SavePost(catalogCategoryRepositoryV1SavePostBody?: CatalogCategoryRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataCategoryInterface>;
    public catalogCategoryRepositoryV1SavePost(catalogCategoryRepositoryV1SavePostBody?: CatalogCategoryRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataCategoryInterface>>;
    public catalogCategoryRepositoryV1SavePost(catalogCategoryRepositoryV1SavePostBody?: CatalogCategoryRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataCategoryInterface>>;
    public catalogCategoryRepositoryV1SavePost(catalogCategoryRepositoryV1SavePostBody?: CatalogCategoryRepositoryV1SavePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<CatalogDataCategoryInterface>(`${this.basePath}/V1/categories`,
            catalogCategoryRepositoryV1SavePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Create category service
     * @param id 
     * @param catalogCategoryRepositoryV1SavePutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogCategoryRepositoryV1SavePut(id: string, catalogCategoryRepositoryV1SavePutBody?: CatalogCategoryRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataCategoryInterface>;
    public catalogCategoryRepositoryV1SavePut(id: string, catalogCategoryRepositoryV1SavePutBody?: CatalogCategoryRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataCategoryInterface>>;
    public catalogCategoryRepositoryV1SavePut(id: string, catalogCategoryRepositoryV1SavePutBody?: CatalogCategoryRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataCategoryInterface>>;
    public catalogCategoryRepositoryV1SavePut(id: string, catalogCategoryRepositoryV1SavePutBody?: CatalogCategoryRepositoryV1SavePutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling catalogCategoryRepositoryV1SavePut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<CatalogDataCategoryInterface>(`${this.basePath}/V1/categories/${encodeURIComponent(String(id))}`,
            catalogCategoryRepositoryV1SavePutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
