/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogCostStorageV1DeletePostBody } from '../model/catalogCostStorageV1DeletePostBody';
import { CatalogCostStorageV1GetPostBody } from '../model/catalogCostStorageV1GetPostBody';
import { CatalogCostStorageV1UpdatePostBody } from '../model/catalogCostStorageV1UpdatePostBody';
import { CatalogDataCostInterface } from '../model/catalogDataCostInterface';
import { CatalogDataPriceUpdateResultInterface } from '../model/catalogDataPriceUpdateResultInterface';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CatalogCostStorageV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Delete product cost. In case of at least one of skus is not found exception will be thrown. If error occurred during the delete exception will be thrown.
     * @param catalogCostStorageV1DeletePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogCostStorageV1DeletePost(catalogCostStorageV1DeletePostBody?: CatalogCostStorageV1DeletePostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogCostStorageV1DeletePost(catalogCostStorageV1DeletePostBody?: CatalogCostStorageV1DeletePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogCostStorageV1DeletePost(catalogCostStorageV1DeletePostBody?: CatalogCostStorageV1DeletePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogCostStorageV1DeletePost(catalogCostStorageV1DeletePostBody?: CatalogCostStorageV1DeletePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<boolean>(`${this.basePath}/V1/products/cost-delete`,
            catalogCostStorageV1DeletePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Return product prices. In case of at least one of skus is not found exception will be thrown.
     * @param catalogCostStorageV1GetPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogCostStorageV1GetPost(catalogCostStorageV1GetPostBody?: CatalogCostStorageV1GetPostBody, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataCostInterface>>;
    public catalogCostStorageV1GetPost(catalogCostStorageV1GetPostBody?: CatalogCostStorageV1GetPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataCostInterface>>>;
    public catalogCostStorageV1GetPost(catalogCostStorageV1GetPostBody?: CatalogCostStorageV1GetPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataCostInterface>>>;
    public catalogCostStorageV1GetPost(catalogCostStorageV1GetPostBody?: CatalogCostStorageV1GetPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<Array<CatalogDataCostInterface>>(`${this.basePath}/V1/products/cost-information`,
            catalogCostStorageV1GetPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Add or update product cost. Input item should correspond to \\Magento\\Catalog\\Api\\Data\\CostInterface. If any items will have invalid cost, store id or sku, they will be marked as failed and excluded from update list and \\Magento\\Catalog\\Api\\Data\\PriceUpdateResultInterface[] with problem description will be returned. If there were no failed items during update empty array will be returned. If error occurred during the update exception will be thrown.
     * @param catalogCostStorageV1UpdatePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogCostStorageV1UpdatePost(catalogCostStorageV1UpdatePostBody?: CatalogCostStorageV1UpdatePostBody, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataPriceUpdateResultInterface>>;
    public catalogCostStorageV1UpdatePost(catalogCostStorageV1UpdatePostBody?: CatalogCostStorageV1UpdatePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataPriceUpdateResultInterface>>>;
    public catalogCostStorageV1UpdatePost(catalogCostStorageV1UpdatePostBody?: CatalogCostStorageV1UpdatePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataPriceUpdateResultInterface>>>;
    public catalogCostStorageV1UpdatePost(catalogCostStorageV1UpdatePostBody?: CatalogCostStorageV1UpdatePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<Array<CatalogDataPriceUpdateResultInterface>>(`${this.basePath}/V1/products/cost`,
            catalogCostStorageV1UpdatePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
