/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogDataProductAttributeInterface } from '../model/catalogDataProductAttributeInterface';
import { CatalogProductAttributeManagementV1AssignPostBody } from '../model/catalogProductAttributeManagementV1AssignPostBody';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CatalogProductAttributeManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Assign attribute to attribute set
     * @param catalogProductAttributeManagementV1AssignPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductAttributeManagementV1AssignPost(catalogProductAttributeManagementV1AssignPostBody?: CatalogProductAttributeManagementV1AssignPostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public catalogProductAttributeManagementV1AssignPost(catalogProductAttributeManagementV1AssignPostBody?: CatalogProductAttributeManagementV1AssignPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public catalogProductAttributeManagementV1AssignPost(catalogProductAttributeManagementV1AssignPostBody?: CatalogProductAttributeManagementV1AssignPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public catalogProductAttributeManagementV1AssignPost(catalogProductAttributeManagementV1AssignPostBody?: CatalogProductAttributeManagementV1AssignPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<number>(`${this.basePath}/V1/products/attribute-sets/attributes`,
            catalogProductAttributeManagementV1AssignPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Retrieve related attributes based on given attribute set ID
     * @param attributeSetId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductAttributeManagementV1GetAttributesGet(attributeSetId: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductAttributeInterface>>;
    public catalogProductAttributeManagementV1GetAttributesGet(attributeSetId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductAttributeInterface>>>;
    public catalogProductAttributeManagementV1GetAttributesGet(attributeSetId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductAttributeInterface>>>;
    public catalogProductAttributeManagementV1GetAttributesGet(attributeSetId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (attributeSetId === null || attributeSetId === undefined) {
            throw new Error('Required parameter attributeSetId was null or undefined when calling catalogProductAttributeManagementV1GetAttributesGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<CatalogDataProductAttributeInterface>>(`${this.basePath}/V1/products/attribute-sets/${encodeURIComponent(String(attributeSetId))}/attributes`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Remove attribute from attribute set
     * @param attributeSetId 
     * @param attributeCode 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductAttributeManagementV1UnassignDelete(attributeSetId: string, attributeCode: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogProductAttributeManagementV1UnassignDelete(attributeSetId: string, attributeCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogProductAttributeManagementV1UnassignDelete(attributeSetId: string, attributeCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogProductAttributeManagementV1UnassignDelete(attributeSetId: string, attributeCode: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (attributeSetId === null || attributeSetId === undefined) {
            throw new Error('Required parameter attributeSetId was null or undefined when calling catalogProductAttributeManagementV1UnassignDelete.');
        }
        if (attributeCode === null || attributeCode === undefined) {
            throw new Error('Required parameter attributeCode was null or undefined when calling catalogProductAttributeManagementV1UnassignDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/products/attribute-sets/${encodeURIComponent(String(attributeSetId))}/attributes/${encodeURIComponent(String(attributeCode))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
