/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogProductAttributeOptionManagementV1AddPostBody } from '../model/catalogProductAttributeOptionManagementV1AddPostBody';
import { EavDataAttributeOptionInterface } from '../model/eavDataAttributeOptionInterface';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CatalogProductAttributeOptionManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Add option to attribute
     * @param attributeCode 
     * @param catalogProductAttributeOptionManagementV1AddPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductAttributeOptionManagementV1AddPost(attributeCode: string, catalogProductAttributeOptionManagementV1AddPostBody?: CatalogProductAttributeOptionManagementV1AddPostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogProductAttributeOptionManagementV1AddPost(attributeCode: string, catalogProductAttributeOptionManagementV1AddPostBody?: CatalogProductAttributeOptionManagementV1AddPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogProductAttributeOptionManagementV1AddPost(attributeCode: string, catalogProductAttributeOptionManagementV1AddPostBody?: CatalogProductAttributeOptionManagementV1AddPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogProductAttributeOptionManagementV1AddPost(attributeCode: string, catalogProductAttributeOptionManagementV1AddPostBody?: CatalogProductAttributeOptionManagementV1AddPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (attributeCode === null || attributeCode === undefined) {
            throw new Error('Required parameter attributeCode was null or undefined when calling catalogProductAttributeOptionManagementV1AddPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<boolean>(`${this.basePath}/V1/products/attributes/${encodeURIComponent(String(attributeCode))}/options`,
            catalogProductAttributeOptionManagementV1AddPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Delete option from attribute
     * @param attributeCode 
     * @param optionId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductAttributeOptionManagementV1DeleteDelete(attributeCode: string, optionId: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogProductAttributeOptionManagementV1DeleteDelete(attributeCode: string, optionId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogProductAttributeOptionManagementV1DeleteDelete(attributeCode: string, optionId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogProductAttributeOptionManagementV1DeleteDelete(attributeCode: string, optionId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (attributeCode === null || attributeCode === undefined) {
            throw new Error('Required parameter attributeCode was null or undefined when calling catalogProductAttributeOptionManagementV1DeleteDelete.');
        }
        if (optionId === null || optionId === undefined) {
            throw new Error('Required parameter optionId was null or undefined when calling catalogProductAttributeOptionManagementV1DeleteDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/products/attributes/${encodeURIComponent(String(attributeCode))}/options/${encodeURIComponent(String(optionId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Retrieve list of attribute options
     * @param attributeCode 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductAttributeOptionManagementV1GetItemsGet(attributeCode: string, observe?: 'body', reportProgress?: boolean): Observable<Array<EavDataAttributeOptionInterface>>;
    public catalogProductAttributeOptionManagementV1GetItemsGet(attributeCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<EavDataAttributeOptionInterface>>>;
    public catalogProductAttributeOptionManagementV1GetItemsGet(attributeCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<EavDataAttributeOptionInterface>>>;
    public catalogProductAttributeOptionManagementV1GetItemsGet(attributeCode: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (attributeCode === null || attributeCode === undefined) {
            throw new Error('Required parameter attributeCode was null or undefined when calling catalogProductAttributeOptionManagementV1GetItemsGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<EavDataAttributeOptionInterface>>(`${this.basePath}/V1/products/attributes/${encodeURIComponent(String(attributeCode))}/options`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
