/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogDataProductCustomOptionInterface } from '../model/catalogDataProductCustomOptionInterface';
import { CatalogProductCustomOptionRepositoryV1SavePostBody } from '../model/catalogProductCustomOptionRepositoryV1SavePostBody';
import { CatalogProductCustomOptionRepositoryV1SavePutBody } from '../model/catalogProductCustomOptionRepositoryV1SavePutBody';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CatalogProductCustomOptionRepositoryV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * 
     * @param sku 
     * @param optionId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductCustomOptionRepositoryV1DeleteByIdentifierDelete(sku: string, optionId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogProductCustomOptionRepositoryV1DeleteByIdentifierDelete(sku: string, optionId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogProductCustomOptionRepositoryV1DeleteByIdentifierDelete(sku: string, optionId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogProductCustomOptionRepositoryV1DeleteByIdentifierDelete(sku: string, optionId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductCustomOptionRepositoryV1DeleteByIdentifierDelete.');
        }
        if (optionId === null || optionId === undefined) {
            throw new Error('Required parameter optionId was null or undefined when calling catalogProductCustomOptionRepositoryV1DeleteByIdentifierDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/products/${encodeURIComponent(String(sku))}/options/${encodeURIComponent(String(optionId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get custom option for a specific product
     * @param sku 
     * @param optionId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductCustomOptionRepositoryV1GetGet(sku: string, optionId: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductCustomOptionInterface>;
    public catalogProductCustomOptionRepositoryV1GetGet(sku: string, optionId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductCustomOptionInterface>>;
    public catalogProductCustomOptionRepositoryV1GetGet(sku: string, optionId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductCustomOptionInterface>>;
    public catalogProductCustomOptionRepositoryV1GetGet(sku: string, optionId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductCustomOptionRepositoryV1GetGet.');
        }
        if (optionId === null || optionId === undefined) {
            throw new Error('Required parameter optionId was null or undefined when calling catalogProductCustomOptionRepositoryV1GetGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<CatalogDataProductCustomOptionInterface>(`${this.basePath}/V1/products/${encodeURIComponent(String(sku))}/options/${encodeURIComponent(String(optionId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get the list of custom options for a specific product
     * @param sku 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductCustomOptionRepositoryV1GetListGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductCustomOptionInterface>>;
    public catalogProductCustomOptionRepositoryV1GetListGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductCustomOptionInterface>>>;
    public catalogProductCustomOptionRepositoryV1GetListGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductCustomOptionInterface>>>;
    public catalogProductCustomOptionRepositoryV1GetListGet(sku: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductCustomOptionRepositoryV1GetListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<CatalogDataProductCustomOptionInterface>>(`${this.basePath}/V1/products/${encodeURIComponent(String(sku))}/options`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Save Custom Option
     * @param catalogProductCustomOptionRepositoryV1SavePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductCustomOptionRepositoryV1SavePost(catalogProductCustomOptionRepositoryV1SavePostBody?: CatalogProductCustomOptionRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductCustomOptionInterface>;
    public catalogProductCustomOptionRepositoryV1SavePost(catalogProductCustomOptionRepositoryV1SavePostBody?: CatalogProductCustomOptionRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductCustomOptionInterface>>;
    public catalogProductCustomOptionRepositoryV1SavePost(catalogProductCustomOptionRepositoryV1SavePostBody?: CatalogProductCustomOptionRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductCustomOptionInterface>>;
    public catalogProductCustomOptionRepositoryV1SavePost(catalogProductCustomOptionRepositoryV1SavePostBody?: CatalogProductCustomOptionRepositoryV1SavePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<CatalogDataProductCustomOptionInterface>(`${this.basePath}/V1/products/options`,
            catalogProductCustomOptionRepositoryV1SavePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Save Custom Option
     * @param optionId 
     * @param catalogProductCustomOptionRepositoryV1SavePutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductCustomOptionRepositoryV1SavePut(optionId: string, catalogProductCustomOptionRepositoryV1SavePutBody?: CatalogProductCustomOptionRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductCustomOptionInterface>;
    public catalogProductCustomOptionRepositoryV1SavePut(optionId: string, catalogProductCustomOptionRepositoryV1SavePutBody?: CatalogProductCustomOptionRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductCustomOptionInterface>>;
    public catalogProductCustomOptionRepositoryV1SavePut(optionId: string, catalogProductCustomOptionRepositoryV1SavePutBody?: CatalogProductCustomOptionRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductCustomOptionInterface>>;
    public catalogProductCustomOptionRepositoryV1SavePut(optionId: string, catalogProductCustomOptionRepositoryV1SavePutBody?: CatalogProductCustomOptionRepositoryV1SavePutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (optionId === null || optionId === undefined) {
            throw new Error('Required parameter optionId was null or undefined when calling catalogProductCustomOptionRepositoryV1SavePut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<CatalogDataProductCustomOptionInterface>(`${this.basePath}/V1/products/options/${encodeURIComponent(String(optionId))}`,
            catalogProductCustomOptionRepositoryV1SavePutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
