/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogDataProductLinkAttributeInterface } from '../model/catalogDataProductLinkAttributeInterface';
import { CatalogDataProductLinkTypeInterface } from '../model/catalogDataProductLinkTypeInterface';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CatalogProductLinkTypeListV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Provide a list of the product link type attributes
     * @param type 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductLinkTypeListV1GetItemAttributesGet(type: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductLinkAttributeInterface>>;
    public catalogProductLinkTypeListV1GetItemAttributesGet(type: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductLinkAttributeInterface>>>;
    public catalogProductLinkTypeListV1GetItemAttributesGet(type: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductLinkAttributeInterface>>>;
    public catalogProductLinkTypeListV1GetItemAttributesGet(type: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (type === null || type === undefined) {
            throw new Error('Required parameter type was null or undefined when calling catalogProductLinkTypeListV1GetItemAttributesGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<CatalogDataProductLinkAttributeInterface>>(`${this.basePath}/V1/products/links/${encodeURIComponent(String(type))}/attributes`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Retrieve information about available product link types
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductLinkTypeListV1GetItemsGet(observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductLinkTypeInterface>>;
    public catalogProductLinkTypeListV1GetItemsGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductLinkTypeInterface>>>;
    public catalogProductLinkTypeListV1GetItemsGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductLinkTypeInterface>>>;
    public catalogProductLinkTypeListV1GetItemsGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<CatalogDataProductLinkTypeInterface>>(`${this.basePath}/V1/products/links/types`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
