/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogDataProductTierPriceInterface } from '../model/catalogDataProductTierPriceInterface';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CatalogProductTierPriceManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Create tier price for product
     * @param sku 
     * @param customerGroupId &#39;all&#39; can be used to specify &#39;ALL GROUPS&#39;
     * @param price 
     * @param qty 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductTierPriceManagementV1AddPost(sku: string, customerGroupId: string, price: number, qty: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogProductTierPriceManagementV1AddPost(sku: string, customerGroupId: string, price: number, qty: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogProductTierPriceManagementV1AddPost(sku: string, customerGroupId: string, price: number, qty: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogProductTierPriceManagementV1AddPost(sku: string, customerGroupId: string, price: number, qty: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductTierPriceManagementV1AddPost.');
        }
        if (customerGroupId === null || customerGroupId === undefined) {
            throw new Error('Required parameter customerGroupId was null or undefined when calling catalogProductTierPriceManagementV1AddPost.');
        }
        if (price === null || price === undefined) {
            throw new Error('Required parameter price was null or undefined when calling catalogProductTierPriceManagementV1AddPost.');
        }
        if (qty === null || qty === undefined) {
            throw new Error('Required parameter qty was null or undefined when calling catalogProductTierPriceManagementV1AddPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<boolean>(`${this.basePath}/V1/products/${encodeURIComponent(String(sku))}/group-prices/${encodeURIComponent(String(customerGroupId))}/tiers/${encodeURIComponent(String(qty))}/price/${encodeURIComponent(String(price))}`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get tier price of product
     * @param sku 
     * @param customerGroupId &#39;all&#39; can be used to specify &#39;ALL GROUPS&#39;
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductTierPriceManagementV1GetListGet(sku: string, customerGroupId: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductTierPriceInterface>>;
    public catalogProductTierPriceManagementV1GetListGet(sku: string, customerGroupId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductTierPriceInterface>>>;
    public catalogProductTierPriceManagementV1GetListGet(sku: string, customerGroupId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductTierPriceInterface>>>;
    public catalogProductTierPriceManagementV1GetListGet(sku: string, customerGroupId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductTierPriceManagementV1GetListGet.');
        }
        if (customerGroupId === null || customerGroupId === undefined) {
            throw new Error('Required parameter customerGroupId was null or undefined when calling catalogProductTierPriceManagementV1GetListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<CatalogDataProductTierPriceInterface>>(`${this.basePath}/V1/products/${encodeURIComponent(String(sku))}/group-prices/${encodeURIComponent(String(customerGroupId))}/tiers`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Remove tier price from product
     * @param sku 
     * @param customerGroupId &#39;all&#39; can be used to specify &#39;ALL GROUPS&#39;
     * @param qty 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogProductTierPriceManagementV1RemoveDelete(sku: string, customerGroupId: string, qty: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public catalogProductTierPriceManagementV1RemoveDelete(sku: string, customerGroupId: string, qty: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public catalogProductTierPriceManagementV1RemoveDelete(sku: string, customerGroupId: string, qty: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public catalogProductTierPriceManagementV1RemoveDelete(sku: string, customerGroupId: string, qty: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductTierPriceManagementV1RemoveDelete.');
        }
        if (customerGroupId === null || customerGroupId === undefined) {
            throw new Error('Required parameter customerGroupId was null or undefined when calling catalogProductTierPriceManagementV1RemoveDelete.');
        }
        if (qty === null || qty === undefined) {
            throw new Error('Required parameter qty was null or undefined when calling catalogProductTierPriceManagementV1RemoveDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/products/${encodeURIComponent(String(sku))}/group-prices/${encodeURIComponent(String(customerGroupId))}/tiers/${encodeURIComponent(String(qty))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
