/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogDataPriceUpdateResultInterface } from '../model/catalogDataPriceUpdateResultInterface';
import { CatalogDataSpecialPriceInterface } from '../model/catalogDataSpecialPriceInterface';
import { CatalogSpecialPriceStorageV1DeletePostBody } from '../model/catalogSpecialPriceStorageV1DeletePostBody';
import { CatalogSpecialPriceStorageV1GetPostBody } from '../model/catalogSpecialPriceStorageV1GetPostBody';
import { CatalogSpecialPriceStorageV1UpdatePostBody } from '../model/catalogSpecialPriceStorageV1UpdatePostBody';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CatalogSpecialPriceStorageV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Delete product&#39;s special price. If any items will have invalid price, store id, sku or dates, they will be marked as failed and excluded from delete list and \\Magento\\Catalog\\Api\\Data\\PriceUpdateResultInterface[] with problem description will be returned. If there were no failed items during update empty array will be returned. If error occurred during the delete exception will be thrown.
     * @param catalogSpecialPriceStorageV1DeletePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogSpecialPriceStorageV1DeletePost(catalogSpecialPriceStorageV1DeletePostBody?: CatalogSpecialPriceStorageV1DeletePostBody, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataPriceUpdateResultInterface>>;
    public catalogSpecialPriceStorageV1DeletePost(catalogSpecialPriceStorageV1DeletePostBody?: CatalogSpecialPriceStorageV1DeletePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataPriceUpdateResultInterface>>>;
    public catalogSpecialPriceStorageV1DeletePost(catalogSpecialPriceStorageV1DeletePostBody?: CatalogSpecialPriceStorageV1DeletePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataPriceUpdateResultInterface>>>;
    public catalogSpecialPriceStorageV1DeletePost(catalogSpecialPriceStorageV1DeletePostBody?: CatalogSpecialPriceStorageV1DeletePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<Array<CatalogDataPriceUpdateResultInterface>>(`${this.basePath}/V1/products/special-price-delete`,
            catalogSpecialPriceStorageV1DeletePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Return product&#39;s special price. In case of at least one of skus is not found exception will be thrown.
     * @param catalogSpecialPriceStorageV1GetPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogSpecialPriceStorageV1GetPost(catalogSpecialPriceStorageV1GetPostBody?: CatalogSpecialPriceStorageV1GetPostBody, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataSpecialPriceInterface>>;
    public catalogSpecialPriceStorageV1GetPost(catalogSpecialPriceStorageV1GetPostBody?: CatalogSpecialPriceStorageV1GetPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataSpecialPriceInterface>>>;
    public catalogSpecialPriceStorageV1GetPost(catalogSpecialPriceStorageV1GetPostBody?: CatalogSpecialPriceStorageV1GetPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataSpecialPriceInterface>>>;
    public catalogSpecialPriceStorageV1GetPost(catalogSpecialPriceStorageV1GetPostBody?: CatalogSpecialPriceStorageV1GetPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<Array<CatalogDataSpecialPriceInterface>>(`${this.basePath}/V1/products/special-price-information`,
            catalogSpecialPriceStorageV1GetPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Add or update product&#39;s special price. If any items will have invalid price, store id, sku or dates, they will be marked as failed and excluded from update list and \\Magento\\Catalog\\Api\\Data\\PriceUpdateResultInterface[] with problem description will be returned. If there were no failed items during update empty array will be returned. If error occurred during the update exception will be thrown.
     * @param catalogSpecialPriceStorageV1UpdatePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public catalogSpecialPriceStorageV1UpdatePost(catalogSpecialPriceStorageV1UpdatePostBody?: CatalogSpecialPriceStorageV1UpdatePostBody, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataPriceUpdateResultInterface>>;
    public catalogSpecialPriceStorageV1UpdatePost(catalogSpecialPriceStorageV1UpdatePostBody?: CatalogSpecialPriceStorageV1UpdatePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataPriceUpdateResultInterface>>>;
    public catalogSpecialPriceStorageV1UpdatePost(catalogSpecialPriceStorageV1UpdatePostBody?: CatalogSpecialPriceStorageV1UpdatePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataPriceUpdateResultInterface>>>;
    public catalogSpecialPriceStorageV1UpdatePost(catalogSpecialPriceStorageV1UpdatePostBody?: CatalogSpecialPriceStorageV1UpdatePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<Array<CatalogDataPriceUpdateResultInterface>>(`${this.basePath}/V1/products/special-price`,
            catalogSpecialPriceStorageV1UpdatePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
