/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CheckoutDataPaymentDetailsInterface } from '../model/checkoutDataPaymentDetailsInterface';
import { CheckoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody } from '../model/checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody';
import { CheckoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody } from '../model/checkoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CheckoutGuestPaymentInformationManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Get payment information
     * @param cartId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public checkoutGuestPaymentInformationManagementV1GetPaymentInformationGet(cartId: string, observe?: 'body', reportProgress?: boolean): Observable<CheckoutDataPaymentDetailsInterface>;
    public checkoutGuestPaymentInformationManagementV1GetPaymentInformationGet(cartId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CheckoutDataPaymentDetailsInterface>>;
    public checkoutGuestPaymentInformationManagementV1GetPaymentInformationGet(cartId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CheckoutDataPaymentDetailsInterface>>;
    public checkoutGuestPaymentInformationManagementV1GetPaymentInformationGet(cartId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling checkoutGuestPaymentInformationManagementV1GetPaymentInformationGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<CheckoutDataPaymentDetailsInterface>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/payment-information`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Set payment information and place order for a specified cart.
     * @param cartId 
     * @param checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPost(cartId: string, checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody?: CheckoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPost(cartId: string, checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody?: CheckoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPost(cartId: string, checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody?: CheckoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPost(cartId: string, checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody?: CheckoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<number>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/payment-information`,
            checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Set payment information for a specified cart.
     * @param cartId 
     * @param checkoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public checkoutGuestPaymentInformationManagementV1SavePaymentInformationPost(cartId: string, checkoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody?: CheckoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public checkoutGuestPaymentInformationManagementV1SavePaymentInformationPost(cartId: string, checkoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody?: CheckoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public checkoutGuestPaymentInformationManagementV1SavePaymentInformationPost(cartId: string, checkoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody?: CheckoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public checkoutGuestPaymentInformationManagementV1SavePaymentInformationPost(cartId: string, checkoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody?: CheckoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling checkoutGuestPaymentInformationManagementV1SavePaymentInformationPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<number>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/set-payment-information`,
            checkoutGuestPaymentInformationManagementV1SavePaymentInformationPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
