/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CatalogDataProductInterface } from '../model/catalogDataProductInterface';
import { ConfigurableProductLinkManagementV1AddChildPostBody } from '../model/configurableProductLinkManagementV1AddChildPostBody';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class ConfigurableProductLinkManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * 
     * @param sku 
     * @param configurableProductLinkManagementV1AddChildPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public configurableProductLinkManagementV1AddChildPost(sku: string, configurableProductLinkManagementV1AddChildPostBody?: ConfigurableProductLinkManagementV1AddChildPostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public configurableProductLinkManagementV1AddChildPost(sku: string, configurableProductLinkManagementV1AddChildPostBody?: ConfigurableProductLinkManagementV1AddChildPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public configurableProductLinkManagementV1AddChildPost(sku: string, configurableProductLinkManagementV1AddChildPostBody?: ConfigurableProductLinkManagementV1AddChildPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public configurableProductLinkManagementV1AddChildPost(sku: string, configurableProductLinkManagementV1AddChildPostBody?: ConfigurableProductLinkManagementV1AddChildPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling configurableProductLinkManagementV1AddChildPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<boolean>(`${this.basePath}/V1/configurable-products/${encodeURIComponent(String(sku))}/child`,
            configurableProductLinkManagementV1AddChildPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get all children for Configurable product
     * @param sku 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public configurableProductLinkManagementV1GetChildrenGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductInterface>>;
    public configurableProductLinkManagementV1GetChildrenGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductInterface>>>;
    public configurableProductLinkManagementV1GetChildrenGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductInterface>>>;
    public configurableProductLinkManagementV1GetChildrenGet(sku: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling configurableProductLinkManagementV1GetChildrenGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<CatalogDataProductInterface>>(`${this.basePath}/V1/configurable-products/${encodeURIComponent(String(sku))}/children`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Remove configurable product option
     * @param sku 
     * @param childSku 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public configurableProductLinkManagementV1RemoveChildDelete(sku: string, childSku: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public configurableProductLinkManagementV1RemoveChildDelete(sku: string, childSku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public configurableProductLinkManagementV1RemoveChildDelete(sku: string, childSku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public configurableProductLinkManagementV1RemoveChildDelete(sku: string, childSku: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling configurableProductLinkManagementV1RemoveChildDelete.');
        }
        if (childSku === null || childSku === undefined) {
            throw new Error('Required parameter childSku was null or undefined when calling configurableProductLinkManagementV1RemoveChildDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/configurable-products/${encodeURIComponent(String(sku))}/children/${encodeURIComponent(String(childSku))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
