/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ConfigurableProductDataOptionInterface } from '../model/configurableProductDataOptionInterface';
import { ConfigurableProductOptionRepositoryV1SavePostBody } from '../model/configurableProductOptionRepositoryV1SavePostBody';
import { ConfigurableProductOptionRepositoryV1SavePutBody } from '../model/configurableProductOptionRepositoryV1SavePutBody';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class ConfigurableProductOptionRepositoryV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Remove option from configurable product
     * @param sku 
     * @param id 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public configurableProductOptionRepositoryV1DeleteByIdDelete(sku: string, id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public configurableProductOptionRepositoryV1DeleteByIdDelete(sku: string, id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public configurableProductOptionRepositoryV1DeleteByIdDelete(sku: string, id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public configurableProductOptionRepositoryV1DeleteByIdDelete(sku: string, id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling configurableProductOptionRepositoryV1DeleteByIdDelete.');
        }
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling configurableProductOptionRepositoryV1DeleteByIdDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/configurable-products/${encodeURIComponent(String(sku))}/options/${encodeURIComponent(String(id))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get option for configurable product
     * @param sku 
     * @param id 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public configurableProductOptionRepositoryV1GetGet(sku: string, id: number, observe?: 'body', reportProgress?: boolean): Observable<ConfigurableProductDataOptionInterface>;
    public configurableProductOptionRepositoryV1GetGet(sku: string, id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ConfigurableProductDataOptionInterface>>;
    public configurableProductOptionRepositoryV1GetGet(sku: string, id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ConfigurableProductDataOptionInterface>>;
    public configurableProductOptionRepositoryV1GetGet(sku: string, id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling configurableProductOptionRepositoryV1GetGet.');
        }
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling configurableProductOptionRepositoryV1GetGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<ConfigurableProductDataOptionInterface>(`${this.basePath}/V1/configurable-products/${encodeURIComponent(String(sku))}/options/${encodeURIComponent(String(id))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get all options for configurable product
     * @param sku 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public configurableProductOptionRepositoryV1GetListGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<ConfigurableProductDataOptionInterface>>;
    public configurableProductOptionRepositoryV1GetListGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<ConfigurableProductDataOptionInterface>>>;
    public configurableProductOptionRepositoryV1GetListGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<ConfigurableProductDataOptionInterface>>>;
    public configurableProductOptionRepositoryV1GetListGet(sku: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling configurableProductOptionRepositoryV1GetListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<ConfigurableProductDataOptionInterface>>(`${this.basePath}/V1/configurable-products/${encodeURIComponent(String(sku))}/options/all`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Save option
     * @param sku 
     * @param configurableProductOptionRepositoryV1SavePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public configurableProductOptionRepositoryV1SavePost(sku: string, configurableProductOptionRepositoryV1SavePostBody?: ConfigurableProductOptionRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public configurableProductOptionRepositoryV1SavePost(sku: string, configurableProductOptionRepositoryV1SavePostBody?: ConfigurableProductOptionRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public configurableProductOptionRepositoryV1SavePost(sku: string, configurableProductOptionRepositoryV1SavePostBody?: ConfigurableProductOptionRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public configurableProductOptionRepositoryV1SavePost(sku: string, configurableProductOptionRepositoryV1SavePostBody?: ConfigurableProductOptionRepositoryV1SavePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling configurableProductOptionRepositoryV1SavePost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<number>(`${this.basePath}/V1/configurable-products/${encodeURIComponent(String(sku))}/options`,
            configurableProductOptionRepositoryV1SavePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Save option
     * @param sku 
     * @param id 
     * @param configurableProductOptionRepositoryV1SavePutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public configurableProductOptionRepositoryV1SavePut(sku: string, id: string, configurableProductOptionRepositoryV1SavePutBody?: ConfigurableProductOptionRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public configurableProductOptionRepositoryV1SavePut(sku: string, id: string, configurableProductOptionRepositoryV1SavePutBody?: ConfigurableProductOptionRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public configurableProductOptionRepositoryV1SavePut(sku: string, id: string, configurableProductOptionRepositoryV1SavePutBody?: ConfigurableProductOptionRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public configurableProductOptionRepositoryV1SavePut(sku: string, id: string, configurableProductOptionRepositoryV1SavePutBody?: ConfigurableProductOptionRepositoryV1SavePutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling configurableProductOptionRepositoryV1SavePut.');
        }
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling configurableProductOptionRepositoryV1SavePut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<number>(`${this.basePath}/V1/configurable-products/${encodeURIComponent(String(sku))}/options/${encodeURIComponent(String(id))}`,
            configurableProductOptionRepositoryV1SavePutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
