/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CustomerAccountManagementV1ActivateByIdPutBody } from '../model/customerAccountManagementV1ActivateByIdPutBody';
import { CustomerAccountManagementV1ActivatePutBody } from '../model/customerAccountManagementV1ActivatePutBody';
import { CustomerAccountManagementV1ChangePasswordByIdPutBody } from '../model/customerAccountManagementV1ChangePasswordByIdPutBody';
import { CustomerAccountManagementV1CreateAccountPostBody } from '../model/customerAccountManagementV1CreateAccountPostBody';
import { CustomerAccountManagementV1InitiatePasswordResetPutBody } from '../model/customerAccountManagementV1InitiatePasswordResetPutBody';
import { CustomerAccountManagementV1IsEmailAvailablePostBody } from '../model/customerAccountManagementV1IsEmailAvailablePostBody';
import { CustomerAccountManagementV1ResendConfirmationPostBody } from '../model/customerAccountManagementV1ResendConfirmationPostBody';
import { CustomerAccountManagementV1ResetPasswordPostBody } from '../model/customerAccountManagementV1ResetPasswordPostBody';
import { CustomerAccountManagementV1ValidatePutBody } from '../model/customerAccountManagementV1ValidatePutBody';
import { CustomerDataAddressInterface } from '../model/customerDataAddressInterface';
import { CustomerDataCustomerInterface } from '../model/customerDataCustomerInterface';
import { CustomerDataValidationResultsInterface } from '../model/customerDataValidationResultsInterface';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CustomerAccountManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Activate a customer account using a key that was sent in a confirmation email.
     * @param customerAccountManagementV1ActivateByIdPutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1ActivateByIdPut(customerAccountManagementV1ActivateByIdPutBody?: CustomerAccountManagementV1ActivateByIdPutBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerInterface>;
    public customerAccountManagementV1ActivateByIdPut(customerAccountManagementV1ActivateByIdPutBody?: CustomerAccountManagementV1ActivateByIdPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerInterface>>;
    public customerAccountManagementV1ActivateByIdPut(customerAccountManagementV1ActivateByIdPutBody?: CustomerAccountManagementV1ActivateByIdPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerInterface>>;
    public customerAccountManagementV1ActivateByIdPut(customerAccountManagementV1ActivateByIdPutBody?: CustomerAccountManagementV1ActivateByIdPutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<CustomerDataCustomerInterface>(`${this.basePath}/V1/customers/me/activate`,
            customerAccountManagementV1ActivateByIdPutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Activate a customer account using a key that was sent in a confirmation email.
     * @param email 
     * @param customerAccountManagementV1ActivatePutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1ActivatePut(email: string, customerAccountManagementV1ActivatePutBody?: CustomerAccountManagementV1ActivatePutBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerInterface>;
    public customerAccountManagementV1ActivatePut(email: string, customerAccountManagementV1ActivatePutBody?: CustomerAccountManagementV1ActivatePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerInterface>>;
    public customerAccountManagementV1ActivatePut(email: string, customerAccountManagementV1ActivatePutBody?: CustomerAccountManagementV1ActivatePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerInterface>>;
    public customerAccountManagementV1ActivatePut(email: string, customerAccountManagementV1ActivatePutBody?: CustomerAccountManagementV1ActivatePutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (email === null || email === undefined) {
            throw new Error('Required parameter email was null or undefined when calling customerAccountManagementV1ActivatePut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<CustomerDataCustomerInterface>(`${this.basePath}/V1/customers/${encodeURIComponent(String(email))}/activate`,
            customerAccountManagementV1ActivatePutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Change customer password.
     * @param customerAccountManagementV1ChangePasswordByIdPutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1ChangePasswordByIdPut(customerAccountManagementV1ChangePasswordByIdPutBody?: CustomerAccountManagementV1ChangePasswordByIdPutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public customerAccountManagementV1ChangePasswordByIdPut(customerAccountManagementV1ChangePasswordByIdPutBody?: CustomerAccountManagementV1ChangePasswordByIdPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public customerAccountManagementV1ChangePasswordByIdPut(customerAccountManagementV1ChangePasswordByIdPutBody?: CustomerAccountManagementV1ChangePasswordByIdPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public customerAccountManagementV1ChangePasswordByIdPut(customerAccountManagementV1ChangePasswordByIdPutBody?: CustomerAccountManagementV1ChangePasswordByIdPutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<boolean>(`${this.basePath}/V1/customers/me/password`,
            customerAccountManagementV1ChangePasswordByIdPutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Create customer account. Perform necessary business operations like sending email.
     * @param customerAccountManagementV1CreateAccountPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1CreateAccountPost(customerAccountManagementV1CreateAccountPostBody?: CustomerAccountManagementV1CreateAccountPostBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerInterface>;
    public customerAccountManagementV1CreateAccountPost(customerAccountManagementV1CreateAccountPostBody?: CustomerAccountManagementV1CreateAccountPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerInterface>>;
    public customerAccountManagementV1CreateAccountPost(customerAccountManagementV1CreateAccountPostBody?: CustomerAccountManagementV1CreateAccountPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerInterface>>;
    public customerAccountManagementV1CreateAccountPost(customerAccountManagementV1CreateAccountPostBody?: CustomerAccountManagementV1CreateAccountPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<CustomerDataCustomerInterface>(`${this.basePath}/V1/customers`,
            customerAccountManagementV1CreateAccountPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Gets the account confirmation status.
     * @param customerId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1GetConfirmationStatusGet(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<string>;
    public customerAccountManagementV1GetConfirmationStatusGet(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    public customerAccountManagementV1GetConfirmationStatusGet(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    public customerAccountManagementV1GetConfirmationStatusGet(customerId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerAccountManagementV1GetConfirmationStatusGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<string>(`${this.basePath}/V1/customers/${encodeURIComponent(String(customerId))}/confirm`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Retrieve default billing address for the given customerId.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1GetDefaultBillingAddressGet(observe?: 'body', reportProgress?: boolean): Observable<CustomerDataAddressInterface>;
    public customerAccountManagementV1GetDefaultBillingAddressGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataAddressInterface>>;
    public customerAccountManagementV1GetDefaultBillingAddressGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataAddressInterface>>;
    public customerAccountManagementV1GetDefaultBillingAddressGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<CustomerDataAddressInterface>(`${this.basePath}/V1/customers/me/billingAddress`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Retrieve default billing address for the given customerId.
     * @param customerId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1GetDefaultBillingAddressGet_1(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataAddressInterface>;
    public customerAccountManagementV1GetDefaultBillingAddressGet_1(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataAddressInterface>>;
    public customerAccountManagementV1GetDefaultBillingAddressGet_1(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataAddressInterface>>;
    public customerAccountManagementV1GetDefaultBillingAddressGet_1(customerId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerAccountManagementV1GetDefaultBillingAddressGet_1.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<CustomerDataAddressInterface>(`${this.basePath}/V1/customers/${encodeURIComponent(String(customerId))}/billingAddress`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Retrieve default shipping address for the given customerId.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1GetDefaultShippingAddressGet(observe?: 'body', reportProgress?: boolean): Observable<CustomerDataAddressInterface>;
    public customerAccountManagementV1GetDefaultShippingAddressGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataAddressInterface>>;
    public customerAccountManagementV1GetDefaultShippingAddressGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataAddressInterface>>;
    public customerAccountManagementV1GetDefaultShippingAddressGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<CustomerDataAddressInterface>(`${this.basePath}/V1/customers/me/shippingAddress`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Retrieve default shipping address for the given customerId.
     * @param customerId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1GetDefaultShippingAddressGet_2(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataAddressInterface>;
    public customerAccountManagementV1GetDefaultShippingAddressGet_2(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataAddressInterface>>;
    public customerAccountManagementV1GetDefaultShippingAddressGet_2(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataAddressInterface>>;
    public customerAccountManagementV1GetDefaultShippingAddressGet_2(customerId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerAccountManagementV1GetDefaultShippingAddressGet_2.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<CustomerDataAddressInterface>(`${this.basePath}/V1/customers/${encodeURIComponent(String(customerId))}/shippingAddress`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Send an email to the customer with a password reset link.
     * @param customerAccountManagementV1InitiatePasswordResetPutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1InitiatePasswordResetPut(customerAccountManagementV1InitiatePasswordResetPutBody?: CustomerAccountManagementV1InitiatePasswordResetPutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public customerAccountManagementV1InitiatePasswordResetPut(customerAccountManagementV1InitiatePasswordResetPutBody?: CustomerAccountManagementV1InitiatePasswordResetPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public customerAccountManagementV1InitiatePasswordResetPut(customerAccountManagementV1InitiatePasswordResetPutBody?: CustomerAccountManagementV1InitiatePasswordResetPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public customerAccountManagementV1InitiatePasswordResetPut(customerAccountManagementV1InitiatePasswordResetPutBody?: CustomerAccountManagementV1InitiatePasswordResetPutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<boolean>(`${this.basePath}/V1/customers/password`,
            customerAccountManagementV1InitiatePasswordResetPutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Check if given email is associated with a customer account in given website.
     * @param customerAccountManagementV1IsEmailAvailablePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1IsEmailAvailablePost(customerAccountManagementV1IsEmailAvailablePostBody?: CustomerAccountManagementV1IsEmailAvailablePostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public customerAccountManagementV1IsEmailAvailablePost(customerAccountManagementV1IsEmailAvailablePostBody?: CustomerAccountManagementV1IsEmailAvailablePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public customerAccountManagementV1IsEmailAvailablePost(customerAccountManagementV1IsEmailAvailablePostBody?: CustomerAccountManagementV1IsEmailAvailablePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public customerAccountManagementV1IsEmailAvailablePost(customerAccountManagementV1IsEmailAvailablePostBody?: CustomerAccountManagementV1IsEmailAvailablePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<boolean>(`${this.basePath}/V1/customers/isEmailAvailable`,
            customerAccountManagementV1IsEmailAvailablePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Check if customer can be deleted.
     * @param customerId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1IsReadonlyGet(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public customerAccountManagementV1IsReadonlyGet(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public customerAccountManagementV1IsReadonlyGet(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public customerAccountManagementV1IsReadonlyGet(customerId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerAccountManagementV1IsReadonlyGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<boolean>(`${this.basePath}/V1/customers/${encodeURIComponent(String(customerId))}/permissions/readonly`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Resend confirmation email.
     * @param customerAccountManagementV1ResendConfirmationPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1ResendConfirmationPost(customerAccountManagementV1ResendConfirmationPostBody?: CustomerAccountManagementV1ResendConfirmationPostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public customerAccountManagementV1ResendConfirmationPost(customerAccountManagementV1ResendConfirmationPostBody?: CustomerAccountManagementV1ResendConfirmationPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public customerAccountManagementV1ResendConfirmationPost(customerAccountManagementV1ResendConfirmationPostBody?: CustomerAccountManagementV1ResendConfirmationPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public customerAccountManagementV1ResendConfirmationPost(customerAccountManagementV1ResendConfirmationPostBody?: CustomerAccountManagementV1ResendConfirmationPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<boolean>(`${this.basePath}/V1/customers/confirm`,
            customerAccountManagementV1ResendConfirmationPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Reset customer password.
     * @param customerAccountManagementV1ResetPasswordPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1ResetPasswordPost(customerAccountManagementV1ResetPasswordPostBody?: CustomerAccountManagementV1ResetPasswordPostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public customerAccountManagementV1ResetPasswordPost(customerAccountManagementV1ResetPasswordPostBody?: CustomerAccountManagementV1ResetPasswordPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public customerAccountManagementV1ResetPasswordPost(customerAccountManagementV1ResetPasswordPostBody?: CustomerAccountManagementV1ResetPasswordPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public customerAccountManagementV1ResetPasswordPost(customerAccountManagementV1ResetPasswordPostBody?: CustomerAccountManagementV1ResetPasswordPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<boolean>(`${this.basePath}/V1/customers/resetPassword`,
            customerAccountManagementV1ResetPasswordPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Validate customer data.
     * @param customerAccountManagementV1ValidatePutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1ValidatePut(customerAccountManagementV1ValidatePutBody?: CustomerAccountManagementV1ValidatePutBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataValidationResultsInterface>;
    public customerAccountManagementV1ValidatePut(customerAccountManagementV1ValidatePutBody?: CustomerAccountManagementV1ValidatePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataValidationResultsInterface>>;
    public customerAccountManagementV1ValidatePut(customerAccountManagementV1ValidatePutBody?: CustomerAccountManagementV1ValidatePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataValidationResultsInterface>>;
    public customerAccountManagementV1ValidatePut(customerAccountManagementV1ValidatePutBody?: CustomerAccountManagementV1ValidatePutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<CustomerDataValidationResultsInterface>(`${this.basePath}/V1/customers/validate`,
            customerAccountManagementV1ValidatePutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Check if password reset token is valid.
     * @param customerId 
     * @param resetPasswordLinkToken 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerAccountManagementV1ValidateResetPasswordLinkTokenGet(customerId: number, resetPasswordLinkToken: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public customerAccountManagementV1ValidateResetPasswordLinkTokenGet(customerId: number, resetPasswordLinkToken: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public customerAccountManagementV1ValidateResetPasswordLinkTokenGet(customerId: number, resetPasswordLinkToken: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public customerAccountManagementV1ValidateResetPasswordLinkTokenGet(customerId: number, resetPasswordLinkToken: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerAccountManagementV1ValidateResetPasswordLinkTokenGet.');
        }
        if (resetPasswordLinkToken === null || resetPasswordLinkToken === undefined) {
            throw new Error('Required parameter resetPasswordLinkToken was null or undefined when calling customerAccountManagementV1ValidateResetPasswordLinkTokenGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<boolean>(`${this.basePath}/V1/customers/${encodeURIComponent(String(customerId))}/password/resetLinkToken/${encodeURIComponent(String(resetPasswordLinkToken))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
