/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { CustomerDataGroupInterface } from '../model/customerDataGroupInterface';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class CustomerGroupManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Get default customer group.
     * @param storeId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerGroupManagementV1GetDefaultGroupGet(storeId: number, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataGroupInterface>;
    public customerGroupManagementV1GetDefaultGroupGet(storeId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataGroupInterface>>;
    public customerGroupManagementV1GetDefaultGroupGet(storeId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataGroupInterface>>;
    public customerGroupManagementV1GetDefaultGroupGet(storeId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (storeId === null || storeId === undefined) {
            throw new Error('Required parameter storeId was null or undefined when calling customerGroupManagementV1GetDefaultGroupGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<CustomerDataGroupInterface>(`${this.basePath}/V1/customerGroups/default/${encodeURIComponent(String(storeId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get default customer group.
     * @param storeId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerGroupManagementV1GetDefaultGroupGet_1(storeId?: number, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataGroupInterface>;
    public customerGroupManagementV1GetDefaultGroupGet_1(storeId?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataGroupInterface>>;
    public customerGroupManagementV1GetDefaultGroupGet_1(storeId?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataGroupInterface>>;
    public customerGroupManagementV1GetDefaultGroupGet_1(storeId?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (storeId !== undefined) {
            queryParameters = queryParameters.set('storeId', <any>storeId);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<CustomerDataGroupInterface>(`${this.basePath}/V1/customerGroups/default`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Check if customer group can be deleted.
     * @param id 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public customerGroupManagementV1IsReadonlyGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public customerGroupManagementV1IsReadonlyGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public customerGroupManagementV1IsReadonlyGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public customerGroupManagementV1IsReadonlyGet(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling customerGroupManagementV1IsReadonlyGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<boolean>(`${this.basePath}/V1/customerGroups/${encodeURIComponent(String(id))}/permissions`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
