/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { DirectoryDataCountryInformationInterface } from '../model/directoryDataCountryInformationInterface';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class DirectoryCountryInformationAcquirerV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Get all countries and regions information for the store.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public directoryCountryInformationAcquirerV1GetCountriesInfoGet(observe?: 'body', reportProgress?: boolean): Observable<Array<DirectoryDataCountryInformationInterface>>;
    public directoryCountryInformationAcquirerV1GetCountriesInfoGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<DirectoryDataCountryInformationInterface>>>;
    public directoryCountryInformationAcquirerV1GetCountriesInfoGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<DirectoryDataCountryInformationInterface>>>;
    public directoryCountryInformationAcquirerV1GetCountriesInfoGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<DirectoryDataCountryInformationInterface>>(`${this.basePath}/V1/directory/countries`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get country and region information for the store.
     * @param countryId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public directoryCountryInformationAcquirerV1GetCountryInfoGet(countryId: string, observe?: 'body', reportProgress?: boolean): Observable<DirectoryDataCountryInformationInterface>;
    public directoryCountryInformationAcquirerV1GetCountryInfoGet(countryId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<DirectoryDataCountryInformationInterface>>;
    public directoryCountryInformationAcquirerV1GetCountryInfoGet(countryId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<DirectoryDataCountryInformationInterface>>;
    public directoryCountryInformationAcquirerV1GetCountryInfoGet(countryId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (countryId === null || countryId === undefined) {
            throw new Error('Required parameter countryId was null or undefined when calling directoryCountryInformationAcquirerV1GetCountryInfoGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<DirectoryDataCountryInformationInterface>(`${this.basePath}/V1/directory/countries/${encodeURIComponent(String(countryId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
