/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { DownloadableDataLinkInterface } from '../model/downloadableDataLinkInterface';
import { DownloadableLinkRepositoryV1SavePostBody } from '../model/downloadableLinkRepositoryV1SavePostBody';
import { DownloadableLinkRepositoryV1SavePutBody } from '../model/downloadableLinkRepositoryV1SavePutBody';
import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class DownloadableLinkRepositoryV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Delete downloadable link
     * @param id 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public downloadableLinkRepositoryV1DeleteDelete(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public downloadableLinkRepositoryV1DeleteDelete(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public downloadableLinkRepositoryV1DeleteDelete(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public downloadableLinkRepositoryV1DeleteDelete(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling downloadableLinkRepositoryV1DeleteDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/products/downloadable-links/${encodeURIComponent(String(id))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * List of links with associated samples
     * @param sku 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public downloadableLinkRepositoryV1GetListGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<DownloadableDataLinkInterface>>;
    public downloadableLinkRepositoryV1GetListGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<DownloadableDataLinkInterface>>>;
    public downloadableLinkRepositoryV1GetListGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<DownloadableDataLinkInterface>>>;
    public downloadableLinkRepositoryV1GetListGet(sku: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling downloadableLinkRepositoryV1GetListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<DownloadableDataLinkInterface>>(`${this.basePath}/V1/products/${encodeURIComponent(String(sku))}/downloadable-links`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Update downloadable link of the given product (link type and its resources cannot be changed)
     * @param sku 
     * @param downloadableLinkRepositoryV1SavePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public downloadableLinkRepositoryV1SavePost(sku: string, downloadableLinkRepositoryV1SavePostBody?: DownloadableLinkRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public downloadableLinkRepositoryV1SavePost(sku: string, downloadableLinkRepositoryV1SavePostBody?: DownloadableLinkRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public downloadableLinkRepositoryV1SavePost(sku: string, downloadableLinkRepositoryV1SavePostBody?: DownloadableLinkRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public downloadableLinkRepositoryV1SavePost(sku: string, downloadableLinkRepositoryV1SavePostBody?: DownloadableLinkRepositoryV1SavePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling downloadableLinkRepositoryV1SavePost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<number>(`${this.basePath}/V1/products/${encodeURIComponent(String(sku))}/downloadable-links`,
            downloadableLinkRepositoryV1SavePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Update downloadable link of the given product (link type and its resources cannot be changed)
     * @param sku 
     * @param id 
     * @param downloadableLinkRepositoryV1SavePutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public downloadableLinkRepositoryV1SavePut(sku: string, id: string, downloadableLinkRepositoryV1SavePutBody?: DownloadableLinkRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public downloadableLinkRepositoryV1SavePut(sku: string, id: string, downloadableLinkRepositoryV1SavePutBody?: DownloadableLinkRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public downloadableLinkRepositoryV1SavePut(sku: string, id: string, downloadableLinkRepositoryV1SavePutBody?: DownloadableLinkRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public downloadableLinkRepositoryV1SavePut(sku: string, id: string, downloadableLinkRepositoryV1SavePutBody?: DownloadableLinkRepositoryV1SavePutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling downloadableLinkRepositoryV1SavePut.');
        }
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling downloadableLinkRepositoryV1SavePut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<number>(`${this.basePath}/V1/products/${encodeURIComponent(String(sku))}/downloadable-links/${encodeURIComponent(String(id))}`,
            downloadableLinkRepositoryV1SavePutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
