/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { GiftMessageDataMessageInterface } from '../model/giftMessageDataMessageInterface';
import { GiftMessageGuestCartRepositoryV1SavePostBody } from '../model/giftMessageGuestCartRepositoryV1SavePostBody';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class GiftMessageGuestCartRepositoryV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Return the gift message for a specified order.
     * @param cartId The shopping cart ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public giftMessageGuestCartRepositoryV1GetGet(cartId: string, observe?: 'body', reportProgress?: boolean): Observable<GiftMessageDataMessageInterface>;
    public giftMessageGuestCartRepositoryV1GetGet(cartId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<GiftMessageDataMessageInterface>>;
    public giftMessageGuestCartRepositoryV1GetGet(cartId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<GiftMessageDataMessageInterface>>;
    public giftMessageGuestCartRepositoryV1GetGet(cartId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling giftMessageGuestCartRepositoryV1GetGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<GiftMessageDataMessageInterface>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/gift-message`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Set the gift message for an entire order.
     * @param cartId The cart ID.
     * @param giftMessageGuestCartRepositoryV1SavePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public giftMessageGuestCartRepositoryV1SavePost(cartId: string, giftMessageGuestCartRepositoryV1SavePostBody?: GiftMessageGuestCartRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public giftMessageGuestCartRepositoryV1SavePost(cartId: string, giftMessageGuestCartRepositoryV1SavePostBody?: GiftMessageGuestCartRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public giftMessageGuestCartRepositoryV1SavePost(cartId: string, giftMessageGuestCartRepositoryV1SavePostBody?: GiftMessageGuestCartRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public giftMessageGuestCartRepositoryV1SavePost(cartId: string, giftMessageGuestCartRepositoryV1SavePostBody?: GiftMessageGuestCartRepositoryV1SavePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling giftMessageGuestCartRepositoryV1SavePost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<boolean>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/gift-message`,
            giftMessageGuestCartRepositoryV1SavePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
