/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { QuoteCartManagementV1AssignCustomerPutBody } from '../model/quoteCartManagementV1AssignCustomerPutBody';
import { QuoteCartManagementV1PlaceOrderPutBody } from '../model/quoteCartManagementV1PlaceOrderPutBody';
import { QuoteCartManagementV1PlaceOrderPutBody1 } from '../model/quoteCartManagementV1PlaceOrderPutBody1';
import { QuoteDataCartInterface } from '../model/quoteDataCartInterface';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class QuoteCartManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Assigns a specified customer to a specified shopping cart.
     * @param cartId The cart ID.
     * @param quoteCartManagementV1AssignCustomerPutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCartManagementV1AssignCustomerPut(cartId: number, quoteCartManagementV1AssignCustomerPutBody?: QuoteCartManagementV1AssignCustomerPutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public quoteCartManagementV1AssignCustomerPut(cartId: number, quoteCartManagementV1AssignCustomerPutBody?: QuoteCartManagementV1AssignCustomerPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public quoteCartManagementV1AssignCustomerPut(cartId: number, quoteCartManagementV1AssignCustomerPutBody?: QuoteCartManagementV1AssignCustomerPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public quoteCartManagementV1AssignCustomerPut(cartId: number, quoteCartManagementV1AssignCustomerPutBody?: QuoteCartManagementV1AssignCustomerPutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteCartManagementV1AssignCustomerPut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<boolean>(`${this.basePath}/V1/carts/${encodeURIComponent(String(cartId))}`,
            quoteCartManagementV1AssignCustomerPutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Creates an empty cart and quote for a specified customer if customer does not have a cart yet.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCartManagementV1CreateEmptyCartForCustomerPost(observe?: 'body', reportProgress?: boolean): Observable<number>;
    public quoteCartManagementV1CreateEmptyCartForCustomerPost(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public quoteCartManagementV1CreateEmptyCartForCustomerPost(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public quoteCartManagementV1CreateEmptyCartForCustomerPost(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<number>(`${this.basePath}/V1/carts/mine`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Creates an empty cart and quote for a specified customer if customer does not have a cart yet.
     * @param customerId The customer ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCartManagementV1CreateEmptyCartForCustomerPost_1(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public quoteCartManagementV1CreateEmptyCartForCustomerPost_1(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public quoteCartManagementV1CreateEmptyCartForCustomerPost_1(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public quoteCartManagementV1CreateEmptyCartForCustomerPost_1(customerId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling quoteCartManagementV1CreateEmptyCartForCustomerPost_1.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<number>(`${this.basePath}/V1/customers/${encodeURIComponent(String(customerId))}/carts`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Creates an empty cart and quote for a guest.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCartManagementV1CreateEmptyCartPost(observe?: 'body', reportProgress?: boolean): Observable<number>;
    public quoteCartManagementV1CreateEmptyCartPost(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public quoteCartManagementV1CreateEmptyCartPost(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public quoteCartManagementV1CreateEmptyCartPost(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<number>(`${this.basePath}/V1/carts/`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Returns information for the cart for a specified customer.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCartManagementV1GetCartForCustomerGet(observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartInterface>;
    public quoteCartManagementV1GetCartForCustomerGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartInterface>>;
    public quoteCartManagementV1GetCartForCustomerGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartInterface>>;
    public quoteCartManagementV1GetCartForCustomerGet(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<QuoteDataCartInterface>(`${this.basePath}/V1/carts/mine`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Places an order for a specified cart.
     * @param quoteCartManagementV1PlaceOrderPutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCartManagementV1PlaceOrderPut(quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public quoteCartManagementV1PlaceOrderPut(quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public quoteCartManagementV1PlaceOrderPut(quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public quoteCartManagementV1PlaceOrderPut(quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<number>(`${this.basePath}/V1/carts/mine/order`,
            quoteCartManagementV1PlaceOrderPutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Places an order for a specified cart.
     * @param cartId The cart ID.
     * @param quoteCartManagementV1PlaceOrderPutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCartManagementV1PlaceOrderPut_2(cartId: number, quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody1, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public quoteCartManagementV1PlaceOrderPut_2(cartId: number, quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody1, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public quoteCartManagementV1PlaceOrderPut_2(cartId: number, quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody1, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public quoteCartManagementV1PlaceOrderPut_2(cartId: number, quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody1, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteCartManagementV1PlaceOrderPut_2.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<number>(`${this.basePath}/V1/carts/${encodeURIComponent(String(cartId))}/order`,
            quoteCartManagementV1PlaceOrderPutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
