/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { QuoteCartRepositoryV1SavePutBody } from '../model/quoteCartRepositoryV1SavePutBody';
import { QuoteDataCartInterface } from '../model/quoteDataCartInterface';
import { QuoteDataCartSearchResultsInterface } from '../model/quoteDataCartSearchResultsInterface';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class QuoteCartRepositoryV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Enables an administrative user to return information for a specified cart.
     * @param cartId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCartRepositoryV1GetGet(cartId: number, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartInterface>;
    public quoteCartRepositoryV1GetGet(cartId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartInterface>>;
    public quoteCartRepositoryV1GetGet(cartId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartInterface>>;
    public quoteCartRepositoryV1GetGet(cartId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteCartRepositoryV1GetGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<QuoteDataCartInterface>(`${this.basePath}/V1/carts/${encodeURIComponent(String(cartId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Enables administrative users to list carts that match specified search criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included.  See http://devdocs.magento.com/codelinks/attributes.html#CartRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.
     * @param searchCriteriaFilterGroupsFiltersField Field
     * @param searchCriteriaFilterGroupsFiltersValue Value
     * @param searchCriteriaFilterGroupsFiltersConditionType Condition type
     * @param searchCriteriaSortOrdersField Sorting field.
     * @param searchCriteriaSortOrdersDirection Sorting direction.
     * @param searchCriteriaPageSize Page size.
     * @param searchCriteriaCurrentPage Current page.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCartRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartSearchResultsInterface>;
    public quoteCartRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartSearchResultsInterface>>;
    public quoteCartRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartSearchResultsInterface>>;
    public quoteCartRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (searchCriteriaFilterGroupsFiltersField !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[filterGroups][][filters][][field]', <any>searchCriteriaFilterGroupsFiltersField);
        }
        if (searchCriteriaFilterGroupsFiltersValue !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[filterGroups][][filters][][value]', <any>searchCriteriaFilterGroupsFiltersValue);
        }
        if (searchCriteriaFilterGroupsFiltersConditionType !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[filterGroups][][filters][][conditionType]', <any>searchCriteriaFilterGroupsFiltersConditionType);
        }
        if (searchCriteriaSortOrdersField !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[sortOrders][][field]', <any>searchCriteriaSortOrdersField);
        }
        if (searchCriteriaSortOrdersDirection !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[sortOrders][][direction]', <any>searchCriteriaSortOrdersDirection);
        }
        if (searchCriteriaPageSize !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[pageSize]', <any>searchCriteriaPageSize);
        }
        if (searchCriteriaCurrentPage !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[currentPage]', <any>searchCriteriaCurrentPage);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<QuoteDataCartSearchResultsInterface>(`${this.basePath}/V1/carts/search`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Save quote
     * @param quoteCartRepositoryV1SavePutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCartRepositoryV1SavePut(quoteCartRepositoryV1SavePutBody?: QuoteCartRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<ErrorResponse>;
    public quoteCartRepositoryV1SavePut(quoteCartRepositoryV1SavePutBody?: QuoteCartRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ErrorResponse>>;
    public quoteCartRepositoryV1SavePut(quoteCartRepositoryV1SavePutBody?: QuoteCartRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ErrorResponse>>;
    public quoteCartRepositoryV1SavePut(quoteCartRepositoryV1SavePutBody?: QuoteCartRepositoryV1SavePutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<ErrorResponse>(`${this.basePath}/V1/carts/mine`,
            quoteCartRepositoryV1SavePutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
