/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class QuoteCouponManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Returns information for a coupon in a specified cart.
     * @param cartId The cart ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCouponManagementV1GetGet(cartId: number, observe?: 'body', reportProgress?: boolean): Observable<string>;
    public quoteCouponManagementV1GetGet(cartId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    public quoteCouponManagementV1GetGet(cartId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    public quoteCouponManagementV1GetGet(cartId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteCouponManagementV1GetGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<string>(`${this.basePath}/V1/carts/${encodeURIComponent(String(cartId))}/coupons`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Returns information for a coupon in a specified cart.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCouponManagementV1GetGet_1(observe?: 'body', reportProgress?: boolean): Observable<string>;
    public quoteCouponManagementV1GetGet_1(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    public quoteCouponManagementV1GetGet_1(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    public quoteCouponManagementV1GetGet_1(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<string>(`${this.basePath}/V1/carts/mine/coupons`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Deletes a coupon from a specified cart.
     * @param cartId The cart ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCouponManagementV1RemoveDelete(cartId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public quoteCouponManagementV1RemoveDelete(cartId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public quoteCouponManagementV1RemoveDelete(cartId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public quoteCouponManagementV1RemoveDelete(cartId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteCouponManagementV1RemoveDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/carts/${encodeURIComponent(String(cartId))}/coupons`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Deletes a coupon from a specified cart.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCouponManagementV1RemoveDelete_2(observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public quoteCouponManagementV1RemoveDelete_2(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public quoteCouponManagementV1RemoveDelete_2(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public quoteCouponManagementV1RemoveDelete_2(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/carts/mine/coupons`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Adds a coupon by code to a specified cart.
     * @param cartId The cart ID.
     * @param couponCode The coupon code data.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCouponManagementV1SetPut(cartId: number, couponCode: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public quoteCouponManagementV1SetPut(cartId: number, couponCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public quoteCouponManagementV1SetPut(cartId: number, couponCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public quoteCouponManagementV1SetPut(cartId: number, couponCode: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteCouponManagementV1SetPut.');
        }
        if (couponCode === null || couponCode === undefined) {
            throw new Error('Required parameter couponCode was null or undefined when calling quoteCouponManagementV1SetPut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.put<boolean>(`${this.basePath}/V1/carts/${encodeURIComponent(String(cartId))}/coupons/${encodeURIComponent(String(couponCode))}`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Adds a coupon by code to a specified cart.
     * @param couponCode The coupon code data.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteCouponManagementV1SetPut_3(couponCode: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public quoteCouponManagementV1SetPut_3(couponCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public quoteCouponManagementV1SetPut_3(couponCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public quoteCouponManagementV1SetPut_3(couponCode: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (couponCode === null || couponCode === undefined) {
            throw new Error('Required parameter couponCode was null or undefined when calling quoteCouponManagementV1SetPut_3.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.put<boolean>(`${this.basePath}/V1/carts/mine/coupons/${encodeURIComponent(String(couponCode))}`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
