/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { QuoteDataCartItemInterface } from '../model/quoteDataCartItemInterface';
import { QuoteGuestCartItemRepositoryV1SavePostBody } from '../model/quoteGuestCartItemRepositoryV1SavePostBody';
import { QuoteGuestCartItemRepositoryV1SavePutBody } from '../model/quoteGuestCartItemRepositoryV1SavePutBody';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class QuoteGuestCartItemRepositoryV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Remove the specified item from the specified cart.
     * @param cartId The cart ID.
     * @param itemId The item ID of the item to be removed.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteGuestCartItemRepositoryV1DeleteByIdDelete(cartId: string, itemId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public quoteGuestCartItemRepositoryV1DeleteByIdDelete(cartId: string, itemId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public quoteGuestCartItemRepositoryV1DeleteByIdDelete(cartId: string, itemId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public quoteGuestCartItemRepositoryV1DeleteByIdDelete(cartId: string, itemId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteGuestCartItemRepositoryV1DeleteByIdDelete.');
        }
        if (itemId === null || itemId === undefined) {
            throw new Error('Required parameter itemId was null or undefined when calling quoteGuestCartItemRepositoryV1DeleteByIdDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/items/${encodeURIComponent(String(itemId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * List items that are assigned to a specified cart.
     * @param cartId The cart ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteGuestCartItemRepositoryV1GetListGet(cartId: string, observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataCartItemInterface>>;
    public quoteGuestCartItemRepositoryV1GetListGet(cartId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataCartItemInterface>>>;
    public quoteGuestCartItemRepositoryV1GetListGet(cartId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataCartItemInterface>>>;
    public quoteGuestCartItemRepositoryV1GetListGet(cartId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteGuestCartItemRepositoryV1GetListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<QuoteDataCartItemInterface>>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/items`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Add/update the specified cart item.
     * @param cartId 
     * @param quoteGuestCartItemRepositoryV1SavePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteGuestCartItemRepositoryV1SavePost(cartId: string, quoteGuestCartItemRepositoryV1SavePostBody?: QuoteGuestCartItemRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartItemInterface>;
    public quoteGuestCartItemRepositoryV1SavePost(cartId: string, quoteGuestCartItemRepositoryV1SavePostBody?: QuoteGuestCartItemRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartItemInterface>>;
    public quoteGuestCartItemRepositoryV1SavePost(cartId: string, quoteGuestCartItemRepositoryV1SavePostBody?: QuoteGuestCartItemRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartItemInterface>>;
    public quoteGuestCartItemRepositoryV1SavePost(cartId: string, quoteGuestCartItemRepositoryV1SavePostBody?: QuoteGuestCartItemRepositoryV1SavePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteGuestCartItemRepositoryV1SavePost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<QuoteDataCartItemInterface>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/items`,
            quoteGuestCartItemRepositoryV1SavePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Add/update the specified cart item.
     * @param cartId 
     * @param itemId 
     * @param quoteGuestCartItemRepositoryV1SavePutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteGuestCartItemRepositoryV1SavePut(cartId: string, itemId: string, quoteGuestCartItemRepositoryV1SavePutBody?: QuoteGuestCartItemRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartItemInterface>;
    public quoteGuestCartItemRepositoryV1SavePut(cartId: string, itemId: string, quoteGuestCartItemRepositoryV1SavePutBody?: QuoteGuestCartItemRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartItemInterface>>;
    public quoteGuestCartItemRepositoryV1SavePut(cartId: string, itemId: string, quoteGuestCartItemRepositoryV1SavePutBody?: QuoteGuestCartItemRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartItemInterface>>;
    public quoteGuestCartItemRepositoryV1SavePut(cartId: string, itemId: string, quoteGuestCartItemRepositoryV1SavePutBody?: QuoteGuestCartItemRepositoryV1SavePutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteGuestCartItemRepositoryV1SavePut.');
        }
        if (itemId === null || itemId === undefined) {
            throw new Error('Required parameter itemId was null or undefined when calling quoteGuestCartItemRepositoryV1SavePut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<QuoteDataCartItemInterface>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/items/${encodeURIComponent(String(itemId))}`,
            quoteGuestCartItemRepositoryV1SavePutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
