/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { QuoteGuestCartManagementV1AssignCustomerPutBody } from '../model/quoteGuestCartManagementV1AssignCustomerPutBody';
import { QuoteGuestCartManagementV1PlaceOrderPutBody } from '../model/quoteGuestCartManagementV1PlaceOrderPutBody';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class QuoteGuestCartManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Assign a specified customer to a specified shopping cart.
     * @param cartId The cart ID.
     * @param quoteGuestCartManagementV1AssignCustomerPutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteGuestCartManagementV1AssignCustomerPut(cartId: string, quoteGuestCartManagementV1AssignCustomerPutBody?: QuoteGuestCartManagementV1AssignCustomerPutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public quoteGuestCartManagementV1AssignCustomerPut(cartId: string, quoteGuestCartManagementV1AssignCustomerPutBody?: QuoteGuestCartManagementV1AssignCustomerPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public quoteGuestCartManagementV1AssignCustomerPut(cartId: string, quoteGuestCartManagementV1AssignCustomerPutBody?: QuoteGuestCartManagementV1AssignCustomerPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public quoteGuestCartManagementV1AssignCustomerPut(cartId: string, quoteGuestCartManagementV1AssignCustomerPutBody?: QuoteGuestCartManagementV1AssignCustomerPutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteGuestCartManagementV1AssignCustomerPut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<boolean>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}`,
            quoteGuestCartManagementV1AssignCustomerPutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Enable an customer or guest user to create an empty cart and quote for an anonymous customer.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteGuestCartManagementV1CreateEmptyCartPost(observe?: 'body', reportProgress?: boolean): Observable<string>;
    public quoteGuestCartManagementV1CreateEmptyCartPost(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    public quoteGuestCartManagementV1CreateEmptyCartPost(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    public quoteGuestCartManagementV1CreateEmptyCartPost(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<string>(`${this.basePath}/V1/guest-carts`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Place an order for a specified cart.
     * @param cartId The cart ID.
     * @param quoteGuestCartManagementV1PlaceOrderPutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteGuestCartManagementV1PlaceOrderPut(cartId: string, quoteGuestCartManagementV1PlaceOrderPutBody?: QuoteGuestCartManagementV1PlaceOrderPutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public quoteGuestCartManagementV1PlaceOrderPut(cartId: string, quoteGuestCartManagementV1PlaceOrderPutBody?: QuoteGuestCartManagementV1PlaceOrderPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public quoteGuestCartManagementV1PlaceOrderPut(cartId: string, quoteGuestCartManagementV1PlaceOrderPutBody?: QuoteGuestCartManagementV1PlaceOrderPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public quoteGuestCartManagementV1PlaceOrderPut(cartId: string, quoteGuestCartManagementV1PlaceOrderPutBody?: QuoteGuestCartManagementV1PlaceOrderPutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteGuestCartManagementV1PlaceOrderPut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<number>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/order`,
            quoteGuestCartManagementV1PlaceOrderPutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
