/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { QuoteDataPaymentInterface } from '../model/quoteDataPaymentInterface';
import { QuoteDataPaymentMethodInterface } from '../model/quoteDataPaymentMethodInterface';
import { QuoteGuestPaymentMethodManagementV1SetPutBody } from '../model/quoteGuestPaymentMethodManagementV1SetPutBody';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class QuoteGuestPaymentMethodManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Return the payment method for a specified shopping cart.
     * @param cartId The cart ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteGuestPaymentMethodManagementV1GetGet(cartId: string, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataPaymentInterface>;
    public quoteGuestPaymentMethodManagementV1GetGet(cartId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataPaymentInterface>>;
    public quoteGuestPaymentMethodManagementV1GetGet(cartId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataPaymentInterface>>;
    public quoteGuestPaymentMethodManagementV1GetGet(cartId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteGuestPaymentMethodManagementV1GetGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<QuoteDataPaymentInterface>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/selected-payment-method`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * List available payment methods for a specified shopping cart. This call returns an array of objects, but detailed information about each object’s attributes might not be included.  See http://devdocs.magento.com/codelinks/attributes.html#GuestPaymentMethodManagementInterface to determine which call to use to get detailed information about all attributes for an object.
     * @param cartId The cart ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteGuestPaymentMethodManagementV1GetListGet(cartId: string, observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataPaymentMethodInterface>>;
    public quoteGuestPaymentMethodManagementV1GetListGet(cartId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataPaymentMethodInterface>>>;
    public quoteGuestPaymentMethodManagementV1GetListGet(cartId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataPaymentMethodInterface>>>;
    public quoteGuestPaymentMethodManagementV1GetListGet(cartId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteGuestPaymentMethodManagementV1GetListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<QuoteDataPaymentMethodInterface>>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/payment-methods`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Add a specified payment method to a specified shopping cart.
     * @param cartId The cart ID.
     * @param quoteGuestPaymentMethodManagementV1SetPutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteGuestPaymentMethodManagementV1SetPut(cartId: string, quoteGuestPaymentMethodManagementV1SetPutBody?: QuoteGuestPaymentMethodManagementV1SetPutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    public quoteGuestPaymentMethodManagementV1SetPut(cartId: string, quoteGuestPaymentMethodManagementV1SetPutBody?: QuoteGuestPaymentMethodManagementV1SetPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    public quoteGuestPaymentMethodManagementV1SetPut(cartId: string, quoteGuestPaymentMethodManagementV1SetPutBody?: QuoteGuestPaymentMethodManagementV1SetPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    public quoteGuestPaymentMethodManagementV1SetPut(cartId: string, quoteGuestPaymentMethodManagementV1SetPutBody?: QuoteGuestPaymentMethodManagementV1SetPutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteGuestPaymentMethodManagementV1SetPut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<number>(`${this.basePath}/V1/guest-carts/${encodeURIComponent(String(cartId))}/selected-payment-method`,
            quoteGuestPaymentMethodManagementV1SetPutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
