/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { QuoteDataShippingMethodInterface } from '../model/quoteDataShippingMethodInterface';
import { QuoteShippingMethodManagementV1EstimateByAddressIdPostBody } from '../model/quoteShippingMethodManagementV1EstimateByAddressIdPostBody';
import { QuoteShippingMethodManagementV1EstimateByAddressIdPostBody1 } from '../model/quoteShippingMethodManagementV1EstimateByAddressIdPostBody1';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class QuoteShippingMethodManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Estimate shipping
     * @param cartId The shopping cart ID.
     * @param quoteShippingMethodManagementV1EstimateByAddressIdPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteShippingMethodManagementV1EstimateByAddressIdPost(cartId: number, quoteShippingMethodManagementV1EstimateByAddressIdPostBody?: QuoteShippingMethodManagementV1EstimateByAddressIdPostBody, observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataShippingMethodInterface>>;
    public quoteShippingMethodManagementV1EstimateByAddressIdPost(cartId: number, quoteShippingMethodManagementV1EstimateByAddressIdPostBody?: QuoteShippingMethodManagementV1EstimateByAddressIdPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataShippingMethodInterface>>>;
    public quoteShippingMethodManagementV1EstimateByAddressIdPost(cartId: number, quoteShippingMethodManagementV1EstimateByAddressIdPostBody?: QuoteShippingMethodManagementV1EstimateByAddressIdPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataShippingMethodInterface>>>;
    public quoteShippingMethodManagementV1EstimateByAddressIdPost(cartId: number, quoteShippingMethodManagementV1EstimateByAddressIdPostBody?: QuoteShippingMethodManagementV1EstimateByAddressIdPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteShippingMethodManagementV1EstimateByAddressIdPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<Array<QuoteDataShippingMethodInterface>>(`${this.basePath}/V1/carts/${encodeURIComponent(String(cartId))}/estimate-shipping-methods-by-address-id`,
            quoteShippingMethodManagementV1EstimateByAddressIdPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Estimate shipping
     * @param quoteShippingMethodManagementV1EstimateByAddressIdPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteShippingMethodManagementV1EstimateByAddressIdPost_1(quoteShippingMethodManagementV1EstimateByAddressIdPostBody?: QuoteShippingMethodManagementV1EstimateByAddressIdPostBody1, observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataShippingMethodInterface>>;
    public quoteShippingMethodManagementV1EstimateByAddressIdPost_1(quoteShippingMethodManagementV1EstimateByAddressIdPostBody?: QuoteShippingMethodManagementV1EstimateByAddressIdPostBody1, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataShippingMethodInterface>>>;
    public quoteShippingMethodManagementV1EstimateByAddressIdPost_1(quoteShippingMethodManagementV1EstimateByAddressIdPostBody?: QuoteShippingMethodManagementV1EstimateByAddressIdPostBody1, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataShippingMethodInterface>>>;
    public quoteShippingMethodManagementV1EstimateByAddressIdPost_1(quoteShippingMethodManagementV1EstimateByAddressIdPostBody?: QuoteShippingMethodManagementV1EstimateByAddressIdPostBody1, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<Array<QuoteDataShippingMethodInterface>>(`${this.basePath}/V1/carts/mine/estimate-shipping-methods-by-address-id`,
            quoteShippingMethodManagementV1EstimateByAddressIdPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Lists applicable shipping methods for a specified quote.
     * @param cartId The shopping cart ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteShippingMethodManagementV1GetListGet(cartId: number, observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataShippingMethodInterface>>;
    public quoteShippingMethodManagementV1GetListGet(cartId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataShippingMethodInterface>>>;
    public quoteShippingMethodManagementV1GetListGet(cartId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataShippingMethodInterface>>>;
    public quoteShippingMethodManagementV1GetListGet(cartId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (cartId === null || cartId === undefined) {
            throw new Error('Required parameter cartId was null or undefined when calling quoteShippingMethodManagementV1GetListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<QuoteDataShippingMethodInterface>>(`${this.basePath}/V1/carts/${encodeURIComponent(String(cartId))}/shipping-methods`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Lists applicable shipping methods for a specified quote.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public quoteShippingMethodManagementV1GetListGet_2(observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataShippingMethodInterface>>;
    public quoteShippingMethodManagementV1GetListGet_2(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataShippingMethodInterface>>>;
    public quoteShippingMethodManagementV1GetListGet_2(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataShippingMethodInterface>>>;
    public quoteShippingMethodManagementV1GetListGet_2(observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<Array<QuoteDataShippingMethodInterface>>(`${this.basePath}/V1/carts/mine/shipping-methods`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
