/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { SalesCreditmemoManagementV1RefundPostBody } from '../model/salesCreditmemoManagementV1RefundPostBody';
import { SalesDataCreditmemoCommentSearchResultInterface } from '../model/salesDataCreditmemoCommentSearchResultInterface';
import { SalesDataCreditmemoInterface } from '../model/salesDataCreditmemoInterface';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class SalesCreditmemoManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Cancels a specified credit memo.
     * @param id The credit memo ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesCreditmemoManagementV1CancelPut(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public salesCreditmemoManagementV1CancelPut(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public salesCreditmemoManagementV1CancelPut(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public salesCreditmemoManagementV1CancelPut(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesCreditmemoManagementV1CancelPut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.put<boolean>(`${this.basePath}/V1/creditmemo/${encodeURIComponent(String(id))}`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Lists comments for a specified credit memo.
     * @param id The credit memo ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesCreditmemoManagementV1GetCommentsListGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataCreditmemoCommentSearchResultInterface>;
    public salesCreditmemoManagementV1GetCommentsListGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataCreditmemoCommentSearchResultInterface>>;
    public salesCreditmemoManagementV1GetCommentsListGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataCreditmemoCommentSearchResultInterface>>;
    public salesCreditmemoManagementV1GetCommentsListGet(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesCreditmemoManagementV1GetCommentsListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<SalesDataCreditmemoCommentSearchResultInterface>(`${this.basePath}/V1/creditmemo/${encodeURIComponent(String(id))}/comments`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Emails a user a specified credit memo.
     * @param id The credit memo ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesCreditmemoManagementV1NotifyPost(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public salesCreditmemoManagementV1NotifyPost(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public salesCreditmemoManagementV1NotifyPost(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public salesCreditmemoManagementV1NotifyPost(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesCreditmemoManagementV1NotifyPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<boolean>(`${this.basePath}/V1/creditmemo/${encodeURIComponent(String(id))}/emails`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Prepare creditmemo to refund and save it.
     * @param salesCreditmemoManagementV1RefundPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesCreditmemoManagementV1RefundPost(salesCreditmemoManagementV1RefundPostBody?: SalesCreditmemoManagementV1RefundPostBody, observe?: 'body', reportProgress?: boolean): Observable<SalesDataCreditmemoInterface>;
    public salesCreditmemoManagementV1RefundPost(salesCreditmemoManagementV1RefundPostBody?: SalesCreditmemoManagementV1RefundPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataCreditmemoInterface>>;
    public salesCreditmemoManagementV1RefundPost(salesCreditmemoManagementV1RefundPostBody?: SalesCreditmemoManagementV1RefundPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataCreditmemoInterface>>;
    public salesCreditmemoManagementV1RefundPost(salesCreditmemoManagementV1RefundPostBody?: SalesCreditmemoManagementV1RefundPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<SalesDataCreditmemoInterface>(`${this.basePath}/V1/creditmemo/refund`,
            salesCreditmemoManagementV1RefundPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
