/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { SalesDataOrderStatusHistorySearchResultInterface } from '../model/salesDataOrderStatusHistorySearchResultInterface';
import { SalesOrderManagementV1AddCommentPostBody } from '../model/salesOrderManagementV1AddCommentPostBody';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class SalesOrderManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Adds a comment to a specified order.
     * @param id The order ID.
     * @param salesOrderManagementV1AddCommentPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesOrderManagementV1AddCommentPost(id: number, salesOrderManagementV1AddCommentPostBody?: SalesOrderManagementV1AddCommentPostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public salesOrderManagementV1AddCommentPost(id: number, salesOrderManagementV1AddCommentPostBody?: SalesOrderManagementV1AddCommentPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public salesOrderManagementV1AddCommentPost(id: number, salesOrderManagementV1AddCommentPostBody?: SalesOrderManagementV1AddCommentPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public salesOrderManagementV1AddCommentPost(id: number, salesOrderManagementV1AddCommentPostBody?: SalesOrderManagementV1AddCommentPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesOrderManagementV1AddCommentPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<boolean>(`${this.basePath}/V1/orders/${encodeURIComponent(String(id))}/comments`,
            salesOrderManagementV1AddCommentPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Cancels a specified order.
     * @param id The order ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesOrderManagementV1CancelPost(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public salesOrderManagementV1CancelPost(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public salesOrderManagementV1CancelPost(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public salesOrderManagementV1CancelPost(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesOrderManagementV1CancelPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<boolean>(`${this.basePath}/V1/orders/${encodeURIComponent(String(id))}/cancel`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Lists comments for a specified order.
     * @param id The order ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesOrderManagementV1GetCommentsListGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataOrderStatusHistorySearchResultInterface>;
    public salesOrderManagementV1GetCommentsListGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataOrderStatusHistorySearchResultInterface>>;
    public salesOrderManagementV1GetCommentsListGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataOrderStatusHistorySearchResultInterface>>;
    public salesOrderManagementV1GetCommentsListGet(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesOrderManagementV1GetCommentsListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<SalesDataOrderStatusHistorySearchResultInterface>(`${this.basePath}/V1/orders/${encodeURIComponent(String(id))}/comments`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Gets the status for a specified order.
     * @param id The order ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesOrderManagementV1GetStatusGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<string>;
    public salesOrderManagementV1GetStatusGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    public salesOrderManagementV1GetStatusGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    public salesOrderManagementV1GetStatusGet(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesOrderManagementV1GetStatusGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<string>(`${this.basePath}/V1/orders/${encodeURIComponent(String(id))}/statuses`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Holds a specified order.
     * @param id The order ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesOrderManagementV1HoldPost(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public salesOrderManagementV1HoldPost(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public salesOrderManagementV1HoldPost(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public salesOrderManagementV1HoldPost(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesOrderManagementV1HoldPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<boolean>(`${this.basePath}/V1/orders/${encodeURIComponent(String(id))}/hold`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Emails a user a specified order.
     * @param id The order ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesOrderManagementV1NotifyPost(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public salesOrderManagementV1NotifyPost(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public salesOrderManagementV1NotifyPost(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public salesOrderManagementV1NotifyPost(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesOrderManagementV1NotifyPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<boolean>(`${this.basePath}/V1/orders/${encodeURIComponent(String(id))}/emails`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Releases a specified order from hold status.
     * @param id The order ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesOrderManagementV1UnHoldPost(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public salesOrderManagementV1UnHoldPost(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public salesOrderManagementV1UnHoldPost(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public salesOrderManagementV1UnHoldPost(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesOrderManagementV1UnHoldPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<boolean>(`${this.basePath}/V1/orders/${encodeURIComponent(String(id))}/unhold`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
