/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { SalesRuleCouponManagementV1DeleteByCodesPostBody } from '../model/salesRuleCouponManagementV1DeleteByCodesPostBody';
import { SalesRuleCouponManagementV1DeleteByIdsPostBody } from '../model/salesRuleCouponManagementV1DeleteByIdsPostBody';
import { SalesRuleCouponManagementV1GeneratePostBody } from '../model/salesRuleCouponManagementV1GeneratePostBody';
import { SalesRuleDataCouponMassDeleteResultInterface } from '../model/salesRuleDataCouponMassDeleteResultInterface';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class SalesRuleCouponManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Delete coupon by coupon codes.
     * @param salesRuleCouponManagementV1DeleteByCodesPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesRuleCouponManagementV1DeleteByCodesPost(salesRuleCouponManagementV1DeleteByCodesPostBody?: SalesRuleCouponManagementV1DeleteByCodesPostBody, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataCouponMassDeleteResultInterface>;
    public salesRuleCouponManagementV1DeleteByCodesPost(salesRuleCouponManagementV1DeleteByCodesPostBody?: SalesRuleCouponManagementV1DeleteByCodesPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataCouponMassDeleteResultInterface>>;
    public salesRuleCouponManagementV1DeleteByCodesPost(salesRuleCouponManagementV1DeleteByCodesPostBody?: SalesRuleCouponManagementV1DeleteByCodesPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataCouponMassDeleteResultInterface>>;
    public salesRuleCouponManagementV1DeleteByCodesPost(salesRuleCouponManagementV1DeleteByCodesPostBody?: SalesRuleCouponManagementV1DeleteByCodesPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<SalesRuleDataCouponMassDeleteResultInterface>(`${this.basePath}/V1/coupons/deleteByCodes`,
            salesRuleCouponManagementV1DeleteByCodesPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Delete coupon by coupon ids.
     * @param salesRuleCouponManagementV1DeleteByIdsPostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesRuleCouponManagementV1DeleteByIdsPost(salesRuleCouponManagementV1DeleteByIdsPostBody?: SalesRuleCouponManagementV1DeleteByIdsPostBody, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataCouponMassDeleteResultInterface>;
    public salesRuleCouponManagementV1DeleteByIdsPost(salesRuleCouponManagementV1DeleteByIdsPostBody?: SalesRuleCouponManagementV1DeleteByIdsPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataCouponMassDeleteResultInterface>>;
    public salesRuleCouponManagementV1DeleteByIdsPost(salesRuleCouponManagementV1DeleteByIdsPostBody?: SalesRuleCouponManagementV1DeleteByIdsPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataCouponMassDeleteResultInterface>>;
    public salesRuleCouponManagementV1DeleteByIdsPost(salesRuleCouponManagementV1DeleteByIdsPostBody?: SalesRuleCouponManagementV1DeleteByIdsPostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<SalesRuleDataCouponMassDeleteResultInterface>(`${this.basePath}/V1/coupons/deleteByIds`,
            salesRuleCouponManagementV1DeleteByIdsPostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Generate coupon for a rule
     * @param salesRuleCouponManagementV1GeneratePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesRuleCouponManagementV1GeneratePost(salesRuleCouponManagementV1GeneratePostBody?: SalesRuleCouponManagementV1GeneratePostBody, observe?: 'body', reportProgress?: boolean): Observable<Array<string>>;
    public salesRuleCouponManagementV1GeneratePost(salesRuleCouponManagementV1GeneratePostBody?: SalesRuleCouponManagementV1GeneratePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<string>>>;
    public salesRuleCouponManagementV1GeneratePost(salesRuleCouponManagementV1GeneratePostBody?: SalesRuleCouponManagementV1GeneratePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<string>>>;
    public salesRuleCouponManagementV1GeneratePost(salesRuleCouponManagementV1GeneratePostBody?: SalesRuleCouponManagementV1GeneratePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<Array<string>>(`${this.basePath}/V1/coupons/generate`,
            salesRuleCouponManagementV1GeneratePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
