/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { SalesRuleCouponRepositoryV1SavePostBody } from '../model/salesRuleCouponRepositoryV1SavePostBody';
import { SalesRuleCouponRepositoryV1SavePutBody } from '../model/salesRuleCouponRepositoryV1SavePutBody';
import { SalesRuleDataCouponInterface } from '../model/salesRuleDataCouponInterface';
import { SalesRuleDataCouponSearchResultInterface } from '../model/salesRuleDataCouponSearchResultInterface';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class SalesRuleCouponRepositoryV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Delete coupon by coupon id.
     * @param couponId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesRuleCouponRepositoryV1DeleteByIdDelete(couponId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public salesRuleCouponRepositoryV1DeleteByIdDelete(couponId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public salesRuleCouponRepositoryV1DeleteByIdDelete(couponId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public salesRuleCouponRepositoryV1DeleteByIdDelete(couponId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (couponId === null || couponId === undefined) {
            throw new Error('Required parameter couponId was null or undefined when calling salesRuleCouponRepositoryV1DeleteByIdDelete.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.delete<boolean>(`${this.basePath}/V1/coupons/${encodeURIComponent(String(couponId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Get coupon by coupon id.
     * @param couponId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesRuleCouponRepositoryV1GetByIdGet(couponId: number, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataCouponInterface>;
    public salesRuleCouponRepositoryV1GetByIdGet(couponId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataCouponInterface>>;
    public salesRuleCouponRepositoryV1GetByIdGet(couponId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataCouponInterface>>;
    public salesRuleCouponRepositoryV1GetByIdGet(couponId: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (couponId === null || couponId === undefined) {
            throw new Error('Required parameter couponId was null or undefined when calling salesRuleCouponRepositoryV1GetByIdGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<SalesRuleDataCouponInterface>(`${this.basePath}/V1/coupons/${encodeURIComponent(String(couponId))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Retrieve a coupon using the specified search criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#CouponRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.
     * @param searchCriteriaFilterGroupsFiltersField Field
     * @param searchCriteriaFilterGroupsFiltersValue Value
     * @param searchCriteriaFilterGroupsFiltersConditionType Condition type
     * @param searchCriteriaSortOrdersField Sorting field.
     * @param searchCriteriaSortOrdersDirection Sorting direction.
     * @param searchCriteriaPageSize Page size.
     * @param searchCriteriaCurrentPage Current page.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesRuleCouponRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataCouponSearchResultInterface>;
    public salesRuleCouponRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataCouponSearchResultInterface>>;
    public salesRuleCouponRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataCouponSearchResultInterface>>;
    public salesRuleCouponRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (searchCriteriaFilterGroupsFiltersField !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[filterGroups][][filters][][field]', <any>searchCriteriaFilterGroupsFiltersField);
        }
        if (searchCriteriaFilterGroupsFiltersValue !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[filterGroups][][filters][][value]', <any>searchCriteriaFilterGroupsFiltersValue);
        }
        if (searchCriteriaFilterGroupsFiltersConditionType !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[filterGroups][][filters][][conditionType]', <any>searchCriteriaFilterGroupsFiltersConditionType);
        }
        if (searchCriteriaSortOrdersField !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[sortOrders][][field]', <any>searchCriteriaSortOrdersField);
        }
        if (searchCriteriaSortOrdersDirection !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[sortOrders][][direction]', <any>searchCriteriaSortOrdersDirection);
        }
        if (searchCriteriaPageSize !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[pageSize]', <any>searchCriteriaPageSize);
        }
        if (searchCriteriaCurrentPage !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[currentPage]', <any>searchCriteriaCurrentPage);
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<SalesRuleDataCouponSearchResultInterface>(`${this.basePath}/V1/coupons/search`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Save a coupon.
     * @param salesRuleCouponRepositoryV1SavePostBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesRuleCouponRepositoryV1SavePost(salesRuleCouponRepositoryV1SavePostBody?: SalesRuleCouponRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataCouponInterface>;
    public salesRuleCouponRepositoryV1SavePost(salesRuleCouponRepositoryV1SavePostBody?: SalesRuleCouponRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataCouponInterface>>;
    public salesRuleCouponRepositoryV1SavePost(salesRuleCouponRepositoryV1SavePostBody?: SalesRuleCouponRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataCouponInterface>>;
    public salesRuleCouponRepositoryV1SavePost(salesRuleCouponRepositoryV1SavePostBody?: SalesRuleCouponRepositoryV1SavePostBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.post<SalesRuleDataCouponInterface>(`${this.basePath}/V1/coupons`,
            salesRuleCouponRepositoryV1SavePostBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Save a coupon.
     * @param couponId 
     * @param salesRuleCouponRepositoryV1SavePutBody 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesRuleCouponRepositoryV1SavePut(couponId: string, salesRuleCouponRepositoryV1SavePutBody?: SalesRuleCouponRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataCouponInterface>;
    public salesRuleCouponRepositoryV1SavePut(couponId: string, salesRuleCouponRepositoryV1SavePutBody?: SalesRuleCouponRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataCouponInterface>>;
    public salesRuleCouponRepositoryV1SavePut(couponId: string, salesRuleCouponRepositoryV1SavePutBody?: SalesRuleCouponRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataCouponInterface>>;
    public salesRuleCouponRepositoryV1SavePut(couponId: string, salesRuleCouponRepositoryV1SavePutBody?: SalesRuleCouponRepositoryV1SavePutBody, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (couponId === null || couponId === undefined) {
            throw new Error('Required parameter couponId was null or undefined when calling salesRuleCouponRepositoryV1SavePut.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];
        let httpContentTypeSelected:string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }

        return this.httpClient.put<SalesRuleDataCouponInterface>(`${this.basePath}/V1/coupons/${encodeURIComponent(String(couponId))}`,
            salesRuleCouponRepositoryV1SavePutBody,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
