/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs/Observable';

import { ErrorResponse } from '../model/errorResponse';
import { SalesDataShipmentCommentSearchResultInterface } from '../model/salesDataShipmentCommentSearchResultInterface';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class SalesShipmentManagementV1Service {

    protected basePath = 'http://shop.sergiofabbri.com/rest';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (let consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * Lists comments for a specified shipment.
     * @param id The shipment ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesShipmentManagementV1GetCommentsListGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataShipmentCommentSearchResultInterface>;
    public salesShipmentManagementV1GetCommentsListGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataShipmentCommentSearchResultInterface>>;
    public salesShipmentManagementV1GetCommentsListGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataShipmentCommentSearchResultInterface>>;
    public salesShipmentManagementV1GetCommentsListGet(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesShipmentManagementV1GetCommentsListGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<SalesDataShipmentCommentSearchResultInterface>(`${this.basePath}/V1/shipment/${encodeURIComponent(String(id))}/comments`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Gets a specified shipment label.
     * @param id The shipment label ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesShipmentManagementV1GetLabelGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<string>;
    public salesShipmentManagementV1GetLabelGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    public salesShipmentManagementV1GetLabelGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    public salesShipmentManagementV1GetLabelGet(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesShipmentManagementV1GetLabelGet.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.get<string>(`${this.basePath}/V1/shipment/${encodeURIComponent(String(id))}/label`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * Emails user a specified shipment.
     * @param id The shipment ID.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public salesShipmentManagementV1NotifyPost(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    public salesShipmentManagementV1NotifyPost(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    public salesShipmentManagementV1NotifyPost(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    public salesShipmentManagementV1NotifyPost(id: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling salesShipmentManagementV1NotifyPost.');
        }

        let headers = this.defaultHeaders;

        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
        ];
        let httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        return this.httpClient.post<boolean>(`${this.basePath}/V1/shipment/${encodeURIComponent(String(id))}/emails`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
