import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { BundleDataLinkInterface } from '../model/bundleDataLinkInterface';
import { BundleProductLinkManagementV1AddChildByProductSkuPostBody } from '../model/bundleProductLinkManagementV1AddChildByProductSkuPostBody';
import { BundleProductLinkManagementV1SaveChildPutBody } from '../model/bundleProductLinkManagementV1SaveChildPutBody';
import { Configuration } from '../configuration';
export declare class BundleProductLinkManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    bundleProductLinkManagementV1AddChildByProductSkuPost(sku: string, optionId: number, bundleProductLinkManagementV1AddChildByProductSkuPostBody?: BundleProductLinkManagementV1AddChildByProductSkuPostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    bundleProductLinkManagementV1AddChildByProductSkuPost(sku: string, optionId: number, bundleProductLinkManagementV1AddChildByProductSkuPostBody?: BundleProductLinkManagementV1AddChildByProductSkuPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    bundleProductLinkManagementV1AddChildByProductSkuPost(sku: string, optionId: number, bundleProductLinkManagementV1AddChildByProductSkuPostBody?: BundleProductLinkManagementV1AddChildByProductSkuPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    bundleProductLinkManagementV1GetChildrenGet(productSku: string, optionId?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<BundleDataLinkInterface>>;
    bundleProductLinkManagementV1GetChildrenGet(productSku: string, optionId?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<BundleDataLinkInterface>>>;
    bundleProductLinkManagementV1GetChildrenGet(productSku: string, optionId?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<BundleDataLinkInterface>>>;
    bundleProductLinkManagementV1RemoveChildDelete(sku: string, optionId: number, childSku: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    bundleProductLinkManagementV1RemoveChildDelete(sku: string, optionId: number, childSku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    bundleProductLinkManagementV1RemoveChildDelete(sku: string, optionId: number, childSku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    bundleProductLinkManagementV1SaveChildPut(sku: string, id: string, bundleProductLinkManagementV1SaveChildPutBody?: BundleProductLinkManagementV1SaveChildPutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    bundleProductLinkManagementV1SaveChildPut(sku: string, id: string, bundleProductLinkManagementV1SaveChildPutBody?: BundleProductLinkManagementV1SaveChildPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    bundleProductLinkManagementV1SaveChildPut(sku: string, id: string, bundleProductLinkManagementV1SaveChildPutBody?: BundleProductLinkManagementV1SaveChildPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
