var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Inject, Injectable, Optional } from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams } from '@angular/common/http';
import { CustomHttpUrlEncodingCodec } from '../encoder';
import { BASE_PATH } from '../variables';
import { Configuration } from '../configuration';
var BundleProductLinkManagementV1Service = (function () {
    function BundleProductLinkManagementV1Service(httpClient, basePath, configuration) {
        this.httpClient = httpClient;
        this.basePath = 'http://shop.sergiofabbri.com/rest';
        this.defaultHeaders = new HttpHeaders();
        this.configuration = new Configuration();
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }
    BundleProductLinkManagementV1Service.prototype.canConsumeForm = function (consumes) {
        var form = 'multipart/form-data';
        for (var _i = 0, consumes_1 = consumes; _i < consumes_1.length; _i++) {
            var consume = consumes_1[_i];
            if (form === consume) {
                return true;
            }
        }
        return false;
    };
    BundleProductLinkManagementV1Service.prototype.bundleProductLinkManagementV1AddChildByProductSkuPost = function (sku, optionId, bundleProductLinkManagementV1AddChildByProductSkuPostBody, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling bundleProductLinkManagementV1AddChildByProductSkuPost.');
        }
        if (optionId === null || optionId === undefined) {
            throw new Error('Required parameter optionId was null or undefined when calling bundleProductLinkManagementV1AddChildByProductSkuPost.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }
        return this.httpClient.post(this.basePath + "/V1/bundle-products/" + encodeURIComponent(String(sku)) + "/links/" + encodeURIComponent(String(optionId)), bundleProductLinkManagementV1AddChildByProductSkuPostBody, {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    BundleProductLinkManagementV1Service.prototype.bundleProductLinkManagementV1GetChildrenGet = function (productSku, optionId, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (productSku === null || productSku === undefined) {
            throw new Error('Required parameter productSku was null or undefined when calling bundleProductLinkManagementV1GetChildrenGet.');
        }
        var queryParameters = new HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
        if (optionId !== undefined) {
            queryParameters = queryParameters.set('optionId', optionId);
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        return this.httpClient.get(this.basePath + "/V1/bundle-products/" + encodeURIComponent(String(productSku)) + "/children", {
            params: queryParameters,
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    BundleProductLinkManagementV1Service.prototype.bundleProductLinkManagementV1RemoveChildDelete = function (sku, optionId, childSku, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling bundleProductLinkManagementV1RemoveChildDelete.');
        }
        if (optionId === null || optionId === undefined) {
            throw new Error('Required parameter optionId was null or undefined when calling bundleProductLinkManagementV1RemoveChildDelete.');
        }
        if (childSku === null || childSku === undefined) {
            throw new Error('Required parameter childSku was null or undefined when calling bundleProductLinkManagementV1RemoveChildDelete.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        return this.httpClient.delete(this.basePath + "/V1/bundle-products/" + encodeURIComponent(String(sku)) + "/options/" + encodeURIComponent(String(optionId)) + "/children/" + encodeURIComponent(String(childSku)), {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    BundleProductLinkManagementV1Service.prototype.bundleProductLinkManagementV1SaveChildPut = function (sku, id, bundleProductLinkManagementV1SaveChildPutBody, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling bundleProductLinkManagementV1SaveChildPut.');
        }
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling bundleProductLinkManagementV1SaveChildPut.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }
        return this.httpClient.put(this.basePath + "/V1/bundle-products/" + encodeURIComponent(String(sku)) + "/links/" + encodeURIComponent(String(id)), bundleProductLinkManagementV1SaveChildPutBody, {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    BundleProductLinkManagementV1Service = __decorate([
        Injectable(),
        __param(1, Optional()), __param(1, Inject(BASE_PATH)), __param(2, Optional()),
        __metadata("design:paramtypes", [HttpClient, String, Configuration])
    ], BundleProductLinkManagementV1Service);
    return BundleProductLinkManagementV1Service;
}());
export { BundleProductLinkManagementV1Service };
//# sourceMappingURL=bundleProductLinkManagementV1.service.js.map