import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogAttributeSetRepositoryV1SavePutBody } from '../model/catalogAttributeSetRepositoryV1SavePutBody';
import { EavDataAttributeSetInterface } from '../model/eavDataAttributeSetInterface';
import { EavDataAttributeSetSearchResultsInterface } from '../model/eavDataAttributeSetSearchResultsInterface';
import { Configuration } from '../configuration';
export declare class CatalogAttributeSetRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogAttributeSetRepositoryV1DeleteByIdDelete(attributeSetId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogAttributeSetRepositoryV1DeleteByIdDelete(attributeSetId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogAttributeSetRepositoryV1DeleteByIdDelete(attributeSetId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogAttributeSetRepositoryV1GetGet(attributeSetId: number, observe?: 'body', reportProgress?: boolean): Observable<EavDataAttributeSetInterface>;
    catalogAttributeSetRepositoryV1GetGet(attributeSetId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EavDataAttributeSetInterface>>;
    catalogAttributeSetRepositoryV1GetGet(attributeSetId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EavDataAttributeSetInterface>>;
    catalogAttributeSetRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<EavDataAttributeSetSearchResultsInterface>;
    catalogAttributeSetRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EavDataAttributeSetSearchResultsInterface>>;
    catalogAttributeSetRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EavDataAttributeSetSearchResultsInterface>>;
    catalogAttributeSetRepositoryV1SavePut(attributeSetId: string, catalogAttributeSetRepositoryV1SavePutBody?: CatalogAttributeSetRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<EavDataAttributeSetInterface>;
    catalogAttributeSetRepositoryV1SavePut(attributeSetId: string, catalogAttributeSetRepositoryV1SavePutBody?: CatalogAttributeSetRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EavDataAttributeSetInterface>>;
    catalogAttributeSetRepositoryV1SavePut(attributeSetId: string, catalogAttributeSetRepositoryV1SavePutBody?: CatalogAttributeSetRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EavDataAttributeSetInterface>>;
}
