import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogDataCategoryAttributeInterface } from '../model/catalogDataCategoryAttributeInterface';
import { CatalogDataCategoryAttributeSearchResultsInterface } from '../model/catalogDataCategoryAttributeSearchResultsInterface';
import { Configuration } from '../configuration';
export declare class CatalogCategoryAttributeRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogCategoryAttributeRepositoryV1GetGet(attributeCode: string, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataCategoryAttributeInterface>;
    catalogCategoryAttributeRepositoryV1GetGet(attributeCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataCategoryAttributeInterface>>;
    catalogCategoryAttributeRepositoryV1GetGet(attributeCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataCategoryAttributeInterface>>;
    catalogCategoryAttributeRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataCategoryAttributeSearchResultsInterface>;
    catalogCategoryAttributeRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataCategoryAttributeSearchResultsInterface>>;
    catalogCategoryAttributeRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataCategoryAttributeSearchResultsInterface>>;
}
