import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogCategoryLinkRepositoryV1SavePostBody } from '../model/catalogCategoryLinkRepositoryV1SavePostBody';
import { CatalogCategoryLinkRepositoryV1SavePutBody } from '../model/catalogCategoryLinkRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class CatalogCategoryLinkRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogCategoryLinkRepositoryV1DeleteByIdsDelete(categoryId: string, sku: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogCategoryLinkRepositoryV1DeleteByIdsDelete(categoryId: string, sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogCategoryLinkRepositoryV1DeleteByIdsDelete(categoryId: string, sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogCategoryLinkRepositoryV1SavePost(categoryId: string, catalogCategoryLinkRepositoryV1SavePostBody?: CatalogCategoryLinkRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogCategoryLinkRepositoryV1SavePost(categoryId: string, catalogCategoryLinkRepositoryV1SavePostBody?: CatalogCategoryLinkRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogCategoryLinkRepositoryV1SavePost(categoryId: string, catalogCategoryLinkRepositoryV1SavePostBody?: CatalogCategoryLinkRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogCategoryLinkRepositoryV1SavePut(categoryId: string, catalogCategoryLinkRepositoryV1SavePutBody?: CatalogCategoryLinkRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogCategoryLinkRepositoryV1SavePut(categoryId: string, catalogCategoryLinkRepositoryV1SavePutBody?: CatalogCategoryLinkRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogCategoryLinkRepositoryV1SavePut(categoryId: string, catalogCategoryLinkRepositoryV1SavePutBody?: CatalogCategoryLinkRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
