import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogCategoryManagementV1MovePutBody } from '../model/catalogCategoryManagementV1MovePutBody';
import { CatalogDataCategoryTreeInterface } from '../model/catalogDataCategoryTreeInterface';
import { Configuration } from '../configuration';
export declare class CatalogCategoryManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogCategoryManagementV1GetTreeGet(rootCategoryId?: number, depth?: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataCategoryTreeInterface>;
    catalogCategoryManagementV1GetTreeGet(rootCategoryId?: number, depth?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataCategoryTreeInterface>>;
    catalogCategoryManagementV1GetTreeGet(rootCategoryId?: number, depth?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataCategoryTreeInterface>>;
    catalogCategoryManagementV1MovePut(categoryId: number, catalogCategoryManagementV1MovePutBody?: CatalogCategoryManagementV1MovePutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogCategoryManagementV1MovePut(categoryId: number, catalogCategoryManagementV1MovePutBody?: CatalogCategoryManagementV1MovePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogCategoryManagementV1MovePut(categoryId: number, catalogCategoryManagementV1MovePutBody?: CatalogCategoryManagementV1MovePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
