import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogCategoryRepositoryV1SavePostBody } from '../model/catalogCategoryRepositoryV1SavePostBody';
import { CatalogCategoryRepositoryV1SavePutBody } from '../model/catalogCategoryRepositoryV1SavePutBody';
import { CatalogDataCategoryInterface } from '../model/catalogDataCategoryInterface';
import { Configuration } from '../configuration';
export declare class CatalogCategoryRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogCategoryRepositoryV1DeleteByIdentifierDelete(categoryId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogCategoryRepositoryV1DeleteByIdentifierDelete(categoryId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogCategoryRepositoryV1DeleteByIdentifierDelete(categoryId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogCategoryRepositoryV1GetGet(categoryId: number, storeId?: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataCategoryInterface>;
    catalogCategoryRepositoryV1GetGet(categoryId: number, storeId?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataCategoryInterface>>;
    catalogCategoryRepositoryV1GetGet(categoryId: number, storeId?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataCategoryInterface>>;
    catalogCategoryRepositoryV1SavePost(catalogCategoryRepositoryV1SavePostBody?: CatalogCategoryRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataCategoryInterface>;
    catalogCategoryRepositoryV1SavePost(catalogCategoryRepositoryV1SavePostBody?: CatalogCategoryRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataCategoryInterface>>;
    catalogCategoryRepositoryV1SavePost(catalogCategoryRepositoryV1SavePostBody?: CatalogCategoryRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataCategoryInterface>>;
    catalogCategoryRepositoryV1SavePut(id: string, catalogCategoryRepositoryV1SavePutBody?: CatalogCategoryRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataCategoryInterface>;
    catalogCategoryRepositoryV1SavePut(id: string, catalogCategoryRepositoryV1SavePutBody?: CatalogCategoryRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataCategoryInterface>>;
    catalogCategoryRepositoryV1SavePut(id: string, catalogCategoryRepositoryV1SavePutBody?: CatalogCategoryRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataCategoryInterface>>;
}
