import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogCostStorageV1DeletePostBody } from '../model/catalogCostStorageV1DeletePostBody';
import { CatalogCostStorageV1GetPostBody } from '../model/catalogCostStorageV1GetPostBody';
import { CatalogCostStorageV1UpdatePostBody } from '../model/catalogCostStorageV1UpdatePostBody';
import { CatalogDataCostInterface } from '../model/catalogDataCostInterface';
import { CatalogDataPriceUpdateResultInterface } from '../model/catalogDataPriceUpdateResultInterface';
import { Configuration } from '../configuration';
export declare class CatalogCostStorageV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogCostStorageV1DeletePost(catalogCostStorageV1DeletePostBody?: CatalogCostStorageV1DeletePostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogCostStorageV1DeletePost(catalogCostStorageV1DeletePostBody?: CatalogCostStorageV1DeletePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogCostStorageV1DeletePost(catalogCostStorageV1DeletePostBody?: CatalogCostStorageV1DeletePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogCostStorageV1GetPost(catalogCostStorageV1GetPostBody?: CatalogCostStorageV1GetPostBody, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataCostInterface>>;
    catalogCostStorageV1GetPost(catalogCostStorageV1GetPostBody?: CatalogCostStorageV1GetPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataCostInterface>>>;
    catalogCostStorageV1GetPost(catalogCostStorageV1GetPostBody?: CatalogCostStorageV1GetPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataCostInterface>>>;
    catalogCostStorageV1UpdatePost(catalogCostStorageV1UpdatePostBody?: CatalogCostStorageV1UpdatePostBody, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataPriceUpdateResultInterface>>;
    catalogCostStorageV1UpdatePost(catalogCostStorageV1UpdatePostBody?: CatalogCostStorageV1UpdatePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataPriceUpdateResultInterface>>>;
    catalogCostStorageV1UpdatePost(catalogCostStorageV1UpdatePostBody?: CatalogCostStorageV1UpdatePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataPriceUpdateResultInterface>>>;
}
