import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogInventoryDataStockItemInterface } from '../model/catalogInventoryDataStockItemInterface';
import { CatalogInventoryDataStockStatusCollectionInterface } from '../model/catalogInventoryDataStockStatusCollectionInterface';
import { CatalogInventoryDataStockStatusInterface } from '../model/catalogInventoryDataStockStatusInterface';
import { CatalogInventoryStockRegistryV1UpdateStockItemBySkuPutBody } from '../model/catalogInventoryStockRegistryV1UpdateStockItemBySkuPutBody';
import { Configuration } from '../configuration';
export declare class CatalogInventoryStockRegistryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogInventoryStockRegistryV1GetLowStockItemsGet(scopeId: number, qty: number, currentPage?: number, pageSize?: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogInventoryDataStockStatusCollectionInterface>;
    catalogInventoryStockRegistryV1GetLowStockItemsGet(scopeId: number, qty: number, currentPage?: number, pageSize?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogInventoryDataStockStatusCollectionInterface>>;
    catalogInventoryStockRegistryV1GetLowStockItemsGet(scopeId: number, qty: number, currentPage?: number, pageSize?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogInventoryDataStockStatusCollectionInterface>>;
    catalogInventoryStockRegistryV1GetStockItemBySkuGet(productSku: string, scopeId?: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogInventoryDataStockItemInterface>;
    catalogInventoryStockRegistryV1GetStockItemBySkuGet(productSku: string, scopeId?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogInventoryDataStockItemInterface>>;
    catalogInventoryStockRegistryV1GetStockItemBySkuGet(productSku: string, scopeId?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogInventoryDataStockItemInterface>>;
    catalogInventoryStockRegistryV1GetStockStatusBySkuGet(productSku: string, scopeId?: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogInventoryDataStockStatusInterface>;
    catalogInventoryStockRegistryV1GetStockStatusBySkuGet(productSku: string, scopeId?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogInventoryDataStockStatusInterface>>;
    catalogInventoryStockRegistryV1GetStockStatusBySkuGet(productSku: string, scopeId?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogInventoryDataStockStatusInterface>>;
    catalogInventoryStockRegistryV1UpdateStockItemBySkuPut(productSku: string, itemId: string, catalogInventoryStockRegistryV1UpdateStockItemBySkuPutBody?: CatalogInventoryStockRegistryV1UpdateStockItemBySkuPutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    catalogInventoryStockRegistryV1UpdateStockItemBySkuPut(productSku: string, itemId: string, catalogInventoryStockRegistryV1UpdateStockItemBySkuPutBody?: CatalogInventoryStockRegistryV1UpdateStockItemBySkuPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    catalogInventoryStockRegistryV1UpdateStockItemBySkuPut(productSku: string, itemId: string, catalogInventoryStockRegistryV1UpdateStockItemBySkuPutBody?: CatalogInventoryStockRegistryV1UpdateStockItemBySkuPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
}
