import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogDataProductAttributeInterface } from '../model/catalogDataProductAttributeInterface';
import { CatalogProductAttributeManagementV1AssignPostBody } from '../model/catalogProductAttributeManagementV1AssignPostBody';
import { Configuration } from '../configuration';
export declare class CatalogProductAttributeManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogProductAttributeManagementV1AssignPost(catalogProductAttributeManagementV1AssignPostBody?: CatalogProductAttributeManagementV1AssignPostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    catalogProductAttributeManagementV1AssignPost(catalogProductAttributeManagementV1AssignPostBody?: CatalogProductAttributeManagementV1AssignPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    catalogProductAttributeManagementV1AssignPost(catalogProductAttributeManagementV1AssignPostBody?: CatalogProductAttributeManagementV1AssignPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    catalogProductAttributeManagementV1GetAttributesGet(attributeSetId: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductAttributeInterface>>;
    catalogProductAttributeManagementV1GetAttributesGet(attributeSetId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductAttributeInterface>>>;
    catalogProductAttributeManagementV1GetAttributesGet(attributeSetId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductAttributeInterface>>>;
    catalogProductAttributeManagementV1UnassignDelete(attributeSetId: string, attributeCode: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductAttributeManagementV1UnassignDelete(attributeSetId: string, attributeCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductAttributeManagementV1UnassignDelete(attributeSetId: string, attributeCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
