import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogDataProductAttributeMediaGalleryEntryInterface } from '../model/catalogDataProductAttributeMediaGalleryEntryInterface';
import { CatalogProductAttributeMediaGalleryManagementV1CreatePostBody } from '../model/catalogProductAttributeMediaGalleryManagementV1CreatePostBody';
import { CatalogProductAttributeMediaGalleryManagementV1UpdatePutBody } from '../model/catalogProductAttributeMediaGalleryManagementV1UpdatePutBody';
import { Configuration } from '../configuration';
export declare class CatalogProductAttributeMediaGalleryManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogProductAttributeMediaGalleryManagementV1CreatePost(sku: string, catalogProductAttributeMediaGalleryManagementV1CreatePostBody?: CatalogProductAttributeMediaGalleryManagementV1CreatePostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    catalogProductAttributeMediaGalleryManagementV1CreatePost(sku: string, catalogProductAttributeMediaGalleryManagementV1CreatePostBody?: CatalogProductAttributeMediaGalleryManagementV1CreatePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    catalogProductAttributeMediaGalleryManagementV1CreatePost(sku: string, catalogProductAttributeMediaGalleryManagementV1CreatePostBody?: CatalogProductAttributeMediaGalleryManagementV1CreatePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    catalogProductAttributeMediaGalleryManagementV1GetGet(sku: string, entryId: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductAttributeMediaGalleryEntryInterface>;
    catalogProductAttributeMediaGalleryManagementV1GetGet(sku: string, entryId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductAttributeMediaGalleryEntryInterface>>;
    catalogProductAttributeMediaGalleryManagementV1GetGet(sku: string, entryId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductAttributeMediaGalleryEntryInterface>>;
    catalogProductAttributeMediaGalleryManagementV1GetListGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductAttributeMediaGalleryEntryInterface>>;
    catalogProductAttributeMediaGalleryManagementV1GetListGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductAttributeMediaGalleryEntryInterface>>>;
    catalogProductAttributeMediaGalleryManagementV1GetListGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductAttributeMediaGalleryEntryInterface>>>;
    catalogProductAttributeMediaGalleryManagementV1RemoveDelete(sku: string, entryId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductAttributeMediaGalleryManagementV1RemoveDelete(sku: string, entryId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductAttributeMediaGalleryManagementV1RemoveDelete(sku: string, entryId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogProductAttributeMediaGalleryManagementV1UpdatePut(sku: string, entryId: string, catalogProductAttributeMediaGalleryManagementV1UpdatePutBody?: CatalogProductAttributeMediaGalleryManagementV1UpdatePutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductAttributeMediaGalleryManagementV1UpdatePut(sku: string, entryId: string, catalogProductAttributeMediaGalleryManagementV1UpdatePutBody?: CatalogProductAttributeMediaGalleryManagementV1UpdatePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductAttributeMediaGalleryManagementV1UpdatePut(sku: string, entryId: string, catalogProductAttributeMediaGalleryManagementV1UpdatePutBody?: CatalogProductAttributeMediaGalleryManagementV1UpdatePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
