import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogDataProductAttributeInterface } from '../model/catalogDataProductAttributeInterface';
import { CatalogDataProductAttributeSearchResultsInterface } from '../model/catalogDataProductAttributeSearchResultsInterface';
import { CatalogProductAttributeRepositoryV1SavePostBody } from '../model/catalogProductAttributeRepositoryV1SavePostBody';
import { CatalogProductAttributeRepositoryV1SavePutBody } from '../model/catalogProductAttributeRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class CatalogProductAttributeRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogProductAttributeRepositoryV1DeleteByIdDelete(attributeCode: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductAttributeRepositoryV1DeleteByIdDelete(attributeCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductAttributeRepositoryV1DeleteByIdDelete(attributeCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogProductAttributeRepositoryV1GetGet(attributeCode: string, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductAttributeInterface>;
    catalogProductAttributeRepositoryV1GetGet(attributeCode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductAttributeInterface>>;
    catalogProductAttributeRepositoryV1GetGet(attributeCode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductAttributeInterface>>;
    catalogProductAttributeRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductAttributeSearchResultsInterface>;
    catalogProductAttributeRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductAttributeSearchResultsInterface>>;
    catalogProductAttributeRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductAttributeSearchResultsInterface>>;
    catalogProductAttributeRepositoryV1SavePost(catalogProductAttributeRepositoryV1SavePostBody?: CatalogProductAttributeRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductAttributeInterface>;
    catalogProductAttributeRepositoryV1SavePost(catalogProductAttributeRepositoryV1SavePostBody?: CatalogProductAttributeRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductAttributeInterface>>;
    catalogProductAttributeRepositoryV1SavePost(catalogProductAttributeRepositoryV1SavePostBody?: CatalogProductAttributeRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductAttributeInterface>>;
    catalogProductAttributeRepositoryV1SavePut(attributeCode: string, catalogProductAttributeRepositoryV1SavePutBody?: CatalogProductAttributeRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductAttributeInterface>;
    catalogProductAttributeRepositoryV1SavePut(attributeCode: string, catalogProductAttributeRepositoryV1SavePutBody?: CatalogProductAttributeRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductAttributeInterface>>;
    catalogProductAttributeRepositoryV1SavePut(attributeCode: string, catalogProductAttributeRepositoryV1SavePutBody?: CatalogProductAttributeRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductAttributeInterface>>;
}
