import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogDataProductCustomOptionInterface } from '../model/catalogDataProductCustomOptionInterface';
import { CatalogProductCustomOptionRepositoryV1SavePostBody } from '../model/catalogProductCustomOptionRepositoryV1SavePostBody';
import { CatalogProductCustomOptionRepositoryV1SavePutBody } from '../model/catalogProductCustomOptionRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class CatalogProductCustomOptionRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogProductCustomOptionRepositoryV1DeleteByIdentifierDelete(sku: string, optionId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductCustomOptionRepositoryV1DeleteByIdentifierDelete(sku: string, optionId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductCustomOptionRepositoryV1DeleteByIdentifierDelete(sku: string, optionId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogProductCustomOptionRepositoryV1GetGet(sku: string, optionId: number, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductCustomOptionInterface>;
    catalogProductCustomOptionRepositoryV1GetGet(sku: string, optionId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductCustomOptionInterface>>;
    catalogProductCustomOptionRepositoryV1GetGet(sku: string, optionId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductCustomOptionInterface>>;
    catalogProductCustomOptionRepositoryV1GetListGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductCustomOptionInterface>>;
    catalogProductCustomOptionRepositoryV1GetListGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductCustomOptionInterface>>>;
    catalogProductCustomOptionRepositoryV1GetListGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductCustomOptionInterface>>>;
    catalogProductCustomOptionRepositoryV1SavePost(catalogProductCustomOptionRepositoryV1SavePostBody?: CatalogProductCustomOptionRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductCustomOptionInterface>;
    catalogProductCustomOptionRepositoryV1SavePost(catalogProductCustomOptionRepositoryV1SavePostBody?: CatalogProductCustomOptionRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductCustomOptionInterface>>;
    catalogProductCustomOptionRepositoryV1SavePost(catalogProductCustomOptionRepositoryV1SavePostBody?: CatalogProductCustomOptionRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductCustomOptionInterface>>;
    catalogProductCustomOptionRepositoryV1SavePut(optionId: string, catalogProductCustomOptionRepositoryV1SavePutBody?: CatalogProductCustomOptionRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<CatalogDataProductCustomOptionInterface>;
    catalogProductCustomOptionRepositoryV1SavePut(optionId: string, catalogProductCustomOptionRepositoryV1SavePutBody?: CatalogProductCustomOptionRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CatalogDataProductCustomOptionInterface>>;
    catalogProductCustomOptionRepositoryV1SavePut(optionId: string, catalogProductCustomOptionRepositoryV1SavePutBody?: CatalogProductCustomOptionRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CatalogDataProductCustomOptionInterface>>;
}
