import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogDataProductLinkInterface } from '../model/catalogDataProductLinkInterface';
import { CatalogProductLinkManagementV1SetProductLinksPostBody } from '../model/catalogProductLinkManagementV1SetProductLinksPostBody';
import { Configuration } from '../configuration';
export declare class CatalogProductLinkManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogProductLinkManagementV1GetLinkedItemsByTypeGet(sku: string, type: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductLinkInterface>>;
    catalogProductLinkManagementV1GetLinkedItemsByTypeGet(sku: string, type: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductLinkInterface>>>;
    catalogProductLinkManagementV1GetLinkedItemsByTypeGet(sku: string, type: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductLinkInterface>>>;
    catalogProductLinkManagementV1SetProductLinksPost(sku: string, catalogProductLinkManagementV1SetProductLinksPostBody?: CatalogProductLinkManagementV1SetProductLinksPostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductLinkManagementV1SetProductLinksPost(sku: string, catalogProductLinkManagementV1SetProductLinksPostBody?: CatalogProductLinkManagementV1SetProductLinksPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductLinkManagementV1SetProductLinksPost(sku: string, catalogProductLinkManagementV1SetProductLinksPostBody?: CatalogProductLinkManagementV1SetProductLinksPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
