var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Inject, Injectable, Optional } from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams } from '@angular/common/http';
import { CustomHttpUrlEncodingCodec } from '../encoder';
import { BASE_PATH } from '../variables';
import { Configuration } from '../configuration';
var CatalogProductRepositoryV1Service = (function () {
    function CatalogProductRepositoryV1Service(httpClient, basePath, configuration) {
        this.httpClient = httpClient;
        this.basePath = 'http://shop.sergiofabbri.com/rest';
        this.defaultHeaders = new HttpHeaders();
        this.configuration = new Configuration();
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }
    CatalogProductRepositoryV1Service.prototype.canConsumeForm = function (consumes) {
        var form = 'multipart/form-data';
        for (var _i = 0, consumes_1 = consumes; _i < consumes_1.length; _i++) {
            var consume = consumes_1[_i];
            if (form === consume) {
                return true;
            }
        }
        return false;
    };
    CatalogProductRepositoryV1Service.prototype.catalogProductRepositoryV1DeleteByIdDelete = function (sku, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductRepositoryV1DeleteByIdDelete.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        return this.httpClient.delete(this.basePath + "/V1/products/" + encodeURIComponent(String(sku)), {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    CatalogProductRepositoryV1Service.prototype.catalogProductRepositoryV1GetGet = function (sku, editMode, storeId, forceReload, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductRepositoryV1GetGet.');
        }
        var queryParameters = new HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
        if (editMode !== undefined) {
            queryParameters = queryParameters.set('editMode', editMode);
        }
        if (storeId !== undefined) {
            queryParameters = queryParameters.set('storeId', storeId);
        }
        if (forceReload !== undefined) {
            queryParameters = queryParameters.set('forceReload', forceReload);
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        return this.httpClient.get(this.basePath + "/V1/products/" + encodeURIComponent(String(sku)), {
            params: queryParameters,
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    CatalogProductRepositoryV1Service.prototype.catalogProductRepositoryV1GetListGet = function (searchCriteriaFilterGroupsFiltersField, searchCriteriaFilterGroupsFiltersValue, searchCriteriaFilterGroupsFiltersConditionType, searchCriteriaSortOrdersField, searchCriteriaSortOrdersDirection, searchCriteriaPageSize, searchCriteriaCurrentPage, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        var queryParameters = new HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
        if (searchCriteriaFilterGroupsFiltersField !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[filterGroups][][filters][][field]', searchCriteriaFilterGroupsFiltersField);
        }
        if (searchCriteriaFilterGroupsFiltersValue !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[filterGroups][][filters][][value]', searchCriteriaFilterGroupsFiltersValue);
        }
        if (searchCriteriaFilterGroupsFiltersConditionType !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[filterGroups][][filters][][conditionType]', searchCriteriaFilterGroupsFiltersConditionType);
        }
        if (searchCriteriaSortOrdersField !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[sortOrders][][field]', searchCriteriaSortOrdersField);
        }
        if (searchCriteriaSortOrdersDirection !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[sortOrders][][direction]', searchCriteriaSortOrdersDirection);
        }
        if (searchCriteriaPageSize !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[pageSize]', searchCriteriaPageSize);
        }
        if (searchCriteriaCurrentPage !== undefined) {
            queryParameters = queryParameters.set('searchCriteria[currentPage]', searchCriteriaCurrentPage);
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        return this.httpClient.get(this.basePath + "/V1/products", {
            params: queryParameters,
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    CatalogProductRepositoryV1Service.prototype.catalogProductRepositoryV1SavePost = function (catalogProductRepositoryV1SavePostBody, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }
        return this.httpClient.post(this.basePath + "/V1/products", catalogProductRepositoryV1SavePostBody, {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    CatalogProductRepositoryV1Service.prototype.catalogProductRepositoryV1SavePut = function (sku, catalogProductRepositoryV1SavePutBody, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductRepositoryV1SavePut.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }
        return this.httpClient.put(this.basePath + "/V1/products/" + encodeURIComponent(String(sku)), catalogProductRepositoryV1SavePutBody, {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    CatalogProductRepositoryV1Service = __decorate([
        Injectable(),
        __param(1, Optional()), __param(1, Inject(BASE_PATH)), __param(2, Optional()),
        __metadata("design:paramtypes", [HttpClient, String, Configuration])
    ], CatalogProductRepositoryV1Service);
    return CatalogProductRepositoryV1Service;
}());
export { CatalogProductRepositoryV1Service };
//# sourceMappingURL=catalogProductRepositoryV1.service.js.map