import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogDataProductTierPriceInterface } from '../model/catalogDataProductTierPriceInterface';
import { Configuration } from '../configuration';
export declare class CatalogProductTierPriceManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogProductTierPriceManagementV1AddPost(sku: string, customerGroupId: string, price: number, qty: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductTierPriceManagementV1AddPost(sku: string, customerGroupId: string, price: number, qty: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductTierPriceManagementV1AddPost(sku: string, customerGroupId: string, price: number, qty: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogProductTierPriceManagementV1GetListGet(sku: string, customerGroupId: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductTierPriceInterface>>;
    catalogProductTierPriceManagementV1GetListGet(sku: string, customerGroupId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductTierPriceInterface>>>;
    catalogProductTierPriceManagementV1GetListGet(sku: string, customerGroupId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductTierPriceInterface>>>;
    catalogProductTierPriceManagementV1RemoveDelete(sku: string, customerGroupId: string, qty: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductTierPriceManagementV1RemoveDelete(sku: string, customerGroupId: string, qty: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductTierPriceManagementV1RemoveDelete(sku: string, customerGroupId: string, qty: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
