var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Inject, Injectable, Optional } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { BASE_PATH } from '../variables';
import { Configuration } from '../configuration';
var CatalogProductTierPriceManagementV1Service = (function () {
    function CatalogProductTierPriceManagementV1Service(httpClient, basePath, configuration) {
        this.httpClient = httpClient;
        this.basePath = 'http://shop.sergiofabbri.com/rest';
        this.defaultHeaders = new HttpHeaders();
        this.configuration = new Configuration();
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }
    CatalogProductTierPriceManagementV1Service.prototype.canConsumeForm = function (consumes) {
        var form = 'multipart/form-data';
        for (var _i = 0, consumes_1 = consumes; _i < consumes_1.length; _i++) {
            var consume = consumes_1[_i];
            if (form === consume) {
                return true;
            }
        }
        return false;
    };
    CatalogProductTierPriceManagementV1Service.prototype.catalogProductTierPriceManagementV1AddPost = function (sku, customerGroupId, price, qty, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductTierPriceManagementV1AddPost.');
        }
        if (customerGroupId === null || customerGroupId === undefined) {
            throw new Error('Required parameter customerGroupId was null or undefined when calling catalogProductTierPriceManagementV1AddPost.');
        }
        if (price === null || price === undefined) {
            throw new Error('Required parameter price was null or undefined when calling catalogProductTierPriceManagementV1AddPost.');
        }
        if (qty === null || qty === undefined) {
            throw new Error('Required parameter qty was null or undefined when calling catalogProductTierPriceManagementV1AddPost.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        return this.httpClient.post(this.basePath + "/V1/products/" + encodeURIComponent(String(sku)) + "/group-prices/" + encodeURIComponent(String(customerGroupId)) + "/tiers/" + encodeURIComponent(String(qty)) + "/price/" + encodeURIComponent(String(price)), null, {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    CatalogProductTierPriceManagementV1Service.prototype.catalogProductTierPriceManagementV1GetListGet = function (sku, customerGroupId, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductTierPriceManagementV1GetListGet.');
        }
        if (customerGroupId === null || customerGroupId === undefined) {
            throw new Error('Required parameter customerGroupId was null or undefined when calling catalogProductTierPriceManagementV1GetListGet.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        return this.httpClient.get(this.basePath + "/V1/products/" + encodeURIComponent(String(sku)) + "/group-prices/" + encodeURIComponent(String(customerGroupId)) + "/tiers", {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    CatalogProductTierPriceManagementV1Service.prototype.catalogProductTierPriceManagementV1RemoveDelete = function (sku, customerGroupId, qty, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling catalogProductTierPriceManagementV1RemoveDelete.');
        }
        if (customerGroupId === null || customerGroupId === undefined) {
            throw new Error('Required parameter customerGroupId was null or undefined when calling catalogProductTierPriceManagementV1RemoveDelete.');
        }
        if (qty === null || qty === undefined) {
            throw new Error('Required parameter qty was null or undefined when calling catalogProductTierPriceManagementV1RemoveDelete.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        return this.httpClient.delete(this.basePath + "/V1/products/" + encodeURIComponent(String(sku)) + "/group-prices/" + encodeURIComponent(String(customerGroupId)) + "/tiers/" + encodeURIComponent(String(qty)), {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    CatalogProductTierPriceManagementV1Service = __decorate([
        Injectable(),
        __param(1, Optional()), __param(1, Inject(BASE_PATH)), __param(2, Optional()),
        __metadata("design:paramtypes", [HttpClient, String, Configuration])
    ], CatalogProductTierPriceManagementV1Service);
    return CatalogProductTierPriceManagementV1Service;
}());
export { CatalogProductTierPriceManagementV1Service };
//# sourceMappingURL=catalogProductTierPriceManagementV1.service.js.map