import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogProductWebsiteLinkRepositoryV1SavePostBody } from '../model/catalogProductWebsiteLinkRepositoryV1SavePostBody';
import { CatalogProductWebsiteLinkRepositoryV1SavePutBody } from '../model/catalogProductWebsiteLinkRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class CatalogProductWebsiteLinkRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    catalogProductWebsiteLinkRepositoryV1DeleteByIdDelete(sku: string, websiteId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductWebsiteLinkRepositoryV1DeleteByIdDelete(sku: string, websiteId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductWebsiteLinkRepositoryV1DeleteByIdDelete(sku: string, websiteId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogProductWebsiteLinkRepositoryV1SavePost(sku: string, catalogProductWebsiteLinkRepositoryV1SavePostBody?: CatalogProductWebsiteLinkRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductWebsiteLinkRepositoryV1SavePost(sku: string, catalogProductWebsiteLinkRepositoryV1SavePostBody?: CatalogProductWebsiteLinkRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductWebsiteLinkRepositoryV1SavePost(sku: string, catalogProductWebsiteLinkRepositoryV1SavePostBody?: CatalogProductWebsiteLinkRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    catalogProductWebsiteLinkRepositoryV1SavePut(sku: string, catalogProductWebsiteLinkRepositoryV1SavePutBody?: CatalogProductWebsiteLinkRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    catalogProductWebsiteLinkRepositoryV1SavePut(sku: string, catalogProductWebsiteLinkRepositoryV1SavePutBody?: CatalogProductWebsiteLinkRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    catalogProductWebsiteLinkRepositoryV1SavePut(sku: string, catalogProductWebsiteLinkRepositoryV1SavePutBody?: CatalogProductWebsiteLinkRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
