import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CmsBlockRepositoryV1SavePostBody } from '../model/cmsBlockRepositoryV1SavePostBody';
import { CmsBlockRepositoryV1SavePutBody } from '../model/cmsBlockRepositoryV1SavePutBody';
import { CmsDataBlockInterface } from '../model/cmsDataBlockInterface';
import { CmsDataBlockSearchResultsInterface } from '../model/cmsDataBlockSearchResultsInterface';
import { Configuration } from '../configuration';
export declare class CmsBlockRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    cmsBlockRepositoryV1DeleteByIdDelete(blockId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    cmsBlockRepositoryV1DeleteByIdDelete(blockId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    cmsBlockRepositoryV1DeleteByIdDelete(blockId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    cmsBlockRepositoryV1GetByIdGet(blockId: number, observe?: 'body', reportProgress?: boolean): Observable<CmsDataBlockInterface>;
    cmsBlockRepositoryV1GetByIdGet(blockId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CmsDataBlockInterface>>;
    cmsBlockRepositoryV1GetByIdGet(blockId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CmsDataBlockInterface>>;
    cmsBlockRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<CmsDataBlockSearchResultsInterface>;
    cmsBlockRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CmsDataBlockSearchResultsInterface>>;
    cmsBlockRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CmsDataBlockSearchResultsInterface>>;
    cmsBlockRepositoryV1SavePost(cmsBlockRepositoryV1SavePostBody?: CmsBlockRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<CmsDataBlockInterface>;
    cmsBlockRepositoryV1SavePost(cmsBlockRepositoryV1SavePostBody?: CmsBlockRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CmsDataBlockInterface>>;
    cmsBlockRepositoryV1SavePost(cmsBlockRepositoryV1SavePostBody?: CmsBlockRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CmsDataBlockInterface>>;
    cmsBlockRepositoryV1SavePut(id: string, cmsBlockRepositoryV1SavePutBody?: CmsBlockRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<CmsDataBlockInterface>;
    cmsBlockRepositoryV1SavePut(id: string, cmsBlockRepositoryV1SavePutBody?: CmsBlockRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CmsDataBlockInterface>>;
    cmsBlockRepositoryV1SavePut(id: string, cmsBlockRepositoryV1SavePutBody?: CmsBlockRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CmsDataBlockInterface>>;
}
