import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CmsDataPageInterface } from '../model/cmsDataPageInterface';
import { CmsDataPageSearchResultsInterface } from '../model/cmsDataPageSearchResultsInterface';
import { CmsPageRepositoryV1SavePostBody } from '../model/cmsPageRepositoryV1SavePostBody';
import { CmsPageRepositoryV1SavePutBody } from '../model/cmsPageRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class CmsPageRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    cmsPageRepositoryV1DeleteByIdDelete(pageId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    cmsPageRepositoryV1DeleteByIdDelete(pageId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    cmsPageRepositoryV1DeleteByIdDelete(pageId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    cmsPageRepositoryV1GetByIdGet(pageId: number, observe?: 'body', reportProgress?: boolean): Observable<CmsDataPageInterface>;
    cmsPageRepositoryV1GetByIdGet(pageId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CmsDataPageInterface>>;
    cmsPageRepositoryV1GetByIdGet(pageId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CmsDataPageInterface>>;
    cmsPageRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<CmsDataPageSearchResultsInterface>;
    cmsPageRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CmsDataPageSearchResultsInterface>>;
    cmsPageRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CmsDataPageSearchResultsInterface>>;
    cmsPageRepositoryV1SavePost(cmsPageRepositoryV1SavePostBody?: CmsPageRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<CmsDataPageInterface>;
    cmsPageRepositoryV1SavePost(cmsPageRepositoryV1SavePostBody?: CmsPageRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CmsDataPageInterface>>;
    cmsPageRepositoryV1SavePost(cmsPageRepositoryV1SavePostBody?: CmsPageRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CmsDataPageInterface>>;
    cmsPageRepositoryV1SavePut(id: string, cmsPageRepositoryV1SavePutBody?: CmsPageRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<CmsDataPageInterface>;
    cmsPageRepositoryV1SavePut(id: string, cmsPageRepositoryV1SavePutBody?: CmsPageRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CmsDataPageInterface>>;
    cmsPageRepositoryV1SavePut(id: string, cmsPageRepositoryV1SavePutBody?: CmsPageRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CmsDataPageInterface>>;
}
