import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CatalogDataProductInterface } from '../model/catalogDataProductInterface';
import { ConfigurableProductLinkManagementV1AddChildPostBody } from '../model/configurableProductLinkManagementV1AddChildPostBody';
import { Configuration } from '../configuration';
export declare class ConfigurableProductLinkManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    configurableProductLinkManagementV1AddChildPost(sku: string, configurableProductLinkManagementV1AddChildPostBody?: ConfigurableProductLinkManagementV1AddChildPostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    configurableProductLinkManagementV1AddChildPost(sku: string, configurableProductLinkManagementV1AddChildPostBody?: ConfigurableProductLinkManagementV1AddChildPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    configurableProductLinkManagementV1AddChildPost(sku: string, configurableProductLinkManagementV1AddChildPostBody?: ConfigurableProductLinkManagementV1AddChildPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    configurableProductLinkManagementV1GetChildrenGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<CatalogDataProductInterface>>;
    configurableProductLinkManagementV1GetChildrenGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<CatalogDataProductInterface>>>;
    configurableProductLinkManagementV1GetChildrenGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<CatalogDataProductInterface>>>;
    configurableProductLinkManagementV1RemoveChildDelete(sku: string, childSku: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    configurableProductLinkManagementV1RemoveChildDelete(sku: string, childSku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    configurableProductLinkManagementV1RemoveChildDelete(sku: string, childSku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
