import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { ConfigurableProductDataOptionInterface } from '../model/configurableProductDataOptionInterface';
import { ConfigurableProductOptionRepositoryV1SavePostBody } from '../model/configurableProductOptionRepositoryV1SavePostBody';
import { ConfigurableProductOptionRepositoryV1SavePutBody } from '../model/configurableProductOptionRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class ConfigurableProductOptionRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    configurableProductOptionRepositoryV1DeleteByIdDelete(sku: string, id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    configurableProductOptionRepositoryV1DeleteByIdDelete(sku: string, id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    configurableProductOptionRepositoryV1DeleteByIdDelete(sku: string, id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    configurableProductOptionRepositoryV1GetGet(sku: string, id: number, observe?: 'body', reportProgress?: boolean): Observable<ConfigurableProductDataOptionInterface>;
    configurableProductOptionRepositoryV1GetGet(sku: string, id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ConfigurableProductDataOptionInterface>>;
    configurableProductOptionRepositoryV1GetGet(sku: string, id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ConfigurableProductDataOptionInterface>>;
    configurableProductOptionRepositoryV1GetListGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<ConfigurableProductDataOptionInterface>>;
    configurableProductOptionRepositoryV1GetListGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<ConfigurableProductDataOptionInterface>>>;
    configurableProductOptionRepositoryV1GetListGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<ConfigurableProductDataOptionInterface>>>;
    configurableProductOptionRepositoryV1SavePost(sku: string, configurableProductOptionRepositoryV1SavePostBody?: ConfigurableProductOptionRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    configurableProductOptionRepositoryV1SavePost(sku: string, configurableProductOptionRepositoryV1SavePostBody?: ConfigurableProductOptionRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    configurableProductOptionRepositoryV1SavePost(sku: string, configurableProductOptionRepositoryV1SavePostBody?: ConfigurableProductOptionRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    configurableProductOptionRepositoryV1SavePut(sku: string, id: string, configurableProductOptionRepositoryV1SavePutBody?: ConfigurableProductOptionRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    configurableProductOptionRepositoryV1SavePut(sku: string, id: string, configurableProductOptionRepositoryV1SavePutBody?: ConfigurableProductOptionRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    configurableProductOptionRepositoryV1SavePut(sku: string, id: string, configurableProductOptionRepositoryV1SavePutBody?: ConfigurableProductOptionRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
}
