import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CustomerAccountManagementV1ActivateByIdPutBody } from '../model/customerAccountManagementV1ActivateByIdPutBody';
import { CustomerAccountManagementV1ActivatePutBody } from '../model/customerAccountManagementV1ActivatePutBody';
import { CustomerAccountManagementV1ChangePasswordByIdPutBody } from '../model/customerAccountManagementV1ChangePasswordByIdPutBody';
import { CustomerAccountManagementV1CreateAccountPostBody } from '../model/customerAccountManagementV1CreateAccountPostBody';
import { CustomerAccountManagementV1InitiatePasswordResetPutBody } from '../model/customerAccountManagementV1InitiatePasswordResetPutBody';
import { CustomerAccountManagementV1IsEmailAvailablePostBody } from '../model/customerAccountManagementV1IsEmailAvailablePostBody';
import { CustomerAccountManagementV1ResendConfirmationPostBody } from '../model/customerAccountManagementV1ResendConfirmationPostBody';
import { CustomerAccountManagementV1ResetPasswordPostBody } from '../model/customerAccountManagementV1ResetPasswordPostBody';
import { CustomerAccountManagementV1ValidatePutBody } from '../model/customerAccountManagementV1ValidatePutBody';
import { CustomerDataAddressInterface } from '../model/customerDataAddressInterface';
import { CustomerDataCustomerInterface } from '../model/customerDataCustomerInterface';
import { CustomerDataValidationResultsInterface } from '../model/customerDataValidationResultsInterface';
import { Configuration } from '../configuration';
export declare class CustomerAccountManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    customerAccountManagementV1ActivateByIdPut(customerAccountManagementV1ActivateByIdPutBody?: CustomerAccountManagementV1ActivateByIdPutBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerInterface>;
    customerAccountManagementV1ActivateByIdPut(customerAccountManagementV1ActivateByIdPutBody?: CustomerAccountManagementV1ActivateByIdPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerInterface>>;
    customerAccountManagementV1ActivateByIdPut(customerAccountManagementV1ActivateByIdPutBody?: CustomerAccountManagementV1ActivateByIdPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerInterface>>;
    customerAccountManagementV1ActivatePut(email: string, customerAccountManagementV1ActivatePutBody?: CustomerAccountManagementV1ActivatePutBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerInterface>;
    customerAccountManagementV1ActivatePut(email: string, customerAccountManagementV1ActivatePutBody?: CustomerAccountManagementV1ActivatePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerInterface>>;
    customerAccountManagementV1ActivatePut(email: string, customerAccountManagementV1ActivatePutBody?: CustomerAccountManagementV1ActivatePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerInterface>>;
    customerAccountManagementV1ChangePasswordByIdPut(customerAccountManagementV1ChangePasswordByIdPutBody?: CustomerAccountManagementV1ChangePasswordByIdPutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    customerAccountManagementV1ChangePasswordByIdPut(customerAccountManagementV1ChangePasswordByIdPutBody?: CustomerAccountManagementV1ChangePasswordByIdPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    customerAccountManagementV1ChangePasswordByIdPut(customerAccountManagementV1ChangePasswordByIdPutBody?: CustomerAccountManagementV1ChangePasswordByIdPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    customerAccountManagementV1CreateAccountPost(customerAccountManagementV1CreateAccountPostBody?: CustomerAccountManagementV1CreateAccountPostBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerInterface>;
    customerAccountManagementV1CreateAccountPost(customerAccountManagementV1CreateAccountPostBody?: CustomerAccountManagementV1CreateAccountPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerInterface>>;
    customerAccountManagementV1CreateAccountPost(customerAccountManagementV1CreateAccountPostBody?: CustomerAccountManagementV1CreateAccountPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerInterface>>;
    customerAccountManagementV1GetConfirmationStatusGet(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<string>;
    customerAccountManagementV1GetConfirmationStatusGet(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    customerAccountManagementV1GetConfirmationStatusGet(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    customerAccountManagementV1GetDefaultBillingAddressGet(observe?: 'body', reportProgress?: boolean): Observable<CustomerDataAddressInterface>;
    customerAccountManagementV1GetDefaultBillingAddressGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataAddressInterface>>;
    customerAccountManagementV1GetDefaultBillingAddressGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataAddressInterface>>;
    customerAccountManagementV1GetDefaultBillingAddressGet_1(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataAddressInterface>;
    customerAccountManagementV1GetDefaultBillingAddressGet_1(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataAddressInterface>>;
    customerAccountManagementV1GetDefaultBillingAddressGet_1(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataAddressInterface>>;
    customerAccountManagementV1GetDefaultShippingAddressGet(observe?: 'body', reportProgress?: boolean): Observable<CustomerDataAddressInterface>;
    customerAccountManagementV1GetDefaultShippingAddressGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataAddressInterface>>;
    customerAccountManagementV1GetDefaultShippingAddressGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataAddressInterface>>;
    customerAccountManagementV1GetDefaultShippingAddressGet_2(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataAddressInterface>;
    customerAccountManagementV1GetDefaultShippingAddressGet_2(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataAddressInterface>>;
    customerAccountManagementV1GetDefaultShippingAddressGet_2(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataAddressInterface>>;
    customerAccountManagementV1InitiatePasswordResetPut(customerAccountManagementV1InitiatePasswordResetPutBody?: CustomerAccountManagementV1InitiatePasswordResetPutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    customerAccountManagementV1InitiatePasswordResetPut(customerAccountManagementV1InitiatePasswordResetPutBody?: CustomerAccountManagementV1InitiatePasswordResetPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    customerAccountManagementV1InitiatePasswordResetPut(customerAccountManagementV1InitiatePasswordResetPutBody?: CustomerAccountManagementV1InitiatePasswordResetPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    customerAccountManagementV1IsEmailAvailablePost(customerAccountManagementV1IsEmailAvailablePostBody?: CustomerAccountManagementV1IsEmailAvailablePostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    customerAccountManagementV1IsEmailAvailablePost(customerAccountManagementV1IsEmailAvailablePostBody?: CustomerAccountManagementV1IsEmailAvailablePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    customerAccountManagementV1IsEmailAvailablePost(customerAccountManagementV1IsEmailAvailablePostBody?: CustomerAccountManagementV1IsEmailAvailablePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    customerAccountManagementV1IsReadonlyGet(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    customerAccountManagementV1IsReadonlyGet(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    customerAccountManagementV1IsReadonlyGet(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    customerAccountManagementV1ResendConfirmationPost(customerAccountManagementV1ResendConfirmationPostBody?: CustomerAccountManagementV1ResendConfirmationPostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    customerAccountManagementV1ResendConfirmationPost(customerAccountManagementV1ResendConfirmationPostBody?: CustomerAccountManagementV1ResendConfirmationPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    customerAccountManagementV1ResendConfirmationPost(customerAccountManagementV1ResendConfirmationPostBody?: CustomerAccountManagementV1ResendConfirmationPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    customerAccountManagementV1ResetPasswordPost(customerAccountManagementV1ResetPasswordPostBody?: CustomerAccountManagementV1ResetPasswordPostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    customerAccountManagementV1ResetPasswordPost(customerAccountManagementV1ResetPasswordPostBody?: CustomerAccountManagementV1ResetPasswordPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    customerAccountManagementV1ResetPasswordPost(customerAccountManagementV1ResetPasswordPostBody?: CustomerAccountManagementV1ResetPasswordPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    customerAccountManagementV1ValidatePut(customerAccountManagementV1ValidatePutBody?: CustomerAccountManagementV1ValidatePutBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataValidationResultsInterface>;
    customerAccountManagementV1ValidatePut(customerAccountManagementV1ValidatePutBody?: CustomerAccountManagementV1ValidatePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataValidationResultsInterface>>;
    customerAccountManagementV1ValidatePut(customerAccountManagementV1ValidatePutBody?: CustomerAccountManagementV1ValidatePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataValidationResultsInterface>>;
    customerAccountManagementV1ValidateResetPasswordLinkTokenGet(customerId: number, resetPasswordLinkToken: string, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    customerAccountManagementV1ValidateResetPasswordLinkTokenGet(customerId: number, resetPasswordLinkToken: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    customerAccountManagementV1ValidateResetPasswordLinkTokenGet(customerId: number, resetPasswordLinkToken: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
