import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CustomerCustomerRepositoryV1SavePutBody } from '../model/customerCustomerRepositoryV1SavePutBody';
import { CustomerCustomerRepositoryV1SavePutBody1 } from '../model/customerCustomerRepositoryV1SavePutBody1';
import { CustomerDataCustomerInterface } from '../model/customerDataCustomerInterface';
import { CustomerDataCustomerSearchResultsInterface } from '../model/customerDataCustomerSearchResultsInterface';
import { Configuration } from '../configuration';
export declare class CustomerCustomerRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    customerCustomerRepositoryV1DeleteByIdDelete(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    customerCustomerRepositoryV1DeleteByIdDelete(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    customerCustomerRepositoryV1DeleteByIdDelete(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    customerCustomerRepositoryV1GetByIdGet(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerInterface>;
    customerCustomerRepositoryV1GetByIdGet(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerInterface>>;
    customerCustomerRepositoryV1GetByIdGet(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerInterface>>;
    customerCustomerRepositoryV1GetByIdGet_1(observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerInterface>;
    customerCustomerRepositoryV1GetByIdGet_1(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerInterface>>;
    customerCustomerRepositoryV1GetByIdGet_1(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerInterface>>;
    customerCustomerRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerSearchResultsInterface>;
    customerCustomerRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerSearchResultsInterface>>;
    customerCustomerRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerSearchResultsInterface>>;
    customerCustomerRepositoryV1SavePut(customerId: string, customerCustomerRepositoryV1SavePutBody?: CustomerCustomerRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerInterface>;
    customerCustomerRepositoryV1SavePut(customerId: string, customerCustomerRepositoryV1SavePutBody?: CustomerCustomerRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerInterface>>;
    customerCustomerRepositoryV1SavePut(customerId: string, customerCustomerRepositoryV1SavePutBody?: CustomerCustomerRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerInterface>>;
    customerCustomerRepositoryV1SavePut_2(customerCustomerRepositoryV1SavePutBody?: CustomerCustomerRepositoryV1SavePutBody1, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataCustomerInterface>;
    customerCustomerRepositoryV1SavePut_2(customerCustomerRepositoryV1SavePutBody?: CustomerCustomerRepositoryV1SavePutBody1, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataCustomerInterface>>;
    customerCustomerRepositoryV1SavePut_2(customerCustomerRepositoryV1SavePutBody?: CustomerCustomerRepositoryV1SavePutBody1, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataCustomerInterface>>;
}
