import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { CustomerDataGroupInterface } from '../model/customerDataGroupInterface';
import { CustomerDataGroupSearchResultsInterface } from '../model/customerDataGroupSearchResultsInterface';
import { CustomerGroupRepositoryV1SavePostBody } from '../model/customerGroupRepositoryV1SavePostBody';
import { CustomerGroupRepositoryV1SavePutBody } from '../model/customerGroupRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class CustomerGroupRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    customerGroupRepositoryV1DeleteByIdDelete(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    customerGroupRepositoryV1DeleteByIdDelete(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    customerGroupRepositoryV1DeleteByIdDelete(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    customerGroupRepositoryV1GetByIdGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataGroupInterface>;
    customerGroupRepositoryV1GetByIdGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataGroupInterface>>;
    customerGroupRepositoryV1GetByIdGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataGroupInterface>>;
    customerGroupRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataGroupSearchResultsInterface>;
    customerGroupRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataGroupSearchResultsInterface>>;
    customerGroupRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataGroupSearchResultsInterface>>;
    customerGroupRepositoryV1SavePost(customerGroupRepositoryV1SavePostBody?: CustomerGroupRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataGroupInterface>;
    customerGroupRepositoryV1SavePost(customerGroupRepositoryV1SavePostBody?: CustomerGroupRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataGroupInterface>>;
    customerGroupRepositoryV1SavePost(customerGroupRepositoryV1SavePostBody?: CustomerGroupRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataGroupInterface>>;
    customerGroupRepositoryV1SavePut(id: string, customerGroupRepositoryV1SavePutBody?: CustomerGroupRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<CustomerDataGroupInterface>;
    customerGroupRepositoryV1SavePut(id: string, customerGroupRepositoryV1SavePutBody?: CustomerGroupRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<CustomerDataGroupInterface>>;
    customerGroupRepositoryV1SavePut(id: string, customerGroupRepositoryV1SavePutBody?: CustomerGroupRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<CustomerDataGroupInterface>>;
}
