import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { DownloadableDataLinkInterface } from '../model/downloadableDataLinkInterface';
import { DownloadableLinkRepositoryV1SavePostBody } from '../model/downloadableLinkRepositoryV1SavePostBody';
import { DownloadableLinkRepositoryV1SavePutBody } from '../model/downloadableLinkRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class DownloadableLinkRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    downloadableLinkRepositoryV1DeleteDelete(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    downloadableLinkRepositoryV1DeleteDelete(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    downloadableLinkRepositoryV1DeleteDelete(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    downloadableLinkRepositoryV1GetListGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<DownloadableDataLinkInterface>>;
    downloadableLinkRepositoryV1GetListGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<DownloadableDataLinkInterface>>>;
    downloadableLinkRepositoryV1GetListGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<DownloadableDataLinkInterface>>>;
    downloadableLinkRepositoryV1SavePost(sku: string, downloadableLinkRepositoryV1SavePostBody?: DownloadableLinkRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    downloadableLinkRepositoryV1SavePost(sku: string, downloadableLinkRepositoryV1SavePostBody?: DownloadableLinkRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    downloadableLinkRepositoryV1SavePost(sku: string, downloadableLinkRepositoryV1SavePostBody?: DownloadableLinkRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    downloadableLinkRepositoryV1SavePut(sku: string, id: string, downloadableLinkRepositoryV1SavePutBody?: DownloadableLinkRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    downloadableLinkRepositoryV1SavePut(sku: string, id: string, downloadableLinkRepositoryV1SavePutBody?: DownloadableLinkRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    downloadableLinkRepositoryV1SavePut(sku: string, id: string, downloadableLinkRepositoryV1SavePutBody?: DownloadableLinkRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
}
