import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { DownloadableDataSampleInterface } from '../model/downloadableDataSampleInterface';
import { DownloadableSampleRepositoryV1SavePostBody } from '../model/downloadableSampleRepositoryV1SavePostBody';
import { DownloadableSampleRepositoryV1SavePutBody } from '../model/downloadableSampleRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class DownloadableSampleRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    downloadableSampleRepositoryV1DeleteDelete(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    downloadableSampleRepositoryV1DeleteDelete(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    downloadableSampleRepositoryV1DeleteDelete(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    downloadableSampleRepositoryV1GetListGet(sku: string, observe?: 'body', reportProgress?: boolean): Observable<Array<DownloadableDataSampleInterface>>;
    downloadableSampleRepositoryV1GetListGet(sku: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<DownloadableDataSampleInterface>>>;
    downloadableSampleRepositoryV1GetListGet(sku: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<DownloadableDataSampleInterface>>>;
    downloadableSampleRepositoryV1SavePost(sku: string, downloadableSampleRepositoryV1SavePostBody?: DownloadableSampleRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    downloadableSampleRepositoryV1SavePost(sku: string, downloadableSampleRepositoryV1SavePostBody?: DownloadableSampleRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    downloadableSampleRepositoryV1SavePost(sku: string, downloadableSampleRepositoryV1SavePostBody?: DownloadableSampleRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    downloadableSampleRepositoryV1SavePut(sku: string, id: string, downloadableSampleRepositoryV1SavePutBody?: DownloadableSampleRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    downloadableSampleRepositoryV1SavePut(sku: string, id: string, downloadableSampleRepositoryV1SavePutBody?: DownloadableSampleRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    downloadableSampleRepositoryV1SavePut(sku: string, id: string, downloadableSampleRepositoryV1SavePutBody?: DownloadableSampleRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
}
