var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Inject, Injectable, Optional } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { BASE_PATH } from '../variables';
import { Configuration } from '../configuration';
var DownloadableSampleRepositoryV1Service = (function () {
    function DownloadableSampleRepositoryV1Service(httpClient, basePath, configuration) {
        this.httpClient = httpClient;
        this.basePath = 'http://shop.sergiofabbri.com/rest';
        this.defaultHeaders = new HttpHeaders();
        this.configuration = new Configuration();
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }
    DownloadableSampleRepositoryV1Service.prototype.canConsumeForm = function (consumes) {
        var form = 'multipart/form-data';
        for (var _i = 0, consumes_1 = consumes; _i < consumes_1.length; _i++) {
            var consume = consumes_1[_i];
            if (form === consume) {
                return true;
            }
        }
        return false;
    };
    DownloadableSampleRepositoryV1Service.prototype.downloadableSampleRepositoryV1DeleteDelete = function (id, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling downloadableSampleRepositoryV1DeleteDelete.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        return this.httpClient.delete(this.basePath + "/V1/products/downloadable-links/samples/" + encodeURIComponent(String(id)), {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    DownloadableSampleRepositoryV1Service.prototype.downloadableSampleRepositoryV1GetListGet = function (sku, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling downloadableSampleRepositoryV1GetListGet.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        return this.httpClient.get(this.basePath + "/V1/products/" + encodeURIComponent(String(sku)) + "/downloadable-links/samples", {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    DownloadableSampleRepositoryV1Service.prototype.downloadableSampleRepositoryV1SavePost = function (sku, downloadableSampleRepositoryV1SavePostBody, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling downloadableSampleRepositoryV1SavePost.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }
        return this.httpClient.post(this.basePath + "/V1/products/" + encodeURIComponent(String(sku)) + "/downloadable-links/samples", downloadableSampleRepositoryV1SavePostBody, {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    DownloadableSampleRepositoryV1Service.prototype.downloadableSampleRepositoryV1SavePut = function (sku, id, downloadableSampleRepositoryV1SavePutBody, observe, reportProgress) {
        if (observe === void 0) { observe = 'body'; }
        if (reportProgress === void 0) { reportProgress = false; }
        if (sku === null || sku === undefined) {
            throw new Error('Required parameter sku was null or undefined when calling downloadableSampleRepositoryV1SavePut.');
        }
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling downloadableSampleRepositoryV1SavePut.');
        }
        var headers = this.defaultHeaders;
        var httpHeaderAccepts = [];
        var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set("Accept", httpHeaderAcceptSelected);
        }
        var consumes = [];
        var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set("Content-Type", httpContentTypeSelected);
        }
        return this.httpClient.put(this.basePath + "/V1/products/" + encodeURIComponent(String(sku)) + "/downloadable-links/samples/" + encodeURIComponent(String(id)), downloadableSampleRepositoryV1SavePutBody, {
            withCredentials: this.configuration.withCredentials,
            headers: headers,
            observe: observe,
            reportProgress: reportProgress
        });
    };
    DownloadableSampleRepositoryV1Service = __decorate([
        Injectable(),
        __param(1, Optional()), __param(1, Inject(BASE_PATH)), __param(2, Optional()),
        __metadata("design:paramtypes", [HttpClient, String, Configuration])
    ], DownloadableSampleRepositoryV1Service);
    return DownloadableSampleRepositoryV1Service;
}());
export { DownloadableSampleRepositoryV1Service };
//# sourceMappingURL=downloadableSampleRepositoryV1.service.js.map