import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { EavAttributeSetRepositoryV1SavePutBody } from '../model/eavAttributeSetRepositoryV1SavePutBody';
import { EavDataAttributeSetInterface } from '../model/eavDataAttributeSetInterface';
import { EavDataAttributeSetSearchResultsInterface } from '../model/eavDataAttributeSetSearchResultsInterface';
import { Configuration } from '../configuration';
export declare class EavAttributeSetRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    eavAttributeSetRepositoryV1DeleteByIdDelete(attributeSetId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    eavAttributeSetRepositoryV1DeleteByIdDelete(attributeSetId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    eavAttributeSetRepositoryV1DeleteByIdDelete(attributeSetId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    eavAttributeSetRepositoryV1GetGet(attributeSetId: number, observe?: 'body', reportProgress?: boolean): Observable<EavDataAttributeSetInterface>;
    eavAttributeSetRepositoryV1GetGet(attributeSetId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EavDataAttributeSetInterface>>;
    eavAttributeSetRepositoryV1GetGet(attributeSetId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EavDataAttributeSetInterface>>;
    eavAttributeSetRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<EavDataAttributeSetSearchResultsInterface>;
    eavAttributeSetRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EavDataAttributeSetSearchResultsInterface>>;
    eavAttributeSetRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EavDataAttributeSetSearchResultsInterface>>;
    eavAttributeSetRepositoryV1SavePut(attributeSetId: string, eavAttributeSetRepositoryV1SavePutBody?: EavAttributeSetRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<EavDataAttributeSetInterface>;
    eavAttributeSetRepositoryV1SavePut(attributeSetId: string, eavAttributeSetRepositoryV1SavePutBody?: EavAttributeSetRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EavDataAttributeSetInterface>>;
    eavAttributeSetRepositoryV1SavePut(attributeSetId: string, eavAttributeSetRepositoryV1SavePutBody?: EavAttributeSetRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EavDataAttributeSetInterface>>;
}
