import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { GiftMessageDataMessageInterface } from '../model/giftMessageDataMessageInterface';
import { GiftMessageGuestItemRepositoryV1SavePostBody } from '../model/giftMessageGuestItemRepositoryV1SavePostBody';
import { Configuration } from '../configuration';
export declare class GiftMessageGuestItemRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    giftMessageGuestItemRepositoryV1GetGet(cartId: string, itemId: number, observe?: 'body', reportProgress?: boolean): Observable<GiftMessageDataMessageInterface>;
    giftMessageGuestItemRepositoryV1GetGet(cartId: string, itemId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<GiftMessageDataMessageInterface>>;
    giftMessageGuestItemRepositoryV1GetGet(cartId: string, itemId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<GiftMessageDataMessageInterface>>;
    giftMessageGuestItemRepositoryV1SavePost(cartId: string, itemId: number, giftMessageGuestItemRepositoryV1SavePostBody?: GiftMessageGuestItemRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    giftMessageGuestItemRepositoryV1SavePost(cartId: string, itemId: number, giftMessageGuestItemRepositoryV1SavePostBody?: GiftMessageGuestItemRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    giftMessageGuestItemRepositoryV1SavePost(cartId: string, itemId: number, giftMessageGuestItemRepositoryV1SavePostBody?: GiftMessageGuestItemRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
