import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { QuoteCartItemRepositoryV1SavePostBody } from '../model/quoteCartItemRepositoryV1SavePostBody';
import { QuoteCartItemRepositoryV1SavePostBody1 } from '../model/quoteCartItemRepositoryV1SavePostBody1';
import { QuoteCartItemRepositoryV1SavePutBody } from '../model/quoteCartItemRepositoryV1SavePutBody';
import { QuoteCartItemRepositoryV1SavePutBody1 } from '../model/quoteCartItemRepositoryV1SavePutBody1';
import { QuoteDataCartItemInterface } from '../model/quoteDataCartItemInterface';
import { Configuration } from '../configuration';
export declare class QuoteCartItemRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    quoteCartItemRepositoryV1DeleteByIdDelete(cartId: number, itemId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    quoteCartItemRepositoryV1DeleteByIdDelete(cartId: number, itemId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    quoteCartItemRepositoryV1DeleteByIdDelete(cartId: number, itemId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    quoteCartItemRepositoryV1DeleteByIdDelete_1(itemId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    quoteCartItemRepositoryV1DeleteByIdDelete_1(itemId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    quoteCartItemRepositoryV1DeleteByIdDelete_1(itemId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    quoteCartItemRepositoryV1GetListGet(cartId: number, observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataCartItemInterface>>;
    quoteCartItemRepositoryV1GetListGet(cartId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataCartItemInterface>>>;
    quoteCartItemRepositoryV1GetListGet(cartId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataCartItemInterface>>>;
    quoteCartItemRepositoryV1GetListGet_2(observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataCartItemInterface>>;
    quoteCartItemRepositoryV1GetListGet_2(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataCartItemInterface>>>;
    quoteCartItemRepositoryV1GetListGet_2(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataCartItemInterface>>>;
    quoteCartItemRepositoryV1SavePost(quoteId: string, quoteCartItemRepositoryV1SavePostBody?: QuoteCartItemRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartItemInterface>;
    quoteCartItemRepositoryV1SavePost(quoteId: string, quoteCartItemRepositoryV1SavePostBody?: QuoteCartItemRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartItemInterface>>;
    quoteCartItemRepositoryV1SavePost(quoteId: string, quoteCartItemRepositoryV1SavePostBody?: QuoteCartItemRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartItemInterface>>;
    quoteCartItemRepositoryV1SavePost_3(quoteCartItemRepositoryV1SavePostBody?: QuoteCartItemRepositoryV1SavePostBody1, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartItemInterface>;
    quoteCartItemRepositoryV1SavePost_3(quoteCartItemRepositoryV1SavePostBody?: QuoteCartItemRepositoryV1SavePostBody1, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartItemInterface>>;
    quoteCartItemRepositoryV1SavePost_3(quoteCartItemRepositoryV1SavePostBody?: QuoteCartItemRepositoryV1SavePostBody1, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartItemInterface>>;
    quoteCartItemRepositoryV1SavePut(cartId: string, itemId: string, quoteCartItemRepositoryV1SavePutBody?: QuoteCartItemRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartItemInterface>;
    quoteCartItemRepositoryV1SavePut(cartId: string, itemId: string, quoteCartItemRepositoryV1SavePutBody?: QuoteCartItemRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartItemInterface>>;
    quoteCartItemRepositoryV1SavePut(cartId: string, itemId: string, quoteCartItemRepositoryV1SavePutBody?: QuoteCartItemRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartItemInterface>>;
    quoteCartItemRepositoryV1SavePut_4(itemId: string, quoteCartItemRepositoryV1SavePutBody?: QuoteCartItemRepositoryV1SavePutBody1, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartItemInterface>;
    quoteCartItemRepositoryV1SavePut_4(itemId: string, quoteCartItemRepositoryV1SavePutBody?: QuoteCartItemRepositoryV1SavePutBody1, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartItemInterface>>;
    quoteCartItemRepositoryV1SavePut_4(itemId: string, quoteCartItemRepositoryV1SavePutBody?: QuoteCartItemRepositoryV1SavePutBody1, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartItemInterface>>;
}
