import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { QuoteCartManagementV1AssignCustomerPutBody } from '../model/quoteCartManagementV1AssignCustomerPutBody';
import { QuoteCartManagementV1PlaceOrderPutBody } from '../model/quoteCartManagementV1PlaceOrderPutBody';
import { QuoteCartManagementV1PlaceOrderPutBody1 } from '../model/quoteCartManagementV1PlaceOrderPutBody1';
import { QuoteDataCartInterface } from '../model/quoteDataCartInterface';
import { Configuration } from '../configuration';
export declare class QuoteCartManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    quoteCartManagementV1AssignCustomerPut(cartId: number, quoteCartManagementV1AssignCustomerPutBody?: QuoteCartManagementV1AssignCustomerPutBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    quoteCartManagementV1AssignCustomerPut(cartId: number, quoteCartManagementV1AssignCustomerPutBody?: QuoteCartManagementV1AssignCustomerPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    quoteCartManagementV1AssignCustomerPut(cartId: number, quoteCartManagementV1AssignCustomerPutBody?: QuoteCartManagementV1AssignCustomerPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    quoteCartManagementV1CreateEmptyCartForCustomerPost(observe?: 'body', reportProgress?: boolean): Observable<number>;
    quoteCartManagementV1CreateEmptyCartForCustomerPost(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    quoteCartManagementV1CreateEmptyCartForCustomerPost(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    quoteCartManagementV1CreateEmptyCartForCustomerPost_1(customerId: number, observe?: 'body', reportProgress?: boolean): Observable<number>;
    quoteCartManagementV1CreateEmptyCartForCustomerPost_1(customerId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    quoteCartManagementV1CreateEmptyCartForCustomerPost_1(customerId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    quoteCartManagementV1CreateEmptyCartPost(observe?: 'body', reportProgress?: boolean): Observable<number>;
    quoteCartManagementV1CreateEmptyCartPost(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    quoteCartManagementV1CreateEmptyCartPost(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    quoteCartManagementV1GetCartForCustomerGet(observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartInterface>;
    quoteCartManagementV1GetCartForCustomerGet(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartInterface>>;
    quoteCartManagementV1GetCartForCustomerGet(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartInterface>>;
    quoteCartManagementV1PlaceOrderPut(quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    quoteCartManagementV1PlaceOrderPut(quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    quoteCartManagementV1PlaceOrderPut(quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
    quoteCartManagementV1PlaceOrderPut_2(cartId: number, quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody1, observe?: 'body', reportProgress?: boolean): Observable<number>;
    quoteCartManagementV1PlaceOrderPut_2(cartId: number, quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody1, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    quoteCartManagementV1PlaceOrderPut_2(cartId: number, quoteCartManagementV1PlaceOrderPutBody?: QuoteCartManagementV1PlaceOrderPutBody1, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
}
