import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { ErrorResponse } from '../model/errorResponse';
import { QuoteCartRepositoryV1SavePutBody } from '../model/quoteCartRepositoryV1SavePutBody';
import { QuoteDataCartInterface } from '../model/quoteDataCartInterface';
import { QuoteDataCartSearchResultsInterface } from '../model/quoteDataCartSearchResultsInterface';
import { Configuration } from '../configuration';
export declare class QuoteCartRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    quoteCartRepositoryV1GetGet(cartId: number, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartInterface>;
    quoteCartRepositoryV1GetGet(cartId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartInterface>>;
    quoteCartRepositoryV1GetGet(cartId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartInterface>>;
    quoteCartRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartSearchResultsInterface>;
    quoteCartRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartSearchResultsInterface>>;
    quoteCartRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartSearchResultsInterface>>;
    quoteCartRepositoryV1SavePut(quoteCartRepositoryV1SavePutBody?: QuoteCartRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<ErrorResponse>;
    quoteCartRepositoryV1SavePut(quoteCartRepositoryV1SavePutBody?: QuoteCartRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ErrorResponse>>;
    quoteCartRepositoryV1SavePut(quoteCartRepositoryV1SavePutBody?: QuoteCartRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ErrorResponse>>;
}
