import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { QuoteDataCartItemInterface } from '../model/quoteDataCartItemInterface';
import { QuoteGuestCartItemRepositoryV1SavePostBody } from '../model/quoteGuestCartItemRepositoryV1SavePostBody';
import { QuoteGuestCartItemRepositoryV1SavePutBody } from '../model/quoteGuestCartItemRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class QuoteGuestCartItemRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    quoteGuestCartItemRepositoryV1DeleteByIdDelete(cartId: string, itemId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    quoteGuestCartItemRepositoryV1DeleteByIdDelete(cartId: string, itemId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    quoteGuestCartItemRepositoryV1DeleteByIdDelete(cartId: string, itemId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    quoteGuestCartItemRepositoryV1GetListGet(cartId: string, observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataCartItemInterface>>;
    quoteGuestCartItemRepositoryV1GetListGet(cartId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataCartItemInterface>>>;
    quoteGuestCartItemRepositoryV1GetListGet(cartId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataCartItemInterface>>>;
    quoteGuestCartItemRepositoryV1SavePost(cartId: string, quoteGuestCartItemRepositoryV1SavePostBody?: QuoteGuestCartItemRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartItemInterface>;
    quoteGuestCartItemRepositoryV1SavePost(cartId: string, quoteGuestCartItemRepositoryV1SavePostBody?: QuoteGuestCartItemRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartItemInterface>>;
    quoteGuestCartItemRepositoryV1SavePost(cartId: string, quoteGuestCartItemRepositoryV1SavePostBody?: QuoteGuestCartItemRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartItemInterface>>;
    quoteGuestCartItemRepositoryV1SavePut(cartId: string, itemId: string, quoteGuestCartItemRepositoryV1SavePutBody?: QuoteGuestCartItemRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataCartItemInterface>;
    quoteGuestCartItemRepositoryV1SavePut(cartId: string, itemId: string, quoteGuestCartItemRepositoryV1SavePutBody?: QuoteGuestCartItemRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataCartItemInterface>>;
    quoteGuestCartItemRepositoryV1SavePut(cartId: string, itemId: string, quoteGuestCartItemRepositoryV1SavePutBody?: QuoteGuestCartItemRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataCartItemInterface>>;
}
