import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { QuoteDataPaymentInterface } from '../model/quoteDataPaymentInterface';
import { QuoteDataPaymentMethodInterface } from '../model/quoteDataPaymentMethodInterface';
import { QuoteGuestPaymentMethodManagementV1SetPutBody } from '../model/quoteGuestPaymentMethodManagementV1SetPutBody';
import { Configuration } from '../configuration';
export declare class QuoteGuestPaymentMethodManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    quoteGuestPaymentMethodManagementV1GetGet(cartId: string, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataPaymentInterface>;
    quoteGuestPaymentMethodManagementV1GetGet(cartId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataPaymentInterface>>;
    quoteGuestPaymentMethodManagementV1GetGet(cartId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataPaymentInterface>>;
    quoteGuestPaymentMethodManagementV1GetListGet(cartId: string, observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataPaymentMethodInterface>>;
    quoteGuestPaymentMethodManagementV1GetListGet(cartId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataPaymentMethodInterface>>>;
    quoteGuestPaymentMethodManagementV1GetListGet(cartId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataPaymentMethodInterface>>>;
    quoteGuestPaymentMethodManagementV1SetPut(cartId: string, quoteGuestPaymentMethodManagementV1SetPutBody?: QuoteGuestPaymentMethodManagementV1SetPutBody, observe?: 'body', reportProgress?: boolean): Observable<number>;
    quoteGuestPaymentMethodManagementV1SetPut(cartId: string, quoteGuestPaymentMethodManagementV1SetPutBody?: QuoteGuestPaymentMethodManagementV1SetPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<number>>;
    quoteGuestPaymentMethodManagementV1SetPut(cartId: string, quoteGuestPaymentMethodManagementV1SetPutBody?: QuoteGuestPaymentMethodManagementV1SetPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<number>>;
}
