import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { QuoteDataPaymentInterface } from '../model/quoteDataPaymentInterface';
import { QuoteDataPaymentMethodInterface } from '../model/quoteDataPaymentMethodInterface';
import { QuotePaymentMethodManagementV1SetPutBody } from '../model/quotePaymentMethodManagementV1SetPutBody';
import { QuotePaymentMethodManagementV1SetPutBody1 } from '../model/quotePaymentMethodManagementV1SetPutBody1';
import { Configuration } from '../configuration';
export declare class QuotePaymentMethodManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    quotePaymentMethodManagementV1GetGet(cartId: number, observe?: 'body', reportProgress?: boolean): Observable<QuoteDataPaymentInterface>;
    quotePaymentMethodManagementV1GetGet(cartId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataPaymentInterface>>;
    quotePaymentMethodManagementV1GetGet(cartId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataPaymentInterface>>;
    quotePaymentMethodManagementV1GetGet_1(observe?: 'body', reportProgress?: boolean): Observable<QuoteDataPaymentInterface>;
    quotePaymentMethodManagementV1GetGet_1(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<QuoteDataPaymentInterface>>;
    quotePaymentMethodManagementV1GetGet_1(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<QuoteDataPaymentInterface>>;
    quotePaymentMethodManagementV1GetListGet(cartId: number, observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataPaymentMethodInterface>>;
    quotePaymentMethodManagementV1GetListGet(cartId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataPaymentMethodInterface>>>;
    quotePaymentMethodManagementV1GetListGet(cartId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataPaymentMethodInterface>>>;
    quotePaymentMethodManagementV1GetListGet_2(observe?: 'body', reportProgress?: boolean): Observable<Array<QuoteDataPaymentMethodInterface>>;
    quotePaymentMethodManagementV1GetListGet_2(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<QuoteDataPaymentMethodInterface>>>;
    quotePaymentMethodManagementV1GetListGet_2(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<QuoteDataPaymentMethodInterface>>>;
    quotePaymentMethodManagementV1SetPut(cartId: number, quotePaymentMethodManagementV1SetPutBody?: QuotePaymentMethodManagementV1SetPutBody, observe?: 'body', reportProgress?: boolean): Observable<string>;
    quotePaymentMethodManagementV1SetPut(cartId: number, quotePaymentMethodManagementV1SetPutBody?: QuotePaymentMethodManagementV1SetPutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    quotePaymentMethodManagementV1SetPut(cartId: number, quotePaymentMethodManagementV1SetPutBody?: QuotePaymentMethodManagementV1SetPutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    quotePaymentMethodManagementV1SetPut_3(quotePaymentMethodManagementV1SetPutBody?: QuotePaymentMethodManagementV1SetPutBody1, observe?: 'body', reportProgress?: boolean): Observable<string>;
    quotePaymentMethodManagementV1SetPut_3(quotePaymentMethodManagementV1SetPutBody?: QuotePaymentMethodManagementV1SetPutBody1, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    quotePaymentMethodManagementV1SetPut_3(quotePaymentMethodManagementV1SetPutBody?: QuotePaymentMethodManagementV1SetPutBody1, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
}
