import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { SalesDataInvoiceInterface } from '../model/salesDataInvoiceInterface';
import { SalesDataInvoiceSearchResultInterface } from '../model/salesDataInvoiceSearchResultInterface';
import { SalesInvoiceRepositoryV1SavePostBody } from '../model/salesInvoiceRepositoryV1SavePostBody';
import { Configuration } from '../configuration';
export declare class SalesInvoiceRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    salesInvoiceRepositoryV1GetGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataInvoiceInterface>;
    salesInvoiceRepositoryV1GetGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataInvoiceInterface>>;
    salesInvoiceRepositoryV1GetGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataInvoiceInterface>>;
    salesInvoiceRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataInvoiceSearchResultInterface>;
    salesInvoiceRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataInvoiceSearchResultInterface>>;
    salesInvoiceRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataInvoiceSearchResultInterface>>;
    salesInvoiceRepositoryV1SavePost(salesInvoiceRepositoryV1SavePostBody?: SalesInvoiceRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<SalesDataInvoiceInterface>;
    salesInvoiceRepositoryV1SavePost(salesInvoiceRepositoryV1SavePostBody?: SalesInvoiceRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataInvoiceInterface>>;
    salesInvoiceRepositoryV1SavePost(salesInvoiceRepositoryV1SavePostBody?: SalesInvoiceRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataInvoiceInterface>>;
}
