import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { SalesDataOrderStatusHistorySearchResultInterface } from '../model/salesDataOrderStatusHistorySearchResultInterface';
import { SalesOrderManagementV1AddCommentPostBody } from '../model/salesOrderManagementV1AddCommentPostBody';
import { Configuration } from '../configuration';
export declare class SalesOrderManagementV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    salesOrderManagementV1AddCommentPost(id: number, salesOrderManagementV1AddCommentPostBody?: SalesOrderManagementV1AddCommentPostBody, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    salesOrderManagementV1AddCommentPost(id: number, salesOrderManagementV1AddCommentPostBody?: SalesOrderManagementV1AddCommentPostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    salesOrderManagementV1AddCommentPost(id: number, salesOrderManagementV1AddCommentPostBody?: SalesOrderManagementV1AddCommentPostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    salesOrderManagementV1CancelPost(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    salesOrderManagementV1CancelPost(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    salesOrderManagementV1CancelPost(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    salesOrderManagementV1GetCommentsListGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataOrderStatusHistorySearchResultInterface>;
    salesOrderManagementV1GetCommentsListGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataOrderStatusHistorySearchResultInterface>>;
    salesOrderManagementV1GetCommentsListGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataOrderStatusHistorySearchResultInterface>>;
    salesOrderManagementV1GetStatusGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<string>;
    salesOrderManagementV1GetStatusGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    salesOrderManagementV1GetStatusGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    salesOrderManagementV1HoldPost(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    salesOrderManagementV1HoldPost(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    salesOrderManagementV1HoldPost(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    salesOrderManagementV1NotifyPost(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    salesOrderManagementV1NotifyPost(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    salesOrderManagementV1NotifyPost(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    salesOrderManagementV1UnHoldPost(id: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    salesOrderManagementV1UnHoldPost(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    salesOrderManagementV1UnHoldPost(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
}
