import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { SalesDataOrderInterface } from '../model/salesDataOrderInterface';
import { SalesDataOrderSearchResultInterface } from '../model/salesDataOrderSearchResultInterface';
import { SalesOrderRepositoryV1SavePostBody } from '../model/salesOrderRepositoryV1SavePostBody';
import { SalesOrderRepositoryV1SavePutBody } from '../model/salesOrderRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class SalesOrderRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    salesOrderRepositoryV1GetGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataOrderInterface>;
    salesOrderRepositoryV1GetGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataOrderInterface>>;
    salesOrderRepositoryV1GetGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataOrderInterface>>;
    salesOrderRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataOrderSearchResultInterface>;
    salesOrderRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataOrderSearchResultInterface>>;
    salesOrderRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataOrderSearchResultInterface>>;
    salesOrderRepositoryV1SavePost(salesOrderRepositoryV1SavePostBody?: SalesOrderRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<SalesDataOrderInterface>;
    salesOrderRepositoryV1SavePost(salesOrderRepositoryV1SavePostBody?: SalesOrderRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataOrderInterface>>;
    salesOrderRepositoryV1SavePost(salesOrderRepositoryV1SavePostBody?: SalesOrderRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataOrderInterface>>;
    salesOrderRepositoryV1SavePut(salesOrderRepositoryV1SavePutBody?: SalesOrderRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<SalesDataOrderInterface>;
    salesOrderRepositoryV1SavePut(salesOrderRepositoryV1SavePutBody?: SalesOrderRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataOrderInterface>>;
    salesOrderRepositoryV1SavePut(salesOrderRepositoryV1SavePutBody?: SalesOrderRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataOrderInterface>>;
}
