import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { SalesRuleCouponRepositoryV1SavePostBody } from '../model/salesRuleCouponRepositoryV1SavePostBody';
import { SalesRuleCouponRepositoryV1SavePutBody } from '../model/salesRuleCouponRepositoryV1SavePutBody';
import { SalesRuleDataCouponInterface } from '../model/salesRuleDataCouponInterface';
import { SalesRuleDataCouponSearchResultInterface } from '../model/salesRuleDataCouponSearchResultInterface';
import { Configuration } from '../configuration';
export declare class SalesRuleCouponRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    salesRuleCouponRepositoryV1DeleteByIdDelete(couponId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    salesRuleCouponRepositoryV1DeleteByIdDelete(couponId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    salesRuleCouponRepositoryV1DeleteByIdDelete(couponId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    salesRuleCouponRepositoryV1GetByIdGet(couponId: number, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataCouponInterface>;
    salesRuleCouponRepositoryV1GetByIdGet(couponId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataCouponInterface>>;
    salesRuleCouponRepositoryV1GetByIdGet(couponId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataCouponInterface>>;
    salesRuleCouponRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataCouponSearchResultInterface>;
    salesRuleCouponRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataCouponSearchResultInterface>>;
    salesRuleCouponRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataCouponSearchResultInterface>>;
    salesRuleCouponRepositoryV1SavePost(salesRuleCouponRepositoryV1SavePostBody?: SalesRuleCouponRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataCouponInterface>;
    salesRuleCouponRepositoryV1SavePost(salesRuleCouponRepositoryV1SavePostBody?: SalesRuleCouponRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataCouponInterface>>;
    salesRuleCouponRepositoryV1SavePost(salesRuleCouponRepositoryV1SavePostBody?: SalesRuleCouponRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataCouponInterface>>;
    salesRuleCouponRepositoryV1SavePut(couponId: string, salesRuleCouponRepositoryV1SavePutBody?: SalesRuleCouponRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataCouponInterface>;
    salesRuleCouponRepositoryV1SavePut(couponId: string, salesRuleCouponRepositoryV1SavePutBody?: SalesRuleCouponRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataCouponInterface>>;
    salesRuleCouponRepositoryV1SavePut(couponId: string, salesRuleCouponRepositoryV1SavePutBody?: SalesRuleCouponRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataCouponInterface>>;
}
