import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { SalesRuleDataRuleInterface } from '../model/salesRuleDataRuleInterface';
import { SalesRuleDataRuleSearchResultInterface } from '../model/salesRuleDataRuleSearchResultInterface';
import { SalesRuleRuleRepositoryV1SavePostBody } from '../model/salesRuleRuleRepositoryV1SavePostBody';
import { SalesRuleRuleRepositoryV1SavePutBody } from '../model/salesRuleRuleRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class SalesRuleRuleRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    salesRuleRuleRepositoryV1DeleteByIdDelete(ruleId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    salesRuleRuleRepositoryV1DeleteByIdDelete(ruleId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    salesRuleRuleRepositoryV1DeleteByIdDelete(ruleId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    salesRuleRuleRepositoryV1GetByIdGet(ruleId: number, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataRuleInterface>;
    salesRuleRuleRepositoryV1GetByIdGet(ruleId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataRuleInterface>>;
    salesRuleRuleRepositoryV1GetByIdGet(ruleId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataRuleInterface>>;
    salesRuleRuleRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataRuleSearchResultInterface>;
    salesRuleRuleRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataRuleSearchResultInterface>>;
    salesRuleRuleRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataRuleSearchResultInterface>>;
    salesRuleRuleRepositoryV1SavePost(salesRuleRuleRepositoryV1SavePostBody?: SalesRuleRuleRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataRuleInterface>;
    salesRuleRuleRepositoryV1SavePost(salesRuleRuleRepositoryV1SavePostBody?: SalesRuleRuleRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataRuleInterface>>;
    salesRuleRuleRepositoryV1SavePost(salesRuleRuleRepositoryV1SavePostBody?: SalesRuleRuleRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataRuleInterface>>;
    salesRuleRuleRepositoryV1SavePut(ruleId: string, salesRuleRuleRepositoryV1SavePutBody?: SalesRuleRuleRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<SalesRuleDataRuleInterface>;
    salesRuleRuleRepositoryV1SavePut(ruleId: string, salesRuleRuleRepositoryV1SavePutBody?: SalesRuleRuleRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesRuleDataRuleInterface>>;
    salesRuleRuleRepositoryV1SavePut(ruleId: string, salesRuleRuleRepositoryV1SavePutBody?: SalesRuleRuleRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesRuleDataRuleInterface>>;
}
