import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { SalesDataShipmentInterface } from '../model/salesDataShipmentInterface';
import { SalesDataShipmentSearchResultInterface } from '../model/salesDataShipmentSearchResultInterface';
import { SalesShipmentRepositoryV1SavePostBody } from '../model/salesShipmentRepositoryV1SavePostBody';
import { Configuration } from '../configuration';
export declare class SalesShipmentRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    salesShipmentRepositoryV1GetGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataShipmentInterface>;
    salesShipmentRepositoryV1GetGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataShipmentInterface>>;
    salesShipmentRepositoryV1GetGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataShipmentInterface>>;
    salesShipmentRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataShipmentSearchResultInterface>;
    salesShipmentRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataShipmentSearchResultInterface>>;
    salesShipmentRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataShipmentSearchResultInterface>>;
    salesShipmentRepositoryV1SavePost(salesShipmentRepositoryV1SavePostBody?: SalesShipmentRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<SalesDataShipmentInterface>;
    salesShipmentRepositoryV1SavePost(salesShipmentRepositoryV1SavePostBody?: SalesShipmentRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataShipmentInterface>>;
    salesShipmentRepositoryV1SavePost(salesShipmentRepositoryV1SavePostBody?: SalesShipmentRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataShipmentInterface>>;
}
