import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { SalesDataTransactionInterface } from '../model/salesDataTransactionInterface';
import { SalesDataTransactionSearchResultInterface } from '../model/salesDataTransactionSearchResultInterface';
import { Configuration } from '../configuration';
export declare class SalesTransactionRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    salesTransactionRepositoryV1GetGet(id: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataTransactionInterface>;
    salesTransactionRepositoryV1GetGet(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataTransactionInterface>>;
    salesTransactionRepositoryV1GetGet(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataTransactionInterface>>;
    salesTransactionRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<SalesDataTransactionSearchResultInterface>;
    salesTransactionRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<SalesDataTransactionSearchResultInterface>>;
    salesTransactionRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<SalesDataTransactionSearchResultInterface>>;
}
