import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { TaxDataTaxClassInterface } from '../model/taxDataTaxClassInterface';
import { TaxDataTaxClassSearchResultsInterface } from '../model/taxDataTaxClassSearchResultsInterface';
import { TaxTaxClassRepositoryV1SavePostBody } from '../model/taxTaxClassRepositoryV1SavePostBody';
import { TaxTaxClassRepositoryV1SavePutBody } from '../model/taxTaxClassRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class TaxTaxClassRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    taxTaxClassRepositoryV1DeleteByIdDelete(taxClassId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    taxTaxClassRepositoryV1DeleteByIdDelete(taxClassId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    taxTaxClassRepositoryV1DeleteByIdDelete(taxClassId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    taxTaxClassRepositoryV1GetGet(taxClassId: number, observe?: 'body', reportProgress?: boolean): Observable<TaxDataTaxClassInterface>;
    taxTaxClassRepositoryV1GetGet(taxClassId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TaxDataTaxClassInterface>>;
    taxTaxClassRepositoryV1GetGet(taxClassId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TaxDataTaxClassInterface>>;
    taxTaxClassRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<TaxDataTaxClassSearchResultsInterface>;
    taxTaxClassRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TaxDataTaxClassSearchResultsInterface>>;
    taxTaxClassRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TaxDataTaxClassSearchResultsInterface>>;
    taxTaxClassRepositoryV1SavePost(taxTaxClassRepositoryV1SavePostBody?: TaxTaxClassRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<string>;
    taxTaxClassRepositoryV1SavePost(taxTaxClassRepositoryV1SavePostBody?: TaxTaxClassRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    taxTaxClassRepositoryV1SavePost(taxTaxClassRepositoryV1SavePostBody?: TaxTaxClassRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
    taxTaxClassRepositoryV1SavePut(classId: string, taxTaxClassRepositoryV1SavePutBody?: TaxTaxClassRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<string>;
    taxTaxClassRepositoryV1SavePut(classId: string, taxTaxClassRepositoryV1SavePutBody?: TaxTaxClassRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<string>>;
    taxTaxClassRepositoryV1SavePut(classId: string, taxTaxClassRepositoryV1SavePutBody?: TaxTaxClassRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<string>>;
}
