import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { TaxDataTaxRateInterface } from '../model/taxDataTaxRateInterface';
import { TaxDataTaxRateSearchResultsInterface } from '../model/taxDataTaxRateSearchResultsInterface';
import { TaxTaxRateRepositoryV1SavePostBody } from '../model/taxTaxRateRepositoryV1SavePostBody';
import { TaxTaxRateRepositoryV1SavePutBody } from '../model/taxTaxRateRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class TaxTaxRateRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    taxTaxRateRepositoryV1DeleteByIdDelete(rateId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    taxTaxRateRepositoryV1DeleteByIdDelete(rateId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    taxTaxRateRepositoryV1DeleteByIdDelete(rateId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    taxTaxRateRepositoryV1GetGet(rateId: number, observe?: 'body', reportProgress?: boolean): Observable<TaxDataTaxRateInterface>;
    taxTaxRateRepositoryV1GetGet(rateId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TaxDataTaxRateInterface>>;
    taxTaxRateRepositoryV1GetGet(rateId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TaxDataTaxRateInterface>>;
    taxTaxRateRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<TaxDataTaxRateSearchResultsInterface>;
    taxTaxRateRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TaxDataTaxRateSearchResultsInterface>>;
    taxTaxRateRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TaxDataTaxRateSearchResultsInterface>>;
    taxTaxRateRepositoryV1SavePost(taxTaxRateRepositoryV1SavePostBody?: TaxTaxRateRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<TaxDataTaxRateInterface>;
    taxTaxRateRepositoryV1SavePost(taxTaxRateRepositoryV1SavePostBody?: TaxTaxRateRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TaxDataTaxRateInterface>>;
    taxTaxRateRepositoryV1SavePost(taxTaxRateRepositoryV1SavePostBody?: TaxTaxRateRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TaxDataTaxRateInterface>>;
    taxTaxRateRepositoryV1SavePut(taxTaxRateRepositoryV1SavePutBody?: TaxTaxRateRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<TaxDataTaxRateInterface>;
    taxTaxRateRepositoryV1SavePut(taxTaxRateRepositoryV1SavePutBody?: TaxTaxRateRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TaxDataTaxRateInterface>>;
    taxTaxRateRepositoryV1SavePut(taxTaxRateRepositoryV1SavePutBody?: TaxTaxRateRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TaxDataTaxRateInterface>>;
}
