import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { TaxDataTaxRuleInterface } from '../model/taxDataTaxRuleInterface';
import { TaxDataTaxRuleSearchResultsInterface } from '../model/taxDataTaxRuleSearchResultsInterface';
import { TaxTaxRuleRepositoryV1SavePostBody } from '../model/taxTaxRuleRepositoryV1SavePostBody';
import { TaxTaxRuleRepositoryV1SavePutBody } from '../model/taxTaxRuleRepositoryV1SavePutBody';
import { Configuration } from '../configuration';
export declare class TaxTaxRuleRepositoryV1Service {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private canConsumeForm;
    taxTaxRuleRepositoryV1DeleteByIdDelete(ruleId: number, observe?: 'body', reportProgress?: boolean): Observable<boolean>;
    taxTaxRuleRepositoryV1DeleteByIdDelete(ruleId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<boolean>>;
    taxTaxRuleRepositoryV1DeleteByIdDelete(ruleId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<boolean>>;
    taxTaxRuleRepositoryV1GetGet(ruleId: number, observe?: 'body', reportProgress?: boolean): Observable<TaxDataTaxRuleInterface>;
    taxTaxRuleRepositoryV1GetGet(ruleId: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TaxDataTaxRuleInterface>>;
    taxTaxRuleRepositoryV1GetGet(ruleId: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TaxDataTaxRuleInterface>>;
    taxTaxRuleRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'body', reportProgress?: boolean): Observable<TaxDataTaxRuleSearchResultsInterface>;
    taxTaxRuleRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TaxDataTaxRuleSearchResultsInterface>>;
    taxTaxRuleRepositoryV1GetListGet(searchCriteriaFilterGroupsFiltersField?: string, searchCriteriaFilterGroupsFiltersValue?: string, searchCriteriaFilterGroupsFiltersConditionType?: string, searchCriteriaSortOrdersField?: string, searchCriteriaSortOrdersDirection?: string, searchCriteriaPageSize?: number, searchCriteriaCurrentPage?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TaxDataTaxRuleSearchResultsInterface>>;
    taxTaxRuleRepositoryV1SavePost(taxTaxRuleRepositoryV1SavePostBody?: TaxTaxRuleRepositoryV1SavePostBody, observe?: 'body', reportProgress?: boolean): Observable<TaxDataTaxRuleInterface>;
    taxTaxRuleRepositoryV1SavePost(taxTaxRuleRepositoryV1SavePostBody?: TaxTaxRuleRepositoryV1SavePostBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TaxDataTaxRuleInterface>>;
    taxTaxRuleRepositoryV1SavePost(taxTaxRuleRepositoryV1SavePostBody?: TaxTaxRuleRepositoryV1SavePostBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TaxDataTaxRuleInterface>>;
    taxTaxRuleRepositoryV1SavePut(taxTaxRuleRepositoryV1SavePutBody?: TaxTaxRuleRepositoryV1SavePutBody, observe?: 'body', reportProgress?: boolean): Observable<TaxDataTaxRuleInterface>;
    taxTaxRuleRepositoryV1SavePut(taxTaxRuleRepositoryV1SavePutBody?: TaxTaxRuleRepositoryV1SavePutBody, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TaxDataTaxRuleInterface>>;
    taxTaxRuleRepositoryV1SavePut(taxTaxRuleRepositoryV1SavePutBody?: TaxTaxRuleRepositoryV1SavePutBody, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TaxDataTaxRuleInterface>>;
}
