import { SalesDataOrderAddressInterface } from './salesDataOrderAddressInterface';
import { SalesDataOrderExtensionInterface } from './salesDataOrderExtensionInterface';
import { SalesDataOrderItemInterface } from './salesDataOrderItemInterface';
import { SalesDataOrderPaymentInterface } from './salesDataOrderPaymentInterface';
import { SalesDataOrderStatusHistoryInterface } from './salesDataOrderStatusHistoryInterface';
export interface SalesDataOrderInterface {
    adjustmentNegative?: number;
    adjustmentPositive?: number;
    appliedRuleIds?: string;
    baseAdjustmentNegative?: number;
    baseAdjustmentPositive?: number;
    baseCurrencyCode?: string;
    baseDiscountAmount?: number;
    baseDiscountCanceled?: number;
    baseDiscountInvoiced?: number;
    baseDiscountRefunded?: number;
    baseGrandTotal: number;
    baseDiscountTaxCompensationAmount?: number;
    baseDiscountTaxCompensationInvoiced?: number;
    baseDiscountTaxCompensationRefunded?: number;
    baseShippingAmount?: number;
    baseShippingCanceled?: number;
    baseShippingDiscountAmount?: number;
    baseShippingDiscountTaxCompensationAmnt?: number;
    baseShippingInclTax?: number;
    baseShippingInvoiced?: number;
    baseShippingRefunded?: number;
    baseShippingTaxAmount?: number;
    baseShippingTaxRefunded?: number;
    baseSubtotal?: number;
    baseSubtotalCanceled?: number;
    baseSubtotalInclTax?: number;
    baseSubtotalInvoiced?: number;
    baseSubtotalRefunded?: number;
    baseTaxAmount?: number;
    baseTaxCanceled?: number;
    baseTaxInvoiced?: number;
    baseTaxRefunded?: number;
    baseTotalCanceled?: number;
    baseTotalDue?: number;
    baseTotalInvoiced?: number;
    baseTotalInvoicedCost?: number;
    baseTotalOfflineRefunded?: number;
    baseTotalOnlineRefunded?: number;
    baseTotalPaid?: number;
    baseTotalQtyOrdered?: number;
    baseTotalRefunded?: number;
    baseToGlobalRate?: number;
    baseToOrderRate?: number;
    billingAddressId?: number;
    canShipPartially?: number;
    canShipPartiallyItem?: number;
    couponCode?: string;
    createdAt?: string;
    customerDob?: string;
    customerEmail: string;
    customerFirstname?: string;
    customerGender?: number;
    customerGroupId?: number;
    customerId?: number;
    customerIsGuest?: number;
    customerLastname?: string;
    customerMiddlename?: string;
    customerNote?: string;
    customerNoteNotify?: number;
    customerPrefix?: string;
    customerSuffix?: string;
    customerTaxvat?: string;
    discountAmount?: number;
    discountCanceled?: number;
    discountDescription?: string;
    discountInvoiced?: number;
    discountRefunded?: number;
    editIncrement?: number;
    emailSent?: number;
    entityId?: number;
    extCustomerId?: string;
    extOrderId?: string;
    forcedShipmentWithInvoice?: number;
    globalCurrencyCode?: string;
    grandTotal: number;
    discountTaxCompensationAmount?: number;
    discountTaxCompensationInvoiced?: number;
    discountTaxCompensationRefunded?: number;
    holdBeforeState?: string;
    holdBeforeStatus?: string;
    incrementId?: string;
    isVirtual?: number;
    orderCurrencyCode?: string;
    originalIncrementId?: string;
    paymentAuthorizationAmount?: number;
    paymentAuthExpiration?: number;
    protectCode?: string;
    quoteAddressId?: number;
    quoteId?: number;
    relationChildId?: string;
    relationChildRealId?: string;
    relationParentId?: string;
    relationParentRealId?: string;
    remoteIp?: string;
    shippingAmount?: number;
    shippingCanceled?: number;
    shippingDescription?: string;
    shippingDiscountAmount?: number;
    shippingDiscountTaxCompensationAmount?: number;
    shippingInclTax?: number;
    shippingInvoiced?: number;
    shippingRefunded?: number;
    shippingTaxAmount?: number;
    shippingTaxRefunded?: number;
    state?: string;
    status?: string;
    storeCurrencyCode?: string;
    storeId?: number;
    storeName?: string;
    storeToBaseRate?: number;
    storeToOrderRate?: number;
    subtotal?: number;
    subtotalCanceled?: number;
    subtotalInclTax?: number;
    subtotalInvoiced?: number;
    subtotalRefunded?: number;
    taxAmount?: number;
    taxCanceled?: number;
    taxInvoiced?: number;
    taxRefunded?: number;
    totalCanceled?: number;
    totalDue?: number;
    totalInvoiced?: number;
    totalItemCount?: number;
    totalOfflineRefunded?: number;
    totalOnlineRefunded?: number;
    totalPaid?: number;
    totalQtyOrdered?: number;
    totalRefunded?: number;
    updatedAt?: string;
    weight?: number;
    xForwardedFor?: string;
    items: Array<SalesDataOrderItemInterface>;
    billingAddress?: SalesDataOrderAddressInterface;
    payment?: SalesDataOrderPaymentInterface;
    statusHistories?: Array<SalesDataOrderStatusHistoryInterface>;
    extensionAttributes?: SalesDataOrderExtensionInterface;
}
