/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { SalesDataCreditmemoCommentInterface } from './salesDataCreditmemoCommentInterface';
import { SalesDataCreditmemoExtensionInterface } from './salesDataCreditmemoExtensionInterface';
import { SalesDataCreditmemoItemInterface } from './salesDataCreditmemoItemInterface';


/**
 * Credit memo interface. After a customer places and pays for an order and an invoice has been issued, the merchant can create a credit memo to refund all or part of the amount paid for any returned or undelivered items. The memo restores funds to the customer account so that the customer can make future purchases.
 */
export interface SalesDataCreditmemoInterface {
    /**
     * Credit memo adjustment.
     */
    adjustment?: number;
    /**
     * Credit memo negative adjustment.
     */
    adjustmentNegative?: number;
    /**
     * Credit memo positive adjustment.
     */
    adjustmentPositive?: number;
    /**
     * Credit memo base adjustment.
     */
    baseAdjustment?: number;
    /**
     * Credit memo negative base adjustment.
     */
    baseAdjustmentNegative?: number;
    /**
     * Credit memo positive base adjustment.
     */
    baseAdjustmentPositive?: number;
    /**
     * Credit memo base currency code.
     */
    baseCurrencyCode?: string;
    /**
     * Credit memo base discount amount.
     */
    baseDiscountAmount?: number;
    /**
     * Credit memo base grand total.
     */
    baseGrandTotal?: number;
    /**
     * Credit memo base discount tax compensation amount.
     */
    baseDiscountTaxCompensationAmount?: number;
    /**
     * Credit memo base shipping amount.
     */
    baseShippingAmount?: number;
    /**
     * Credit memo base shipping discount tax compensation amount.
     */
    baseShippingDiscountTaxCompensationAmnt?: number;
    /**
     * Credit memo base shipping including tax.
     */
    baseShippingInclTax?: number;
    /**
     * Credit memo base shipping tax amount.
     */
    baseShippingTaxAmount?: number;
    /**
     * Credit memo base subtotal.
     */
    baseSubtotal?: number;
    /**
     * Credit memo base subtotal including tax.
     */
    baseSubtotalInclTax?: number;
    /**
     * Credit memo base tax amount.
     */
    baseTaxAmount?: number;
    /**
     * Credit memo base-to-global rate.
     */
    baseToGlobalRate?: number;
    /**
     * Credit memo base-to-order rate.
     */
    baseToOrderRate?: number;
    /**
     * Credit memo billing address ID.
     */
    billingAddressId?: number;
    /**
     * Credit memo created-at timestamp.
     */
    createdAt?: string;
    /**
     * Credit memo status.
     */
    creditmemoStatus?: number;
    /**
     * Credit memo discount amount.
     */
    discountAmount?: number;
    /**
     * Credit memo discount description.
     */
    discountDescription?: string;
    /**
     * Credit memo email sent flag value.
     */
    emailSent?: number;
    /**
     * Credit memo ID.
     */
    entityId?: number;
    /**
     * Credit memo global currency code.
     */
    globalCurrencyCode?: string;
    /**
     * Credit memo grand total.
     */
    grandTotal?: number;
    /**
     * Credit memo discount tax compensation amount.
     */
    discountTaxCompensationAmount?: number;
    /**
     * Credit memo increment ID.
     */
    incrementId?: string;
    /**
     * Credit memo invoice ID.
     */
    invoiceId?: number;
    /**
     * Credit memo order currency code.
     */
    orderCurrencyCode?: string;
    /**
     * Credit memo order ID.
     */
    orderId: number;
    /**
     * Credit memo shipping address ID.
     */
    shippingAddressId?: number;
    /**
     * Credit memo shipping amount.
     */
    shippingAmount?: number;
    /**
     * Credit memo shipping discount tax compensation amount.
     */
    shippingDiscountTaxCompensationAmount?: number;
    /**
     * Credit memo shipping including tax.
     */
    shippingInclTax?: number;
    /**
     * Credit memo shipping tax amount.
     */
    shippingTaxAmount?: number;
    /**
     * Credit memo state.
     */
    state?: number;
    /**
     * Credit memo store currency code.
     */
    storeCurrencyCode?: string;
    /**
     * Credit memo store ID.
     */
    storeId?: number;
    /**
     * Credit memo store-to-base rate.
     */
    storeToBaseRate?: number;
    /**
     * Credit memo store-to-order rate.
     */
    storeToOrderRate?: number;
    /**
     * Credit memo subtotal.
     */
    subtotal?: number;
    /**
     * Credit memo subtotal including tax.
     */
    subtotalInclTax?: number;
    /**
     * Credit memo tax amount.
     */
    taxAmount?: number;
    /**
     * Credit memo transaction ID.
     */
    transactionId?: string;
    /**
     * Credit memo updated-at timestamp.
     */
    updatedAt?: string;
    /**
     * Array of credit memo items.
     */
    items: Array<SalesDataCreditmemoItemInterface>;
    /**
     * Array of any credit memo comments. Otherwise, null.
     */
    comments?: Array<SalesDataCreditmemoCommentInterface>;
    extensionAttributes?: SalesDataCreditmemoExtensionInterface;
}
