/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { SalesDataCreditmemoItemExtensionInterface } from './salesDataCreditmemoItemExtensionInterface';


/**
 * Credit memo item interface. After a customer places and pays for an order and an invoice has been issued, the merchant can create a credit memo to refund all or part of the amount paid for any returned or undelivered items. The memo restores funds to the customer account so that the customer can make future purchases. A credit memo item is an invoiced item for which a merchant creates a credit memo.
 */
export interface SalesDataCreditmemoItemInterface {
    /**
     * Additional data.
     */
    additionalData?: string;
    /**
     * The base cost for a credit memo item.
     */
    baseCost: number;
    /**
     * The base discount amount for a credit memo item.
     */
    baseDiscountAmount?: number;
    /**
     * The base discount tax compensation amount for a credit memo item.
     */
    baseDiscountTaxCompensationAmount?: number;
    /**
     * The base price for a credit memo item.
     */
    basePrice: number;
    /**
     * Base price including tax.
     */
    basePriceInclTax?: number;
    /**
     * Base row total.
     */
    baseRowTotal?: number;
    /**
     * Base row total including tax.
     */
    baseRowTotalInclTax?: number;
    /**
     * Base tax amount.
     */
    baseTaxAmount?: number;
    /**
     * Base WEEE tax applied amount.
     */
    baseWeeeTaxAppliedAmount?: number;
    /**
     * Base WEEE tax applied row amount.
     */
    baseWeeeTaxAppliedRowAmnt?: number;
    /**
     * Base WEEE tax disposition.
     */
    baseWeeeTaxDisposition?: number;
    /**
     * Base WEEE tax row disposition.
     */
    baseWeeeTaxRowDisposition?: number;
    /**
     * Description.
     */
    description?: string;
    /**
     * Discount amount.
     */
    discountAmount?: number;
    /**
     * Credit memo item ID.
     */
    entityId: number;
    /**
     * Discount tax compensation amount.
     */
    discountTaxCompensationAmount?: number;
    /**
     * Name.
     */
    name?: string;
    /**
     * Order item ID.
     */
    orderItemId: number;
    /**
     * Parent ID.
     */
    parentId?: number;
    /**
     * Price.
     */
    price?: number;
    /**
     * Price including tax.
     */
    priceInclTax?: number;
    /**
     * Product ID.
     */
    productId?: number;
    /**
     * Quantity.
     */
    qty: number;
    /**
     * Row total.
     */
    rowTotal?: number;
    /**
     * Row total including tax.
     */
    rowTotalInclTax?: number;
    /**
     * SKU.
     */
    sku?: string;
    /**
     * Tax amount.
     */
    taxAmount?: number;
    /**
     * WEEE tax applied.
     */
    weeeTaxApplied?: string;
    /**
     * WEEE tax applied amount.
     */
    weeeTaxAppliedAmount?: number;
    /**
     * WEEE tax applied row amount.
     */
    weeeTaxAppliedRowAmount?: number;
    /**
     * WEEE tax disposition.
     */
    weeeTaxDisposition?: number;
    /**
     * WEEE tax row disposition.
     */
    weeeTaxRowDisposition?: number;
    extensionAttributes?: SalesDataCreditmemoItemExtensionInterface;
}
