/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { SalesDataOrderAddressInterface } from './salesDataOrderAddressInterface';
import { SalesDataOrderExtensionInterface } from './salesDataOrderExtensionInterface';
import { SalesDataOrderItemInterface } from './salesDataOrderItemInterface';
import { SalesDataOrderPaymentInterface } from './salesDataOrderPaymentInterface';
import { SalesDataOrderStatusHistoryInterface } from './salesDataOrderStatusHistoryInterface';


/**
 * Order interface. An order is a document that a web store issues to a customer. Magento generates a sales order that lists the product items, billing and shipping addresses, and shipping and payment methods. A corresponding external document, known as a purchase order, is emailed to the customer.
 */
export interface SalesDataOrderInterface {
    /**
     * Negative adjustment value.
     */
    adjustmentNegative?: number;
    /**
     * Positive adjustment value.
     */
    adjustmentPositive?: number;
    /**
     * Applied rule IDs.
     */
    appliedRuleIds?: string;
    /**
     * Base negative adjustment value.
     */
    baseAdjustmentNegative?: number;
    /**
     * Base positive adjustment value.
     */
    baseAdjustmentPositive?: number;
    /**
     * Base currency code.
     */
    baseCurrencyCode?: string;
    /**
     * Base discount amount.
     */
    baseDiscountAmount?: number;
    /**
     * Base discount canceled.
     */
    baseDiscountCanceled?: number;
    /**
     * Base discount invoiced.
     */
    baseDiscountInvoiced?: number;
    /**
     * Base discount refunded.
     */
    baseDiscountRefunded?: number;
    /**
     * Base grand total.
     */
    baseGrandTotal: number;
    /**
     * Base discount tax compensation amount.
     */
    baseDiscountTaxCompensationAmount?: number;
    /**
     * Base discount tax compensation invoiced.
     */
    baseDiscountTaxCompensationInvoiced?: number;
    /**
     * Base discount tax compensation refunded.
     */
    baseDiscountTaxCompensationRefunded?: number;
    /**
     * Base shipping amount.
     */
    baseShippingAmount?: number;
    /**
     * Base shipping canceled.
     */
    baseShippingCanceled?: number;
    /**
     * Base shipping discount amount.
     */
    baseShippingDiscountAmount?: number;
    /**
     * Base shipping discount tax compensation amount.
     */
    baseShippingDiscountTaxCompensationAmnt?: number;
    /**
     * Base shipping including tax.
     */
    baseShippingInclTax?: number;
    /**
     * Base shipping invoiced.
     */
    baseShippingInvoiced?: number;
    /**
     * Base shipping refunded.
     */
    baseShippingRefunded?: number;
    /**
     * Base shipping tax amount.
     */
    baseShippingTaxAmount?: number;
    /**
     * Base shipping tax refunded.
     */
    baseShippingTaxRefunded?: number;
    /**
     * Base subtotal.
     */
    baseSubtotal?: number;
    /**
     * Base subtotal canceled.
     */
    baseSubtotalCanceled?: number;
    /**
     * Base subtotal including tax.
     */
    baseSubtotalInclTax?: number;
    /**
     * Base subtotal invoiced.
     */
    baseSubtotalInvoiced?: number;
    /**
     * Base subtotal refunded.
     */
    baseSubtotalRefunded?: number;
    /**
     * Base tax amount.
     */
    baseTaxAmount?: number;
    /**
     * Base tax canceled.
     */
    baseTaxCanceled?: number;
    /**
     * Base tax invoiced.
     */
    baseTaxInvoiced?: number;
    /**
     * Base tax refunded.
     */
    baseTaxRefunded?: number;
    /**
     * Base total canceled.
     */
    baseTotalCanceled?: number;
    /**
     * Base total due.
     */
    baseTotalDue?: number;
    /**
     * Base total invoiced.
     */
    baseTotalInvoiced?: number;
    /**
     * Base total invoiced cost.
     */
    baseTotalInvoicedCost?: number;
    /**
     * Base total offline refunded.
     */
    baseTotalOfflineRefunded?: number;
    /**
     * Base total online refunded.
     */
    baseTotalOnlineRefunded?: number;
    /**
     * Base total paid.
     */
    baseTotalPaid?: number;
    /**
     * Base total quantity ordered.
     */
    baseTotalQtyOrdered?: number;
    /**
     * Base total refunded.
     */
    baseTotalRefunded?: number;
    /**
     * Base-to-global rate.
     */
    baseToGlobalRate?: number;
    /**
     * Base-to-order rate.
     */
    baseToOrderRate?: number;
    /**
     * Billing address ID.
     */
    billingAddressId?: number;
    /**
     * Can-ship-partially flag value.
     */
    canShipPartially?: number;
    /**
     * Can-ship-partially-item flag value.
     */
    canShipPartiallyItem?: number;
    /**
     * Coupon code.
     */
    couponCode?: string;
    /**
     * Created-at timestamp.
     */
    createdAt?: string;
    /**
     * Customer date-of-birth (DOB).
     */
    customerDob?: string;
    /**
     * Customer email address.
     */
    customerEmail: string;
    /**
     * Customer first name.
     */
    customerFirstname?: string;
    /**
     * Customer gender.
     */
    customerGender?: number;
    /**
     * Customer group ID.
     */
    customerGroupId?: number;
    /**
     * Customer ID.
     */
    customerId?: number;
    /**
     * Customer-is-guest flag value.
     */
    customerIsGuest?: number;
    /**
     * Customer last name.
     */
    customerLastname?: string;
    /**
     * Customer middle name.
     */
    customerMiddlename?: string;
    /**
     * Customer note.
     */
    customerNote?: string;
    /**
     * Customer-note-notify flag value.
     */
    customerNoteNotify?: number;
    /**
     * Customer prefix.
     */
    customerPrefix?: string;
    /**
     * Customer suffix.
     */
    customerSuffix?: string;
    /**
     * Customer value-added tax (VAT).
     */
    customerTaxvat?: string;
    /**
     * Discount amount.
     */
    discountAmount?: number;
    /**
     * Discount canceled.
     */
    discountCanceled?: number;
    /**
     * Discount description.
     */
    discountDescription?: string;
    /**
     * Discount invoiced.
     */
    discountInvoiced?: number;
    /**
     * Discount refunded amount.
     */
    discountRefunded?: number;
    /**
     * Edit increment value.
     */
    editIncrement?: number;
    /**
     * Email-sent flag value.
     */
    emailSent?: number;
    /**
     * Order ID.
     */
    entityId?: number;
    /**
     * External customer ID.
     */
    extCustomerId?: string;
    /**
     * External order ID.
     */
    extOrderId?: string;
    /**
     * Forced-shipment-with-invoice flag value.
     */
    forcedShipmentWithInvoice?: number;
    /**
     * Global currency code.
     */
    globalCurrencyCode?: string;
    /**
     * Grand total.
     */
    grandTotal: number;
    /**
     * Discount tax compensation amount.
     */
    discountTaxCompensationAmount?: number;
    /**
     * Discount tax compensation invoiced amount.
     */
    discountTaxCompensationInvoiced?: number;
    /**
     * Discount tax compensation refunded amount.
     */
    discountTaxCompensationRefunded?: number;
    /**
     * Hold before state.
     */
    holdBeforeState?: string;
    /**
     * Hold before status.
     */
    holdBeforeStatus?: string;
    /**
     * Increment ID.
     */
    incrementId?: string;
    /**
     * Is-virtual flag value.
     */
    isVirtual?: number;
    /**
     * Order currency code.
     */
    orderCurrencyCode?: string;
    /**
     * Original increment ID.
     */
    originalIncrementId?: string;
    /**
     * Payment authorization amount.
     */
    paymentAuthorizationAmount?: number;
    /**
     * Payment authorization expiration date.
     */
    paymentAuthExpiration?: number;
    /**
     * Protect code.
     */
    protectCode?: string;
    /**
     * Quote address ID.
     */
    quoteAddressId?: number;
    /**
     * Quote ID.
     */
    quoteId?: number;
    /**
     * Relation child ID.
     */
    relationChildId?: string;
    /**
     * Relation child real ID.
     */
    relationChildRealId?: string;
    /**
     * Relation parent ID.
     */
    relationParentId?: string;
    /**
     * Relation parent real ID.
     */
    relationParentRealId?: string;
    /**
     * Remote IP address.
     */
    remoteIp?: string;
    /**
     * Shipping amount.
     */
    shippingAmount?: number;
    /**
     * Shipping canceled amount.
     */
    shippingCanceled?: number;
    /**
     * Shipping description.
     */
    shippingDescription?: string;
    /**
     * Shipping discount amount.
     */
    shippingDiscountAmount?: number;
    /**
     * Shipping discount tax compensation amount.
     */
    shippingDiscountTaxCompensationAmount?: number;
    /**
     * Shipping including tax amount.
     */
    shippingInclTax?: number;
    /**
     * Shipping invoiced amount.
     */
    shippingInvoiced?: number;
    /**
     * Shipping refunded amount.
     */
    shippingRefunded?: number;
    /**
     * Shipping tax amount.
     */
    shippingTaxAmount?: number;
    /**
     * Shipping tax refunded amount.
     */
    shippingTaxRefunded?: number;
    /**
     * State.
     */
    state?: string;
    /**
     * Status.
     */
    status?: string;
    /**
     * Store currency code.
     */
    storeCurrencyCode?: string;
    /**
     * Store ID.
     */
    storeId?: number;
    /**
     * Store name.
     */
    storeName?: string;
    /**
     * Store-to-base rate.
     */
    storeToBaseRate?: number;
    /**
     * Store-to-order rate.
     */
    storeToOrderRate?: number;
    /**
     * Subtotal.
     */
    subtotal?: number;
    /**
     * Subtotal canceled amount.
     */
    subtotalCanceled?: number;
    /**
     * Subtotal including tax amount.
     */
    subtotalInclTax?: number;
    /**
     * Subtotal invoiced amount.
     */
    subtotalInvoiced?: number;
    /**
     * Subtotal refunded amount.
     */
    subtotalRefunded?: number;
    /**
     * Tax amount.
     */
    taxAmount?: number;
    /**
     * Tax canceled amount.
     */
    taxCanceled?: number;
    /**
     * Tax invoiced amount.
     */
    taxInvoiced?: number;
    /**
     * Tax refunded amount.
     */
    taxRefunded?: number;
    /**
     * Total canceled.
     */
    totalCanceled?: number;
    /**
     * Total due.
     */
    totalDue?: number;
    /**
     * Total invoiced amount.
     */
    totalInvoiced?: number;
    /**
     * Total item count.
     */
    totalItemCount?: number;
    /**
     * Total offline refunded amount.
     */
    totalOfflineRefunded?: number;
    /**
     * Total online refunded amount.
     */
    totalOnlineRefunded?: number;
    /**
     * Total paid.
     */
    totalPaid?: number;
    /**
     * Total quantity ordered.
     */
    totalQtyOrdered?: number;
    /**
     * Total amount refunded.
     */
    totalRefunded?: number;
    /**
     * Updated-at timestamp.
     */
    updatedAt?: string;
    /**
     * Weight.
     */
    weight?: number;
    /**
     * X-Forwarded-For field value.
     */
    xForwardedFor?: string;
    /**
     * Array of items.
     */
    items: Array<SalesDataOrderItemInterface>;
    billingAddress?: SalesDataOrderAddressInterface;
    payment?: SalesDataOrderPaymentInterface;
    /**
     * Array of status histories.
     */
    statusHistories?: Array<SalesDataOrderStatusHistoryInterface>;
    extensionAttributes?: SalesDataOrderExtensionInterface;
}
