/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { CatalogDataProductOptionInterface } from './catalogDataProductOptionInterface';
import { SalesDataOrderItemExtensionInterface } from './salesDataOrderItemExtensionInterface';


/**
 * Order item interface. An order is a document that a web store issues to a customer. Magento generates a sales order that lists the product items, billing and shipping addresses, and shipping and payment methods. A corresponding external document, known as a purchase order, is emailed to the customer.
 */
export interface SalesDataOrderItemInterface {
    /**
     * Additional data.
     */
    additionalData?: string;
    /**
     * Amount refunded.
     */
    amountRefunded?: number;
    /**
     * Applied rule IDs.
     */
    appliedRuleIds?: string;
    /**
     * Base amount refunded.
     */
    baseAmountRefunded?: number;
    /**
     * Base cost.
     */
    baseCost?: number;
    /**
     * Base discount amount.
     */
    baseDiscountAmount?: number;
    /**
     * Base discount invoiced.
     */
    baseDiscountInvoiced?: number;
    /**
     * Base discount refunded.
     */
    baseDiscountRefunded?: number;
    /**
     * Base discount tax compensation amount.
     */
    baseDiscountTaxCompensationAmount?: number;
    /**
     * Base discount tax compensation invoiced.
     */
    baseDiscountTaxCompensationInvoiced?: number;
    /**
     * Base discount tax compensation refunded.
     */
    baseDiscountTaxCompensationRefunded?: number;
    /**
     * Base original price.
     */
    baseOriginalPrice?: number;
    /**
     * Base price.
     */
    basePrice?: number;
    /**
     * Base price including tax.
     */
    basePriceInclTax?: number;
    /**
     * Base row invoiced.
     */
    baseRowInvoiced?: number;
    /**
     * Base row total.
     */
    baseRowTotal?: number;
    /**
     * Base row total including tax.
     */
    baseRowTotalInclTax?: number;
    /**
     * Base tax amount.
     */
    baseTaxAmount?: number;
    /**
     * Base tax before discount.
     */
    baseTaxBeforeDiscount?: number;
    /**
     * Base tax invoiced.
     */
    baseTaxInvoiced?: number;
    /**
     * Base tax refunded.
     */
    baseTaxRefunded?: number;
    /**
     * Base WEEE tax applied amount.
     */
    baseWeeeTaxAppliedAmount?: number;
    /**
     * Base WEEE tax applied row amount.
     */
    baseWeeeTaxAppliedRowAmnt?: number;
    /**
     * Base WEEE tax disposition.
     */
    baseWeeeTaxDisposition?: number;
    /**
     * Base WEEE tax row disposition.
     */
    baseWeeeTaxRowDisposition?: number;
    /**
     * Created-at timestamp.
     */
    createdAt?: string;
    /**
     * Description.
     */
    description?: string;
    /**
     * Discount amount.
     */
    discountAmount?: number;
    /**
     * Discount invoiced.
     */
    discountInvoiced?: number;
    /**
     * Discount percent.
     */
    discountPercent?: number;
    /**
     * Discount refunded.
     */
    discountRefunded?: number;
    /**
     * Event ID.
     */
    eventId?: number;
    /**
     * External order item ID.
     */
    extOrderItemId?: string;
    /**
     * Free-shipping flag value.
     */
    freeShipping?: number;
    /**
     * GW base price.
     */
    gwBasePrice?: number;
    /**
     * GW base price invoiced.
     */
    gwBasePriceInvoiced?: number;
    /**
     * GW base price refunded.
     */
    gwBasePriceRefunded?: number;
    /**
     * GW base tax amount.
     */
    gwBaseTaxAmount?: number;
    /**
     * GW base tax amount invoiced.
     */
    gwBaseTaxAmountInvoiced?: number;
    /**
     * GW base tax amount refunded.
     */
    gwBaseTaxAmountRefunded?: number;
    /**
     * GW ID.
     */
    gwId?: number;
    /**
     * GW price.
     */
    gwPrice?: number;
    /**
     * GW price invoiced.
     */
    gwPriceInvoiced?: number;
    /**
     * GW price refunded.
     */
    gwPriceRefunded?: number;
    /**
     * GW tax amount.
     */
    gwTaxAmount?: number;
    /**
     * GW tax amount invoiced.
     */
    gwTaxAmountInvoiced?: number;
    /**
     * GW tax amount refunded.
     */
    gwTaxAmountRefunded?: number;
    /**
     * Discount tax compensation amount.
     */
    discountTaxCompensationAmount?: number;
    /**
     * Discount tax compensation canceled.
     */
    discountTaxCompensationCanceled?: number;
    /**
     * Discount tax compensation invoiced.
     */
    discountTaxCompensationInvoiced?: number;
    /**
     * Discount tax compensation refunded.
     */
    discountTaxCompensationRefunded?: number;
    /**
     * Is-quantity-decimal flag value.
     */
    isQtyDecimal?: number;
    /**
     * Is-virtual flag value.
     */
    isVirtual?: number;
    /**
     * Item ID.
     */
    itemId?: number;
    /**
     * Locked DO invoice flag value.
     */
    lockedDoInvoice?: number;
    /**
     * Locked DO ship flag value.
     */
    lockedDoShip?: number;
    /**
     * Name.
     */
    name?: string;
    /**
     * No-discount flag value.
     */
    noDiscount?: number;
    /**
     * Order ID.
     */
    orderId?: number;
    /**
     * Original price.
     */
    originalPrice?: number;
    /**
     * Parent item ID.
     */
    parentItemId?: number;
    /**
     * Price.
     */
    price?: number;
    /**
     * Price including tax.
     */
    priceInclTax?: number;
    /**
     * Product ID.
     */
    productId?: number;
    /**
     * Product type.
     */
    productType?: string;
    /**
     * Quantity backordered.
     */
    qtyBackordered?: number;
    /**
     * Quantity canceled.
     */
    qtyCanceled?: number;
    /**
     * Quantity invoiced.
     */
    qtyInvoiced?: number;
    /**
     * Quantity ordered.
     */
    qtyOrdered?: number;
    /**
     * Quantity refunded.
     */
    qtyRefunded?: number;
    /**
     * Quantity returned.
     */
    qtyReturned?: number;
    /**
     * Quantity shipped.
     */
    qtyShipped?: number;
    /**
     * Quote item ID.
     */
    quoteItemId?: number;
    /**
     * Row invoiced.
     */
    rowInvoiced?: number;
    /**
     * Row total.
     */
    rowTotal?: number;
    /**
     * Row total including tax.
     */
    rowTotalInclTax?: number;
    /**
     * Row weight.
     */
    rowWeight?: number;
    /**
     * SKU.
     */
    sku: string;
    /**
     * Store ID.
     */
    storeId?: number;
    /**
     * Tax amount.
     */
    taxAmount?: number;
    /**
     * Tax before discount.
     */
    taxBeforeDiscount?: number;
    /**
     * Tax canceled.
     */
    taxCanceled?: number;
    /**
     * Tax invoiced.
     */
    taxInvoiced?: number;
    /**
     * Tax percent.
     */
    taxPercent?: number;
    /**
     * Tax refunded.
     */
    taxRefunded?: number;
    /**
     * Updated-at timestamp.
     */
    updatedAt?: string;
    /**
     * WEEE tax applied.
     */
    weeeTaxApplied?: string;
    /**
     * WEEE tax applied amount.
     */
    weeeTaxAppliedAmount?: number;
    /**
     * WEEE tax applied row amount.
     */
    weeeTaxAppliedRowAmount?: number;
    /**
     * WEEE tax disposition.
     */
    weeeTaxDisposition?: number;
    /**
     * WEEE tax row disposition.
     */
    weeeTaxRowDisposition?: number;
    /**
     * Weight.
     */
    weight?: number;
    parentItem?: SalesDataOrderItemInterface;
    productOption?: CatalogDataProductOptionInterface;
    extensionAttributes?: SalesDataOrderItemExtensionInterface;
}
