/**
 * Magento Community
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { SalesDataOrderPaymentExtensionInterface } from './salesDataOrderPaymentExtensionInterface';


/**
 * Order payment interface. An order is a document that a web store issues to a customer. Magento generates a sales order that lists the product items, billing and shipping addresses, and shipping and payment methods. A corresponding external document, known as a purchase order, is emailed to the customer.
 */
export interface SalesDataOrderPaymentInterface {
    /**
     * Account status.
     */
    accountStatus: string;
    /**
     * Additional data.
     */
    additionalData?: string;
    /**
     * Array of additional information.
     */
    additionalInformation: Array<string>;
    /**
     * Address status.
     */
    addressStatus?: string;
    /**
     * Amount authorized.
     */
    amountAuthorized?: number;
    /**
     * Amount canceled.
     */
    amountCanceled?: number;
    /**
     * Amount ordered.
     */
    amountOrdered?: number;
    /**
     * Amount paid.
     */
    amountPaid?: number;
    /**
     * Amount refunded.
     */
    amountRefunded?: number;
    /**
     * Anet transaction method.
     */
    anetTransMethod?: string;
    /**
     * Base amount authorized.
     */
    baseAmountAuthorized?: number;
    /**
     * Base amount canceled.
     */
    baseAmountCanceled?: number;
    /**
     * Base amount ordered.
     */
    baseAmountOrdered?: number;
    /**
     * Base amount paid.
     */
    baseAmountPaid?: number;
    /**
     * Base amount paid online.
     */
    baseAmountPaidOnline?: number;
    /**
     * Base amount refunded.
     */
    baseAmountRefunded?: number;
    /**
     * Base amount refunded online.
     */
    baseAmountRefundedOnline?: number;
    /**
     * Base shipping amount.
     */
    baseShippingAmount?: number;
    /**
     * Base shipping captured amount.
     */
    baseShippingCaptured?: number;
    /**
     * Base shipping refunded amount.
     */
    baseShippingRefunded?: number;
    /**
     * Credit card approval.
     */
    ccApproval?: string;
    /**
     * Credit card avs status.
     */
    ccAvsStatus?: string;
    /**
     * Credit card CID status.
     */
    ccCidStatus?: string;
    /**
     * Credit card debug request body.
     */
    ccDebugRequestBody?: string;
    /**
     * Credit card debug response body.
     */
    ccDebugResponseBody?: string;
    /**
     * Credit card debug response serialized.
     */
    ccDebugResponseSerialized?: string;
    /**
     * Credit card expiration month.
     */
    ccExpMonth?: string;
    /**
     * Credit card expiration year.
     */
    ccExpYear?: string;
    /**
     * Last four digits of the credit card.
     */
    ccLast4: string;
    /**
     * Encrypted credit card number.
     */
    ccNumberEnc?: string;
    /**
     * Credit card number.
     */
    ccOwner?: string;
    /**
     * Credit card secure verify.
     */
    ccSecureVerify?: string;
    /**
     * Credit card SS issue.
     */
    ccSsIssue?: string;
    /**
     * Credit card SS start month.
     */
    ccSsStartMonth?: string;
    /**
     * Credit card SS start year.
     */
    ccSsStartYear?: string;
    /**
     * Credit card status.
     */
    ccStatus?: string;
    /**
     * Credit card status description.
     */
    ccStatusDescription?: string;
    /**
     * Credit card transaction ID.
     */
    ccTransId?: string;
    /**
     * Credit card type.
     */
    ccType?: string;
    /**
     * eCheck account name.
     */
    echeckAccountName?: string;
    /**
     * eCheck account type.
     */
    echeckAccountType?: string;
    /**
     * eCheck bank name.
     */
    echeckBankName?: string;
    /**
     * eCheck routing number.
     */
    echeckRoutingNumber?: string;
    /**
     * eCheck type.
     */
    echeckType?: string;
    /**
     * Entity ID.
     */
    entityId?: number;
    /**
     * Last transaction ID.
     */
    lastTransId?: string;
    /**
     * Method.
     */
    method: string;
    /**
     * Parent ID.
     */
    parentId?: number;
    /**
     * PO number.
     */
    poNumber?: string;
    /**
     * Protection eligibility.
     */
    protectionEligibility?: string;
    /**
     * Quote payment ID.
     */
    quotePaymentId?: number;
    /**
     * Shipping amount.
     */
    shippingAmount?: number;
    /**
     * Shipping captured.
     */
    shippingCaptured?: number;
    /**
     * Shipping refunded.
     */
    shippingRefunded?: number;
    extensionAttributes?: SalesDataOrderPaymentExtensionInterface;
}
